;----------------------------------------Commands

;----------------------------------------Misc - Commands


;Command: 2ddraw
Function com_2ddraw()
	Local value#=parse_getpar_num()
	If value#=-111.111 Then
		op_2ddraw=1-op_2ddraw
	Else
		If Int(value#)<0 Then value#=0
		If Int(value#)>1 Then value#=1
		op_2ddraw=Int(value#)
	EndIf
	con_add("set '2ddraw' = '"+op_2ddraw+"'")
End Function


;----------------------------------------(A) - Commands

;Command: Alias
Function com_alias()
	con_add("Sorry, Counter-Strike 2D supports no aliases ;(",0,1)
End Function

;Command: AntiAlias
Function com_antialias()
	Local value#=parse_getpar_num()
	If value#=-111.111 Then
		op_antialias=1-op_antialias
	Else
		If Int(value#)<0 Then value#=0
		If Int(value#)>1 Then value#=1
		op_antialias=Int(value#)
	EndIf
	AntiAlias op_antialias
	con_add("set 'antialias' = '"+op_antialias+"'")
End Function

;Command: Attack
Function com_attack()
	player_attack(e_player)
End Function

;Command: Attack2
Function com_attack2()
	player_attack2(e_player)
End Function

;----------------------------------------(B) - Commands

;Command: Back
Function com_back()
	If e_ymoved=1 Then Return 0
	e_ymoved=1
	If player_move(e_player,-180,2.0*spfak#,op_bind_walk,op_movement)=-1 Then
		If sp25go And hud_spec_mode=0 Then e_y=e_y+1
	EndIf
End Function

;Command: BanID
Function com_banid()
	;Server?
	If e_player<>e_server Then
		con_add("Error: No server. Can't ban players!",0,1)
		Return 0
	Else
		;Parameter einlesen
		Local banid$,banip,banname$,banned
		banid=parse_getpar_str()
		;Selfban?
		If banid$=e_server Then
			con_add("Error: I think it isn't a good idea to ban yourself ;)",0,1)
			Return 0
		EndIf
		;Player mit ID suchen
		For player.player=Each player
			If player\id=banid$ Then
				banip=player\ip
				banname$=player\name$
				If player\gameadmin=1 Then con_add("Error: This player is a game admin! You can't ban him!",0,1):Return 0
				Exit
			EndIf
		Next
		;Player mit Nick suchen
		If banip=0 Or banname$="" Then
			For player.player=Each player
				If player\name$=banid$ Then
					banip=player\ip
					banname$=player\name$
					If player\gameadmin=1 Then con_add("Error: This player is a game admin! You can't ban him!",0,1):Return 0
					Exit
				EndIf
			Next
		EndIf
		;Gefunden?
		If banip=0 Or banname$="" Then
			con_add("Error: Player does not exist or is a bot!",0,1)
			Return 0
		Else
			For sv_ban.sv_ban=Each sv_ban
				If sv_ban\ip=banip Then banned=1:Exit
			Next
			If banned Then
				con_add("Error: This player is already banned!",0,1)
				Return 0
			Else
				sv_ban.sv_ban=New sv_ban
				sv_ban\ip=banip
				con_add("Banned #"+banid+" ("+banname$+", "+DottedIP(banip)+")!",0,1)
				Return 1
			EndIf
		EndIf
	EndIf
End Function

;Command: Bind
Function com_bind()
	Local key$,bind$,txt$,set
	txt$=Mid(par_txt$,par_os,-1)
	split(txt$,Chr(34),3)
	key$=splits$(1)
	bind$=splits$(3)
	set=0
	For op_bind.op_bind=Each op_bind
		If op_bind\bind$=bind$ Then
			op_bind\key=key_c(key$)
			set=1
			Exit
		EndIf
	Next
	If set=0 Then
		op_bind.op_bind = New op_bind
		If bind$="speed" Or bind$="strafe" Then Insert op_bind Before First op_bind
		op_bind\bind$=bind$
		op_bind\key=key_c(key$)
	EndIf
	op_bind\down=1
	Select bind$
		Case "showscores" 
		Case "forward","back","left","right","speed"
		Case "attack"
		Case "speed","strafe"
		Case "use"
		Default op_bind\down=0
	End Select
End Function

;Command: Binds
Function com_binds()
	For op_bind.op_bind=Each op_bind
		con_add(op_bind\bind$,0,1)
	Next
End Function

;Command: Blood
Function com_blood()
	Local value=parse_getpar_num()
	If value<0 Then value=0
	If value>6 Then value=6
	op_blood=value
	con_add("set 'blood' = '"+value+"'")
End Function

;Command: Bot
Function com_bot()
	If e_bot<>0 Then
		hud_men_set(20)
	Else
		hud_m_add("Bots are not available at Net Games")
	EndIf
End Function

;Command: Buy
Function com_buy()
	hud_men_set(10)
End Function

;Command: Buyammo
Function com_buyammo(mode)
	Select mode
		Case 1 player_buy(e_player,61,1)
		Case 2 player_buy(e_player,62,1)
	End Select
End Function

;Command: Buyequip
Function com_buyequip()
	hud_men_set(16)
End Function

;----------------------------------------(C) - Commands

;Command: CatchCursor
Function com_catchcursor()
	Local value=parse_getpar_num()
	If value<0 Then value=0
	If value>100 Then value=100
	op_catchcursor=value
	If op_catchcursor=0 Then
		con_add("set 'catchcursor' = 'off'")
	ElseIf op_catchcursor=1 Then
		con_add("set 'catchcursor' = '1 pixel'")
	Else
		con_add("set 'catchcursor' = '"+value+" pixels'")
	EndIf
	If cmd_win<>2 Then
		con_add("Warning: catch cursor function works only in windowed mode!",0,1)
	EndIf
End Function

;Command: Chooseteam
Function com_chooseteam()
	hud_men_set(1)
End Function

;Command: Clear
Function com_clear()
	Local i
	For i=0 To 100
		con_txt$(i)=""
	Next
End Function

;Command: Close
Function com_close()
	con_mode=2
End Function

;Command: Connect
Function com_connect()
	Local joinstr$=parse_getpar_str()
	Local pw$=parse_getpar_str()
	e_cls()
	udp_join(0,0,pw$,joinstr$)
End Function


;----------------------------------------(D) - Commands

;Command: Debug
Function com_debug()
	Local value#=parse_getpar_num()
	If value#=-111.111 Then
		op_debug=1-op_debug
	Else
		If Int(value#)<0 Then value#=0
		If Int(value#)>1 Then value#=1
		op_debug=Int(value#)
	EndIf
	con_add("set 'debug' = '"+op_debug+"'")
End Function

;Command: Debugbot
Function com_debugbot()
	Local value#=parse_getpar_num()
	If value#=-111.111 Then
		op_debug_bots=1-op_debug_bots
	Else
		If Int(value#)<0 Then value#=0
		If Int(value#)>1 Then value#=1
		op_debug_bots=Int(value#)
	EndIf
	con_add("set 'debugbot' = '"+op_debug_bots+"'")
End Function

;Command: Debuglog
Function com_debuglog()
	Local value#=parse_getpar_num()
	If value#=-111.111 Then
		op_debug_log=1-op_debug_log
	Else
		If Int(value#)<0 Then value#=0
		If Int(value#)>1 Then value#=1
		op_debug_log=Int(value#)
	EndIf
	con_add("set 'debuglog' = '"+op_debug_log+"'")
End Function

;Command: DrawRadar
Function com_drawradar()
	If hud_radar<>0 Then ShowEntity hud_radar
	hud_radar_on=1
End Function

;Command: Drop
Function com_drop()
	For player.player=Each player
		If player\id=e_player Then
			If player_drop(player\id,player\slot,player\sweapon[player\slot],player\sammo[player\slot],player\sammoin[player\slot],(Int(player\x)+16)/32,(Int(player\y)+16)/32,1) Then
				player_bestweapon(player\id, 1)
			EndIf
			Return 1
		EndIf
	Next
	Return 0
End Function

;----------------------------------------(E) - Commands

;Command: Echo
Function com_echo()
	con_add(parse_getpar_str(),0,1)
End Function

;Command: Entityinfo
Function com_entityinfo()
	con_add("",0,0)
	con_add("--- Entity Info ---",0,0)
	If map_name$="" Then con_add("No map loaded",0,0)
	count=0:For entity.entity=Each entity:count=count+1:Next
	con_add("Entities: "+count,0,0)
	count=0
	For entity.entity=Each entity
		count=count+1
		con_add("#"+count+" "+entity_name$(entity\typ)+" ("+entity\x+"|"+entity\y+")",0,1)
	Next
	con_add("",0,1)
End Function

;Command: exec
Function com_exec()
	Local file$
	Local stream
	Local in$
	file$=parse_getpar_str()
	If FileType(file$)=1 Then
		stream=ReadFile(file$)
		While Not Eof(stream)
			in$=ReadLine(stream)
			parse(in$)
		Wend
	EndIf
End Function

;Command: Exit
Function com_exit()
	If e_player=e_server And e_bot=0 Then
		tcp_killserver(DottedIP(e_sv_ip))
		player_leave(0,3,1)
	Else
		player_leave(e_player,0,1)
	EndIf
	e_shutdown()
End Function

;----------------------------------------(F) - Commands

;Command: Fixedport
Function com_fixedport()
	Local value=parse_getpar_num()
	If value<0 Then value=0
	If value>65535 Then value=65535
	op_fixedport=value
	con_add("set 'fixedport' = '"+value+"'")
End Function


;Command: Forward
Function com_forward()
	If e_ymoved=1 Then Return 0
	e_ymoved=1
	If player_move(e_player,0,2.0*spfak#,op_bind_walk,op_movement)=-1 Then
		If sp25go And hud_spec_mode=0 Then e_y=e_y-1
	EndIf
End Function

;----------------------------------------(G) - Commands

;Command: Game Admin
Function com_gameadmin()
	admin_reqcount=admin_reqcount+1
	Local pas$
	pas$=parse_getpar_str()
	If pas$=0 Then
		admin=0
		admin_ch=0
		con_add("Game Admin removed",0,1)
		For player.player=Each player
			If player\id=e_player Then
				player\gameadmin=0
				Exit
			EndIf
		Next
	Else
		tcp_gameadmin(pas$)
	EndIf
	;Senden
	For player.player=Each player
		If player\id=e_player Then
			For player2.player=Each player
				If player2\id<>e_player Then
					WriteByte(udp),94
					WriteByte(udp),player\id
					WriteLine(udp),player\name$
					WriteShort(udp),player\frags+32767
					WriteShort(udp),player\deads+32767
					WriteByte(udp),player\gameadmin
					SendUDPMsg(udp,player2\ip,player2\port)
				EndIf
			Next
			Exit
		EndIf
	Next
End Function

;Command: Get Servers
Function com_getservers()
	tcp_getserver()
End Function

;----------------------------------------(H) - Commands

;Command: HideRadar
Function com_hideradar()
	If hud_radar<>0 Then HideEntity hud_radar
	hud_radar_on=0
End Function

;Command: hud_fastswitch
Function com_hud_fastswitch()
	Local value#=parse_getpar_num()
	If value#=-111.111 Then
		op_fastswitch=1-op_fastswitch
	Else
		If Int(value#)<0 Then value#=0
		If Int(value#)>1 Then value#=1
		op_fastswitch=Int(value#)
	EndIf
	con_add("set 'hud_fastswitch' = '"+op_fastswitch+"'")
End Function

;Command: hud_hurt
Function com_hud_hurt()
	Local value#=parse_getpar_num()
	If value#=-111.111 Then
		op_hurt=1-op_hurt
	Else
		If Int(value#)<0 Then value#=0
		If Int(value#)>1 Then value#=1
		op_hurt=Int(value#)
	EndIf
	con_add("set 'hud_hurt' = '"+op_hurt+"'")
End Function


;----------------------------------------(i) - Commands

;Command: invnext
Function com_invnext()
	Local ph=0
	For player.player=Each player
		If player\id=e_player Then ph=1:Exit
	Next
	If Not ph Then Return 0
	Local changed=0
	Local limit=0
	If hud_slot=0 Then hud_slot=player\slot+1
	While Not changed
		hud_slot=hud_slot+1
		If player\sweapon[hud_slot-1]<>0 Then
			changed=1
			Exit
		EndIf
		If hud_slot>=14 Then hud_slot=0
		limit=limit+1
		If limit>20 Then
			hud_slot=player\slot+1
			Return 0
		EndIf
	Wend
	Return 1
End Function

;Command: invprev
Function com_invprev()
	Local ph=0
	For player.player=Each player
		If player\id=e_player Then ph=1:Exit
	Next
	If Not ph Then Return 0
	Local changed=0
	Local limit=0
	If hud_slot=0 Then hud_slot=player\slot+1
	While Not changed
		hud_slot=hud_slot-1
		If hud_slot>0 Then
			If player\sweapon[hud_slot-1]<>0 Then
				changed=1
				Exit
			EndIf
		EndIf
		If hud_slot<=1 Then hud_slot=14
		limit=limit+1
		If limit>20 Then
			hud_slot=player\slot+1
			Return 0
		EndIf
	Wend
	Return 1
End Function

;----------------------------------------(j) - Commands

;----------------------------------------(k) - Commands

;Command: Kick
Function com_kick()
	;Server?
	If e_player<>e_server Then
		con_add("Error: No server. Can't kick players!",0,1)
		Return 0
	Else
		;Parameter einlesen
		Local kickpar$,kickid=-1
		kickpar$=parse_getpar_str$()
		;Player nach Name suchen
		For player.player=Each player
			If player\name$=kickpar$ Then
				kickid=player\id
				If player\gameadmin=1 Then con_add("Error: This player is a game admin! You can't kick him!",0,1):Return 0
			EndIf
		Next
		;Player nach ID suchen
		If kickid=-1 Then
			For player.player=Each player
				If player\id=Int(kickpar$) Then
					kickid=player\id
				EndIf
			Next
		EndIf
		;Gefunden?
		If kickid=-1 Then
			con_add("Error: There is no player with Name/ID "+kickpar$+"!",0,1)
			Return 0
		Else
			;Selfkick?
			If kickid=e_server Then
				con_add("Error: I think it isn't a good idea to kick yourself ;)",0,1)
				Return 0
			Else
				player_leave(kickid,2,1)
			EndIf
		EndIf
	EndIf
End Function

;Command: Kill
Function com_kill()
	Local ph=0
	For player.player=Each player
		If player\id=e_player Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If player\health<1 Then Return 0
	player_kill(e_player, 202, 0, 1)
End Function

;----------------------------------------(L) - Commands

;Command: Lastinv
Function com_lastinv()
	For player.player = Each player
		If player\id=e_player Then
			If player\sweapon[e_lastusedslot]<>0 Then
				player_weapon(e_player, e_lastusedslot, player\sweapon[e_lastusedslot], 1)
			EndIf
			Exit
		EndIf
	Next
End Function

;Command: Left
Function com_left()
	If e_xmoved=1 Then Return 0
	e_xmoved=1
	If player_move(e_player,-90,2.0*spfak#,op_bind_walk,op_movement)=-1 Then
		If sp25go And hud_spec_mode=0 Then e_x=e_x-1
	EndIf
End Function

;Command: ListPlayers
Function com_listplayers()
	con_add("",0,0)
	con_add("--- Player List ---",0,0)
	Local tcpport
	For player.player = Each player
		If player\bot Then
			con_add(player\id+"# "+player\name+" (Bot)",0,0)
		Else
			If player\id=e_server Then
				con_add(player\id+"# "+player\name+" ("+DottedIP(player\ip)+":"+player\port+", Server)",0,0)
			Else
				con_add(player\id+"# "+player\name+" ("+DottedIP(player\ip)+":"+player\port+")",0,0)
			EndIf
		EndIf
	Next
	con_add("",0,1)
End Function

;----------------------------------------(M) - Commands

;Command: Map
Function com_map()
	FlushKeys()
	;Server?
	If e_player<>e_server Then
		con_add("Error: No server. Can't change the map!",0,1)
		Return 0
	Else
		;Parameter einlesen
		Local cache_map$
		cache_map$=parse_getpar_str$()
		cache_map$=Replace(cache_map$,".map","")
		
		;Existiert die Map?
		If FileType("maps/"+cache_map$+".map")<>1 Then
			con_add("Error: Can't find maps/"+cache_map$+".map!",0)
			Return 0
		EndIf
		
		;Mapchange senden, wenn Net Game
		If e_bot=0 Then
			For player.player=Each player
				If player\id<>e_player Then
					udp_iniimp(player\ip, player\port,20)
					udp_w_byte(106)
					udp_w_line(cache_map$)
					udp_sendimp()
				EndIf
			Next
		EndIf
		
		;Einstellungen Cachen
		Local cache_net
		Local cache_bots
		If e_bot=1 Then cache_net=0 Else cache_net=1
		If e_bot=1 Then cache_bots=7 Else cache_bots=0
		Local cache_maxpl=e_sv_maxplayers
		Local cache_name$=e_sv_name$
		Local cache_pw$=e_sv_pw$
		Local cache_lport
		If udp<>0 Then
			cache_lport=UDPStreamPort(udp)
		Else
			cache_lport="0"
		EndIf
		Local cache_fow=e_sv_fow
		Local cache_warmode=e_sv_warmode
		e_cls(0)
				
		;Neuen Server mit neuer Map initialisieren
		FlushKeys()
		If game_server_ini(cache_map$,cache_net,cache_bots,cache_maxpl,cache_name$,cache_pw$,cache_lport,0,cache_fow,cache_warmode) Then
			FlushKeys()
			e_ini()
			FlushKeys()
			leave=0
			hud_men_set(1)
			hud_say_mode=0
			Return 1
		Else
			e_cls()
			men_msg("Mapchange failed",2,0)
			leave=1
		EndIf
	EndIf
End Function

;Command: Mapinfo
Function com_mapinfo()
	If map_name$<>"" Then
		con_add("",0,0)
		con_add("--- Map Info ---",0,0)
		con_add("Name: "+map_name$,0,0)
		con_add("Mission: "+map_gametype+" (1=AS, 2=CS, 3=DE)")
		con_add("Size: "+map_xsize+"x"+map_ysize+" Tiles ("+(map_xsize*map_ysize)+")",0,0)
		con_add("Tileset: "+map_tileset$+" ("+map_tilesc+" Tiles)",0,0)
		
		Local count=0:For entity.entity=Each entity:count=count+1:Next
		con_add("Entities: "+count+" - entityinfo for details",0,0)
		
		count=0:For source.source=Each source:count=count+1:Next
		con_add("External Resources: "+count+" - resinfo for details",0,0)
		
		count=0:For pf_wp.pf_wp=Each pf_wp:count=count+1:Next
		con_add("Waypoints: "+count,0,0)
		
		count=0:For pf_link.pf_link=Each pf_link:count=count+1:Next
		con_add("Waypoint Links: "+count,0,0)
		
		con_add("",0,1)
	Else
		con_add("",0,0)
		con_add("--- Map Info ---",0,0)
		con_add("Error: No map loaded",0,0)
		con_add("",0,1)
	EndIf	
End Function

;Command: Maximize
Function com_maximize()
	con_y=480
End Function

;Command: Memorie
Function com_memory()
	con_add("",0,0)
	con_add("--- Memory Info ---",0,0)
	c=0:For player.player=Each player:c=c+1:Next:con_add("player: "+c,0,0)
	c=0:For udp_data_h.udp_data_h=Each udp_data_h:c=c+1:Next:con_add("udp_data_h: "+c,0,0)
	c=0:For udp_data.udp_data=Each udp_data:c=c+1:Next:con_add("udp_data: "+c,0,0)
	c=0:For udp_getblock.udp_getblock=Each udp_getblock:c=c+1:Next:con_add("udp_getblock: "+c,0,0)
	c=0:For sv_ban.sv_ban=Each sv_ban:c=c+1:Next:con_add("sv_ban: "+c,0,0)
	c=0:For pf_node.pf_node=Each pf_node:c=c+1:Next:con_add("pf_node: "+c,0,0)
	c=0:For pf_wp.pf_wp=Each pf_wp:c=c+1:Next:con_add("pf_wp: "+c,0,0)
	c=0:For pf_link.pf_link=Each pf_link:c=c+1:Next:con_add("pf_link: "+c,0,0)
	c=0:For hostage.hostage=Each hostage:c=c+1:Next:con_add("hostage: "+c,0,0)
	c=0:For grenade.grenade=Each grenade:c=c+1:Next:con_add("grenade: "+c,0,0)
	c=0:For item.item=Each item:c=c+1:Next:con_add("item: "+c,0,1)

End Function

;Command: mp_fraglimit
Function com_mp_fraglimit()
	If e_player=e_server Then
		Local value=parse_getpar_num()
		If value<0 Then value=0
		e_sv_fraglimit=value
		con_add("set 'mp_fraglimit' = '"+value+"'",0,1)
	Else
		con_add("Error: No server.",0,1)
	EndIf
End Function

;Command: mp_maxrounds
Function com_mp_maxrounds()
	If e_player=e_server Then
		Local value=parse_getpar_num()
		If value<0 Then value=0
		e_sv_maxrounds=value
		con_add("set 'mp_maxrounds' = '"+value+"'",0,1)
	Else
		con_add("Error: No server.",0,1)
	EndIf
End Function

;Command: mp_nextmap
Function com_mp_nextmap()
	If e_player=e_server Then
		stream=ReadFile("mapcycle.txt")
		If Not stream Then con_add("Error: Unable to load next map - mapcycle.txt does not exist!",0,1):Return 0
		i=0
		loadmap$=""
		While Not Eof(stream)
			in$=ReadLine(stream)
			in$=Trim(in$)
			If i=e_sv_mapcyclepos Then
				loadmap$=in$
				e_sv_mapcyclepos=e_sv_mapcyclepos+1
				Exit
			EndIf
			i=i+1
		Wend
		If loadmap$="" Then
			e_sv_mapcyclepos=1
			SeekFile(stream,0)
			in$=ReadLine(stream)
			in$=Trim(in$)
			loadmap$=in$
		EndIf
		CloseFile(stream)
		If loadmap$<>"" Then
			parse("map "+loadmap$)
		Else
			con_add("Error: Unable to load next map - mapcycle.txt seems to be empty!",0,1)
		EndIf
	Else
		con_add("Error: No server.",0,1)
	EndIf
End Function

;Command: mp_timelimit
Function com_mp_timelimit()
	If e_player=e_server Then
		Local value=parse_getpar_num()
		If value<0 Then value=0
		e_sv_timelimit=value
		con_add("set 'mp_timelimit' = '"+value+"'",0,1)
	Else
		con_add("Error: No server.",0,1)
	EndIf
End Function



;----------------------------------------(N) - Commands

;Command: Name
Function com_name()
	name$=parse_getpar_str()
	player_name(e_player,name$)
End Function

;Command Net_Graph
Function com_net_graph()
	Local value#=parse_getpar_num()
	If value#=-111.111 Then
		op_netgraph=1-op_netgraph
	Else
		If Int(value#)<0 Then value#=0
		If Int(value#)>1 Then value#=1
		op_netgraph=Int(value#)
	EndIf
End Function

;Command: Nightvision
Function com_nightvision()
	For player.player=Each player
		If player\id=e_player Then
			If player\health>0 Then
				If player\team>0 And player\team<3 Then
					If player\sweapon[9]<>0 Then
						Local param#=parse_getpar_num()
						;Toggle
						If param#=-111.111 Then
							hud_nv_mode=1-hud_nv_mode
							If hud_nv_mode=1 Then e_sound(sfx_w_nv,player\x,player\y)
						;0 - Off
						ElseIf Int(param#)=0 Then
							hud_nv_mode=0
						;1 - On
						ElseIf Int(param#)=1 Then
							hud_nv_mode=1
							e_sound(sfx_w_nv,player\x,player\y)
						EndIf
					EndIf
				EndIf
			EndIf
		EndIf
	Next
End Function

;----------------------------------------(O) - Commands

;----------------------------------------(P) - Commands

;Command: Particles
Function com_particles()
	Local value#=parse_getpar_num()
	If value#=-111.111 Then
		op_particles=1-op_particles
	Else
		If Int(value#)<0 Then value#=0
		If Int(value#)>1 Then value#=1
		op_particles=Int(value#)
	EndIf
	con_add("set 'particles' = '"+op_particles+"'",0,1)
End Function

;Command: Port
Function com_port()
	If udp=0 Then
		con_add("UDP Port: No active UDP Connection",0,1)
	Else
		con_add("UDP Port: "+UDPStreamPort(udp)+" (CON-ID: "+udp+")",0,1)
	EndIf
End Function

;----------------------------------------(Q) - Commands

;Command: Quit
Function com_quit()
	If e_player=e_server And e_bot=0 Then
		tcp_killserver(DottedIP(e_sv_ip))
		player_leave(0,3,1)
	Else
		player_leave(e_player,0,1)
	EndIf
	e_shutdown()
End Function

;----------------------------------------(R) - Commands

;Command: Radio
Function com_radio(radio)
	hud_men_set(29+radio)
End Function

;Command: Reload
Function com_reload()
	player_reload(e_player,1,1)
End Function

;Command: Resinfo
Function com_resinfo()
	Local typ$
	con_add("",0,0)
	con_add("--- Resource Info ---",0,0)
	If map_name$="" Then con_add("No map loaded",0,0)
	count=0:For source.source=Each source:count=count+1:Next
	con_add("External Resources: "+count,0,0)
	count=0
	For source.source=Each source
		count=count+1
		Select source\typ
			Case 0 typ$="Sound"
			Case 1 typ$="Sprite"
			Case 2 typ$="Image"
			Case 3 typ$="Text"
			Default typ$="Unknown"
		End Select
		con_add("#"+count+" "+source\file$+" ("+typ$+", "+source\mode+")",0,1)
	Next
	con_add("",0,1)
End Function

;Command: Right
Function com_right()
	If e_xmoved=1 Then Return 0
	e_xmoved=1
	If player_move(e_player,90,2.0*spfak#,op_bind_walk,op_movement)=-1 Then
		If sp25go And hud_spec_mode=0 Then e_x=e_x+1
	EndIf
End Function

;----------------------------------------(S) - Commands

;Command: Say
Function com_say()
	FlushKeys()
	txt$=parse_getpar_str()
	If txt$="" Then
		hud_say_mode=1
		hud_say_block=1
		hud_say_txt$=""
	Else
		player_say(e_player,txt$,1)
	EndIf
End Function

;Command: SayTeam
Function com_sayteam()
	FlushKeys()
	txt$=parse_getpar_str()
	If txt$="" Then
		hud_say_mode=2
		hud_say_block=1
		hud_say_txt$=""
	Else
		player_sayteam(e_player,txt$,1)
	EndIf
End Function

;Command: Setcon
Function com_setcon()
	txt$=parse_getpar_str()
	con_in$=txt$
End Function

;Command: Showscores
Function com_showscores()
	op_bind_scores=1
End Function

;Command: Slot
Function com_slot(slot)
	If hud_men<>0 Then
		;Men Auswahl
		hud_men_render(slot)
	Else
		;Waffen Auswahl
		hud_wpnsel(slot)
	EndIf
End Function

;Command: snapshot
Function com_snapshot()
	SaveBuffer(FrontBuffer(),"screenshots\"+map_name$+ms+".bmp")
End Function

;Command: specmode
Function com_specmode()
	hud_spec_mode=1-hud_spec_mode
End Function

;Command: specplayer
Function com_specplayer()
	For player.player=Each player
		If player\health>0 Then
			If player\team=1 Or player\team=2 Then
				If player\id>hud_spec_player Then
					hud_spec_player=player\id
					Return 1
				EndIf
			EndIf
		EndIf
	Next
	For player.player=Each player
		If player\health>0 Then
			If player\team=1 Or player\team=2 Then
				hud_spec_player=player\id
				Return 1
			EndIf
		EndIf
	Next	
End Function

;Command: Speed
Function com_speed()
	op_bind_walk=1
End Function

;Command: Spray
Function com_spray()
	player_spray(e_player)
End Function

;Command: sv_ff
Function com_sv_ff()
	If e_player=e_server Then
		Local value#=parse_getpar_num()
		If value#=-111.111 Then
			e_sv_ff=1-e_sv_ff
		Else
			If Int(value#)<0 Then value#=0
			If Int(value#)>1 Then value#=1
			e_sv_ff=Int(value#)
		EndIf
		con_add("set 'sv_ff' = '"+e_sv_ff+"'",0,1)
	Else
		con_add("Error: No server.",0,1)
	EndIf
End Function

;Command: sv_fow
Function com_sv_fow()
	If e_player=e_server Then
		Local value#=parse_getpar_num()
		If value#=-111.111 Then
			e_sv_fow=1-e_sv_fow
		Else
			If Int(value#)<0 Then value#=0
			If Int(value#)>1 Then value#=1
			e_sv_fow=Int(value#)
		EndIf
		con_add("set 'sv_fow' = '"+e_sv_fow+"'",0,1)
		game_sendsettings(2)
		ch_fow=e_sv_fow*ch_fak
		ch_fow2=e_sv_fow*ch_fak2
	Else
		con_add("Error: No server.",0,1)
	EndIf
End Function

;Command: sv_maxplayers
Function com_sv_maxplayers()
	If e_player=e_server Then
		Local value=parse_getpar_num()
		If value<1 Then value=1
		If value>32 Then value=32
		e_sv_maxplayers=value
		con_add("set 'sv_maxplayers' = '"+value+"'",0,1)
		game_sendsettings(1)
	Else
		con_add("Error: No server.",0,1)
	EndIf
End Function

;Command: sv_msg
Function com_sv_msg()
	If e_player=e_server Then
		msg$=parse_getpar_str()
		If Trim(msg$)<>""
			For player.player=Each player
				If player\id<>e_server Then
					udp_iniimp(player\ip,player\port)
					udp_w_byte(91)
					udp_w_byte(3)
					udp_w_byte(e_server)
					udp_w_line(msg$)
					udp_sendimp()
					udp_sendb(13)
				EndIf
			Next
			hud_ml_add("",0,"* "+msg$,1)
		EndIf
	Else
		con_add("Error: No server.",0,1)
	EndIf
End Function


;Command: sv_name
Function com_sv_name()
	If e_player=e_server Then
		name$=parse_getpar_str()
		If Len(name$)>0 And Len(name$)<=64 Then
			e_sv_name$=name$
			con_add("set 'sv_name' = '"+name$+"'",0,1)
			game_sendsettings(0)
		Else
			con_add("Error: Invalid Servername",0,1)
		EndIf
	Else
		con_add("Error: No server.",0,1)
	EndIf
End Function

;Command: sv_password
Function com_sv_password()
	If e_player=e_server Then
		password$=parse_getpar_str()
		e_sv_pw$=password$
		con_add("set 'sv_password' = '"+password$+"'",0,1)
	Else
		con_add("Error: No server.",0,1)
	EndIf
End Function

;Command: sv_remote
Function com_sv_remote()
	pw$=parse_getpar_str()
	code$=parse_getpar_str()
	par_osadd=2+Len(pw$)+Len(code$)
	If Len(code$)>0 Then
		For player.player=Each player
			If player\id = e_server Then
				udp_iniimp(player\ip,player\port)
				udp_w_byte(108)
				udp_w_line(pw$)
				udp_w_line(code$)
				udp_sendimp()
				Exit
			EndIf
		Next
		con_add("remote command(s) sended ("+pw$+", "+code$+")",0,1)
	EndIf
End Function

;Command: sv_remotepw
Function com_sv_remotepw()
	If e_player=e_server Then
		password$=parse_getpar_str()
		e_sv_remotepw$=password$
		con_add("set 'sv_remotepw' = '"+password$+"'",0,1)
	Else
		con_add("Error: No server.",0,1)
	EndIf
End Function

;Command: sv_restart
Function com_sv_restart()
	If e_player=e_server Then
		Local value#=parse_getpar_num()
		If value#=-111.111 Then
			game_startround(30,5000,1)
		Else
			If value#<5 Then value#=5
			If value#>15 Then value#=15
			game_startround(30,Int(value#)*1000,1)
		EndIf
	Else
		con_add("Error: No server.",0,1)
	EndIf
End Function

;Command: sv_warmode
Function com_sv_warmode()
	If e_player=e_server Then
		Local value#=parse_getpar_num()
		If value#=-111.111 Then
			e_sv_warmode=1-e_sv_warmode
		Else
			If Int(value#)<0 Then value#=0
			If Int(value#)>1 Then value#=1
			e_sv_warmode=Int(value#)
		EndIf
		con_add("set 'sv_warmode' = '"+e_sv_warmode+"'",0,1)
		game_sendsettings(3)
		ch_warmode=e_sv_warmode*ch_fak
	Else
		con_add("Error: No server.",0,1)
	EndIf
End Function



;----------------------------------------(T) - Commands

;----------------------------------------(U) - Commands

;Command: Unbanall
Function com_unbanall()
	For sv_ban.sv_ban=Each sv_ban
		Delete sv_ban
	Next
End Function

;Command: Unbindall
Function com_unbindall()
	For op_bind.op_bind = Each op_bind
		Delete op_bind
	Next
End Function

;Command: uprate
Function com_uprate()
	Local value=parse_getpar_num()
	If value<1 Then value=1
	If value>5 Then value=5
	op_udp_dirrate=value
	op_udp_moverate=value
	con_add("set 'uprate' = '"+value+"'")
End Function

;Command: use
Function com_use()
	player_use(e_player)
End Function

;Command: usgn_cancel
Function com_usgn_cancel()
	If e_sv_usgnupdate>0 Then
		con_add("canceled U.S.G.N. auto setup!")
		e_sv_usgnupdate=0
	EndIf
End Function

;Command: usgn_hideserver
Function com_usgn_hideserver()
	If e_player=e_server Then
		If tcp_killserver(DottedIP(e_sv_ip)) Then
			hud_m_add("U.S.G.N. - Server hidden")
			Return 1
		Else
			hud_m_add("U.S.G.N. - failed to hide Server")
			Return 0
		EndIf
	Else
		con_add("Error: No server. Can't hide U.S.G.N. Server!",0,1)
		Return 0
	EndIf
	tcp_killserver(ip$)
End Function

;Command: usgn_setserver
Function com_usgn_setserver()
	If e_player=e_server Then
		If tcp_setserver(e_sv_port)<>0 Then
			hud_m_add("U.S.G.N. - Server setup")
			Return 1
		Else
			hud_m_add("U.S.G.N. - failed to setup Server")
			Return 0
		EndIf
	Else
		con_add("Error: No server. Can't setup U.S.G.N. Server!",0,1)
		Return 0
	EndIf
End Function


;----------------------------------------(V) - Commands

;Command: Version
Function com_version()
	con_add("Unreal Software's Counter-Strike 2D "+version$+" - www.unrealsoftware.de",0,1)
End Function

;Commad: Volume
Function com_volume()
	Local value#=parse_getpar_num()
	If value#=-111.111 Then Return 0
	value#=value#/100.0
	If value#<0.0 Then value#=0.0
	If value#>1.0 Then value#=1.0
	op_volume#=value#
	con_add("set 'volume' = '"+(Int(op_volume#*100))+"'",0,1)
End Function

;Command Vram
Function com_vram()
	con_add("",0,0)
	con_add("--- VRAM Info ---",0,0)
	con_add("Total: ~"+(TotalVidMem ()/1024/1024)+"mb ("+TotalVidMem ()+" bytes)",0,0)
	con_add("Used: ~"+((TotalVidMem ()-AvailVidMem ())/1024/1024)+"mb ("+(TotalVidMem ()-AvailVidMem ())+" bytes)",0,0)
	con_add("Free: ~"+(AvailVidMem ()/1024/1024)+"mb ("+AvailVidMem ()+" bytes)",0,1)
	If (AvailVidMem ()/1024/1024)<3 Then
		con_add("Warning: vram is low!",0,1)
	EndIf
End Function

;----------------------------------------(W) - Commands

;Command: Wireframe
Function com_wireframe()
	If e_bot<>0 Then
		op_wireframe=1-op_wireframe
		WireFrame op_wireframe
	Else
		con_add("Error: Can't change Wireframe Mode in Net Game / Menu",0,1)
	EndIf
End Function

;----------------------------------------(X) - Commands

;----------------------------------------(Y) - Commands

;----------------------------------------(Z) - Commands