;----------------------------------------Hud Functions

;--------------------Bitmap Font
Function hud_txt(x, y, txt$, typ=0, align=0,maxlen=-1)
	Local txtlen, i, substr$, sign
	sx=x
	txtlen=Len(txt$)
	If align=1 Then
		x=x-(hud_txt_width(txt$)/2)
	ElseIf align=2 Then
		x=x-hud_txt_width(txt$)
	EndIf
	For i=1 To txtlen
		substr$=Mid(txt$, i, 1)
		sign=Asc(substr$)
		If sign>32 And sign<256 Then
			If maxlen>-1 Then
				If x+hud_font_size(sign-33)-sx>=maxlen Then Exit
			EndIf
			Select typ
				Case 0 DrawImage gfx_font_orange, x, y, sign-33
				Case 1 DrawImage gfx_font_red, x, y, sign-33
				Case 2 DrawImage gfx_font_blue, x, y, sign-33
				Case 3 DrawImage gfx_font_grey, x, y, sign-33
			End Select
			x=x+hud_font_size(sign-33)
		Else
			x=x+7
		EndIf
	Next
End Function

;--------------------Bitmap Font lnge
Function hud_txt_width(txt$)
	Local x, txtlen, i, substr$, sign
	txtlen=Len(txt$)
	For i=1 To txtlen
		substr$=Mid(txt$, i, 1)
		sign=Asc(substr$)
		If sign>32 And sign<127 Then
			x=x+hud_font_size(sign-33)
		Else
			x=x+7
		EndIf
	Next
	Return x
End Function

;--------------------Bitmap Font String mit bestimmter Lnge abziehen
Function hud_txt_extract(txt$,size)
	Local x, txtlen, i, substr$, sign
	txtlen=Len(txt$)
	For i=1 To txtlen
		substr$=Mid(txt$, i, 1)
		sign=Asc(substr$)
		If sign>32 And sign<127 Then
			x=x+hud_font_size(sign-33)
		Else
			x=x+7
		EndIf
		If x>size Then Return i-1
	Next
	Return txtlen
End Function


;--------------------HUD Men setzen
Function hud_men_set(id)
	Local y=0
	SetBuffer ImageBuffer(gfx_hudmen)
	Color 0,0,0
	Rect 0,0,400,400,1
	SetFont font_norm
	Color 255,255,255
	Select id
		;0 - Nichts
		Case 0
		;1 - Team
		Case 1
					Text 0,y,"1. Terrorist Force"
			y=y+15: Text 0,y,"2. Counter-Terrorist Force"
			y=y+30: Text 0,y,"5. Auto-Select"
			y=y+15: Text 0,y,"6. Spectator"
			y=y+30: Text 0,y,"0. Exit"
		;2 - Look T
		Case 2
					Text 0,y,"1. Phoenix Connexion"
			y=y+15: Text 0,y,"2. L337 Krew"
			y=y+15: Text 0,y,"3. Arctic Avengers"
			y=y+15: Text 0,y,"4. Guerilla Warfare"
			y=y+30: Text 0,y,"5. Auto-select"
		;3 - Look CT
		Case 3
					Text 0,y,"1. Seal Team 6 (DEVGRU)"
			y=y+15: Text 0,y,"2. German GSG-9"
			y=y+15: Text 0,y,"3. UK SAS"
			y=y+15: Text 0,y,"4. French GIGN"
			y=y+30: Text 0,y,"5. Auto-select"
		;10 - Buy
		Case 10
			Color 255,255,0
			Text 0,y,"Buy Menu"
			Color 255,255,255
			y=y+15: Text 0,y,"1. Handgun"
			y=y+15: Text 0,y,"2. Shotgun"
			y=y+15: Text 0,y,"3. Sub Machine Gun"
			y=y+15: Text 0,y,"4. Rifle"
			y=y+15: Text 0,y,"5. Machine Gun"
			y=y+30: Text 0,y,"6. Primary Ammo"
			y=y+15: Text 0,y,"7. Secondary Ammo"
			y=y+15: Text 0,y,"8. Equipment"
			y=y+30: Text 0,y,"0. Cancel"
			
		;11 - Buy - Handgun
		Case 11
			Color 255,255,0
					Text 0,y,"Buy Handgun"
					Text 170,y,"$ Cost"
			y=y+15: Text 170,y,weapon_price(1)
			y=y+15: Text 170,y,weapon_price(2)
			y=y+15: Text 170,y,weapon_price(3)
			y=y+15: Text 170,y,weapon_price(4)
			y=y+15: Text 170,y,weapon_price(5)
			y=y+15: Text 170,y,weapon_price(6)
			Color 255,255,255
			y=15:	Text 0,y,"1. "+weapon_name$(1)
			y=y+15: Text 0,y,"2. "+weapon_name$(2)
			y=y+15: Text 0,y,"3. "+weapon_name$(3)
			y=y+15: Text 0,y,"4. "+weapon_name$(4)
			y=y+15: Text 0,y,"5. "+weapon_name$(5)
			y=y+15: Text 0,y,"6. "+weapon_name$(6)
			
		;12 - Buy - Shotgun
		Case 12
			Color 255,255,0
					Text 0,y,"Buy Shotgun"
					Text 170,y,"$ Cost"
			y=y+15: Text 170,y,weapon_price(10)
			y=y+15: Text 170,y,weapon_price(11)
			Color 255,255,255
			y=15:	Text 0,y,"1. "+weapon_name$(10)
			y=y+15: Text 0,y,"2. "+weapon_name$(11)
		
		;13 - Buy - Sub Machine Gun
		Case 13
		Color 255,255,0
					Text 0,y,"Buy Sub Machine Gun"
					Text 170,y,"$ Cost"
			y=y+15: Text 170,y,weapon_price(20)
			y=y+15: Text 170,y,weapon_price(21)
			y=y+15: Text 170,y,weapon_price(22)
			y=y+15: Text 170,y,weapon_price(23)
			y=y+15: Text 170,y,weapon_price(24)
			Color 255,255,255
			y=15:	Text 0,y,"1. "+weapon_name$(20)
			If e_team=1 Then Color 130,130,130
			y=y+15: Text 0,y,"2. "+weapon_name$(21):Color 255,255,255
			y=y+15: Text 0,y,"3. "+weapon_name$(22)
			If e_team=2 Then Color 130,130,130
			y=y+15: Text 0,y,"4. "+weapon_name$(23):Color 255,255,255
			y=y+15: Text 0,y,"5. "+weapon_name$(24)
		
		;14 - Buy - Rifle
		Case 14
			Color 255,255,0
					Text 0,y,"Buy Rifle"
					Text 170,y,"$ Cost"
			y=y+15: Text 170,y,weapon_price(30)
			y=y+15: Text 170,y,weapon_price(31)
			y=y+15: Text 170,y,weapon_price(32)
			y=y+15: Text 170,y,weapon_price(33)
			y=y+30: Text 0,y,"Buy Sniper-Rifle"
					Text 170,y,"$ Cost"
			y=y+15: Text 170,y,weapon_price(34)
			y=y+15: Text 170,y,weapon_price(35)
			y=y+15: Text 170,y,weapon_price(36)
			y=y+15: Text 170,y,weapon_price(37)
			Color 255,255,255
			If e_team=2 Then Color 130,130,130
			y=15:	Text 0,y,"1. "+weapon_name$(30)
			y=y+15: Text 0,y,"2. "+weapon_name$(31):Color 255,255,255
			If e_team=1 Then Color 130,130,130
			y=y+15: Text 0,y,"3. "+weapon_name$(32)
			y=y+15: Text 0,y,"4. "+weapon_name$(33):Color 255,255,255
			y=y+45: Text 0,y,"5. "+weapon_name$(34)
			y=y+15: Text 0,y,"6. "+weapon_name$(35)
			y=y+15: Text 0,y,"7. "+weapon_name$(36)
			y=y+15: Text 0,y,"8. "+weapon_name$(37)
		
		;15 - Buy - Machine Gun
		Case 15
			Color 255,255,0
					Text 0,y,"Buy Machine Gun"
					Text 170,y,"$ Cost"
			y=y+15: Text 170,y,weapon_price(40)
			Color 255,255,255
			y=15:	Text 0,y,"1. "+weapon_name$(40)
			
		;16 - Buy - Equipment
		Case 16
			Color 255,255,0
					Text 0,y,"Buy Equipment"
					Text 170,y,"$ Cost"
			y=y+15: Text 170,y,weapon_price(57)
			y=y+15: Text 170,y,weapon_price(58)
			y=y+15: Text 170,y,weapon_price(52)
			y=y+15: Text 170,y,weapon_price(51)
			y=y+15: Text 170,y,weapon_price(53)
			y=y+15: Text 170,y,weapon_price(56)
			y=y+15: Text 170,y,weapon_price(59)
			y=y+15: Text 170,y,weapon_price(54)
			Color 255,255,255
			y=15:	Text 0,y,"1. "+weapon_name$(57)
			y=y+15: Text 0,y,"2. "+weapon_name$(58)
			y=y+15: Text 0,y,"3. "+weapon_name$(52)
			y=y+15: Text 0,y,"4. "+weapon_name$(51)
			y=y+15: Text 0,y,"5. "+weapon_name$(53)
			If e_team=1 Or map_gametype<>3 Then Color 130,130,130
			y=y+15: Text 0,y,"6. "+weapon_name$(56):Color 255,255,255
			y=y+15: Text 0,y,"7. "+weapon_name$(59)
			y=y+15: Text 0,y,"8. "+weapon_name$(54)
		
		;20 - Bot
		Case 20
			Color 255,255,0
					 Text 0,y,"Bot Menu"
			Color 255,255,255
			y=y+15: Text 0,y," 1. Kill all Bots"
			y=y+15: Text 0,y," 2. Fill with Bots"
			y=y+15: Text 0,y," 3. Add T Bot"
			y=y+15: Text 0,y," 4. Add CT Bot"	
			y=y+15: Text 0,y," 5. Remove T Bot"
			y=y+15: Text 0,y," 6. Remove CT Bot"
			y=y+15: Text 0,y," 7. Remove all Bots"
			y=y+15: Text 0,y," 8. Bot Skills"
			y=y+15: Text 0,y," 9. Bot Modes"
			y=y+30: Text 0,y," 0. Cancel"
			
		;21 - Bot - Skills
		Case 21
			Color 255,255,0
					 Text 0,y,"Bot Skills"
			Color 255,255,255
			y=y+15: Text 0,y," 1. Newbie"
			y=y+15: Text 0,y," 2. Normal"
			y=y+15: Text 0,y," 3. Pro Gamer"
			y=y+15: Text 0,y," 4. Cheater"	
			y=y+30: Text 0,y," 0. Cancel"
			
		;22 - Bot - Modes
		Case 22
			Color 255,255,0
					 Text 0,y,"Bot Modes"
			Color 255,255,255
			y=y+15: Text 0,y," 1. Normal"
			y=y+15: Text 0,y," 2. Knifes only"
			y=y+15: Text 0,y," 3. Pistols only"
			y=y+15: Text 0,y," 4. Shotguns only"	
			y=y+15: Text 0,y," 5. SMGs only"
			y=y+15: Text 0,y," 6. Rifles only"
			y=y+15: Text 0,y," 7. Sniper-Rifles only"
			y=y+15: Text 0,y," 8. MGs only"
			y=y+30: Text 0,y," 0. Cancel"
			

		;30 - Radio Commands
		Case 30
			Color 255,255,0
					 Text 0,y,"Radio Commands"
			Color 255,255,255
			y=y+15: Text 0,y," 1. Cover me"
			y=y+15: Text 0,y," 2. You Take the Point"
			y=y+15: Text 0,y," 3. Hold This Position"
			y=y+15: Text 0,y," 4. Regroup Team"	
			y=y+15: Text 0,y," 5. Follow Me"
			y=y+15: Text 0,y," 6. Taking Fire, Need Assistance"
			y=y+30: Text 0,y," 0. Cancel"
		
		
		;31 - Group Radio Commands
		Case 31
			Color 255,255,0
					 Text 0,y,"Radio Commands"
			Color 255,255,255
			y=y+15: Text 0,y," 1. Go"
			y=y+15: Text 0,y," 2. Fall Back"
			y=y+15: Text 0,y," 3. Stick Together Team"
			y=y+15: Text 0,y," 4. Get in Position"	
			y=y+15: Text 0,y," 5. Storm the Front"
			y=y+15: Text 0,y," 6. Report In"
			y=y+30: Text 0,y," 0. Cancel"
			
		;32 - Radio Responses/Reports
		Case 32
			Color 255,255,0
					 Text 0,y,"Radio Commands"
			Color 255,255,255
			y=y+15: Text 0,y," 1. Affirmative/Roger"
			y=y+15: Text 0,y," 2. Enemy Spotted"
			y=y+15: Text 0,y," 3. Need Backup"
			y=y+15: Text 0,y," 4. Sector Clear"	
			y=y+15: Text 0,y," 5. I'm in Position"
			y=y+15: Text 0,y," 6. Reporting In"
			y=y+15: Text 0,y," 7. She's gonna Blow!"
			y=y+15: Text 0,y," 8. Negative"
			y=y+15: Text 0,y," 9. Enemy Down"
			y=y+30: Text 0,y," 0. Cancel"
				
		;100 - Quit
		Case 100
			Color 255,255,0
			Text 0,y,"Quit Game?"
			Color 255,255,255
			y=y+15: Text 0,y,"1. Yes"
			y=y+15: Text 0,y,"2. No"
			y=y+30: Text 0,y,"0. Cancel"		
		
		
		
		
	End Select
	hud_men=id
	SetBuffer BackBuffer()
End Function

;--------------------HUD Men Anzeigen + Eingabe
Function hud_men_render(key=0)
	If hud_men=0 Then Return 1
	Local i
	If con_y<=103 Then
		If key=0 Then
			DrawImage gfx_hudmen, 3,103
		EndIf
	EndIf
	Select hud_men
		;1 - Team
		Case 1
			If key=1 Then player_team(e_player,1): hud_men_set(2)
			If key=2 Then player_team(e_player,2): hud_men_set(3)
			If key=5 Then
				;Autoselect - Mehr Ts?
				If player_count(1)>player_count(2) Then
					player_team(e_player,2): hud_men_set(3)
				;Mehr CTs?
				ElseIf player_count(2)>player_count(1) Then
					player_team(e_player,1): hud_men_set(2)
				;Mehr T Wins?
				ElseIf e_sv_score_t>e_sv_score_ct Then
					player_team(e_player,2): hud_men_set(3)
				;Mehr CT Wins?
				ElseIf e_sv_score_ct>e_sv_score_t Then
					player_team(e_player,1): hud_men_set(2)
				;Zufall
				Else
					i=Rand(1,2)
					player_team(e_player,i)
					hud_men_set(1+i)
				EndIf
			EndIf
			If key=6 Then player_team(e_player,0):player_ini(e_player):hud_men_set(0)
			
		
		;2/3 - Look T/CT
		Case 2,3
			i=-1
			If key=1 Then i=0
			If key=2 Then i=1
			If key=3 Then i=2
			If key=4 Then i=3
			If key=5 Then i=Rand(0,3)
			If i<>-1 Then
				player_look(e_player,i)
				player_ini(e_player)
				If e_player=e_server Then
					If e_bot<>0 Then
						player_start(e_player)
					Else
						game_roundend()
					EndIf
				EndIf
				hud_men_set(0)
			EndIf
		
		;10 - Buy
		Case 10
			If key=1 Then hud_men_set(11)
			If key=2 Then hud_men_set(12)
			If key=3 Then hud_men_set(13)
			If key=4 Then hud_men_set(14)
			If key=5 Then hud_men_set(15)
			If key=6 Then player_buy(e_player,63)
			If key=7 Then player_buy(e_player,64)
			If key=8 Then hud_men_set(16)
			
		;11 - Buy - Handgun
		Case 11
			If key=1 Then player_buy(e_player,1)
			If key=2 Then player_buy(e_player,2)
			If key=3 Then player_buy(e_player,3)
			If key=4 Then player_buy(e_player,4)
			If key=5 Then player_buy(e_player,5)
			If key=6 Then player_buy(e_player,6)
			
		;12 - Buy - Shotgun
		Case 12
			If key=1 Then player_buy(e_player,10)
			If key=2 Then player_buy(e_player,11)
		
		;13 - Buy - Sub Machine Gun
		Case 13
			If key=1 Then player_buy(e_player,20)
			If key=2 Then player_buy(e_player,21)
			If key=3 Then player_buy(e_player,22)
			If key=4 Then player_buy(e_player,23)
			If key=5 Then player_buy(e_player,24)
		
		;14 - Buy - Rifle
		Case 14
			If key=1 Then player_buy(e_player,30)
			If key=2 Then player_buy(e_player,31)
			If key=3 Then player_buy(e_player,32)
			If key=4 Then player_buy(e_player,33)
			If key=5 Then player_buy(e_player,34)
			If key=6 Then player_buy(e_player,35)
			If key=7 Then player_buy(e_player,36)
			If key=8 Then player_buy(e_player,37)
		
		;15 - Buy - Machine Gun
		Case 15
			If key=1 Then player_buy(e_player,40)
			
		;16 - Buy - Equipment
		Case 16
			If key=1 Then player_buy(e_player,57)
			If key=2 Then player_buy(e_player,58)
			If key=3 Then player_buy(e_player,52)
			If key=4 Then player_buy(e_player,51)
			If key=5 Then player_buy(e_player,53)
			If key=6 Then player_buy(e_player,56)
			If key=7 Then player_buy(e_player,59)
			If key=8 Then player_buy(e_player,54)
		
		;20 - Bot Menu
		Case 20
			;Kill all
			If key=1 Then
				hud_men_set(0)
				For player.player=Each player
					If player\bot=1 Then
						player_kill(player\id, 200, 0, 1)
					EndIf
				Next
			EndIf
			;Fill
			If key=2 Then
				hud_men_set(0)
				If map_waypoints Then
					If player_count(0)<e_sv_maxplayers Then
						e_bot_join=e_sv_maxplayers-player_count(0)
					Else
						hud_m_add("Can't fill with Bots - Player limit already reached")
					EndIf
				Else
					hud_m_add("Can't fill with Bots - No Waypoints for this Map")
				EndIf
			EndIf
			;Add T
			If key=3 Then
				hud_men_set(0)
				If map_waypoints Then
					If player_count(0)<e_sv_maxplayers Then
						id=player_add(op_botname$(Rand(0,op_botnames)),1,0,0)
						player_team(id,1)
						player_look(id,Rand(0,3))
						player_ini(id)
						player_start(id)
					Else
						hud_m_add("Can't add Bot - Player limit reached")
					EndIf
				Else
					hud_m_add("Can't add Bot - No Waypoints for this Map")
				EndIf
			EndIf
			;Add CT
			If key=4 Then
				hud_men_set(0)
				If map_waypoints Then
					If player_count(0)<e_sv_maxplayers Then
						id=player_add(op_botname$(Rand(0,op_botnames)),1,0,0)
						player_team(id,2)
						player_look(id,Rand(0,3))
						player_ini(id)
						player_start(id)
					Else
						hud_m_add("Can't add Bot - Player limit reached")
					EndIf
				Else
					hud_m_add("Can't add Bot - No Waypoints for this Map")
				EndIf
			EndIf
			;Remove T
			If key=5 Then
				hud_men_set(0)
				For player.player=Each player
					If player\bot=1 Then
						If player\team=1 Then
							player_leave(player\id,0,1)
							Return 1
						EndIf
					EndIf
				Next
			EndIf
			;Remove CT
			If key=6 Then
				hud_men_set(0)
				For player.player=Each player
					If player\bot=1 Then
						If player\team=2 Then
							player_leave(player\id,0,1)
							Return 1
						EndIf
					EndIf
				Next
			EndIf
			;Remove all
			If key=7 Then
				hud_men_set(0)
				For player.player=Each player
					If player\bot=1 Then
						player_leave(player\id,0,1)
					EndIf
				Next
			EndIf
			;Men
			If key=8 Then hud_men_set(21)
			If key=9 Then hud_men_set(22)
			
		;21 - Bot Skills
		Case 21
			If key=1 Then bot_skills(1)
			If key=2 Then bot_skills(2)
			If key=3 Then bot_skills(3)
			If key=4 Then bot_skills(4)
			
		;22 - Bot Modes
		Case 22
			If key=1 Then bot_modes(1)
			If key=2 Then bot_modes(2)
			If key=3 Then bot_modes(3)
			If key=4 Then bot_modes(4)
			If key=5 Then bot_modes(5)
			If key=6 Then bot_modes(6)
			If key=7 Then bot_modes(7)
			If key=8 Then bot_modes(8)
			
		;30 - Radio Commands
		Case 30
			If key=1 Then player_radio(e_player,1)
			If key=2 Then player_radio(e_player,2)
			If key=3 Then player_radio(e_player,3)
			If key=4 Then player_radio(e_player,4)
			If key=5 Then player_radio(e_player,5)
			If key=6 Then player_radio(e_player,6)
		
		;31 - Group Radio Commands
		Case 31
			If key=1 Then player_radio(e_player,11)
			If key=2 Then player_radio(e_player,12)
			If key=3 Then player_radio(e_player,13)
			If key=4 Then player_radio(e_player,14)
			If key=5 Then player_radio(e_player,15)
			If key=6 Then player_radio(e_player,16)
			
		;32 - Radio Responses/Reports
		Case 32
			If key=1 Then player_radio(e_player,21)
			If key=2 Then player_radio(e_player,22)
			If key=3 Then player_radio(e_player,23)
			If key=4 Then player_radio(e_player,24)
			If key=5 Then player_radio(e_player,25)
			If key=6 Then player_radio(e_player,26)
			If key=7 Then player_radio(e_player,27)
			If key=8 Then player_radio(e_player,28)
			If key=9 Then player_radio(e_player,29)
		
		;100 - Quit
		Case 100
			If key=1 Then
				;Server
				If e_player=e_server Then
					;Online Quit
					If e_bot=0 Then
						tcp_killserver(DottedIP(e_sv_ip))
						player_leave(e_player,3,1)
					;Offline Quit
					Else
						udp_clear()
						men_set(30)
					EndIf
				Else
					player_leave(e_player,0,1)
				EndIf
				e_cls()
				leave=1
			EndIf
			If key=2 Then hud_men_set(0)
		
	End Select
	If key=10 Then hud_men_set(0)
End Function


;--------------------Nachrichten (O)ben (L)inks hinzfgen
Function hud_ol_add(txt$, update=1)
	hud_ol.hud_ol=New hud_ol
	hud_ol\txt$=txt$
	hud_ol\timer=ms
	con_add(txt$,0,update)
End Function

;--------------------Nachrichten (O)ben (L)inks anzeigen & updaten
Function hud_ol_render()
	Local y=1,count,i
	For hud_ol.hud_ol = Each hud_ol
		count=count+1
	Next
	If count=0 Then
		Return 0
	ElseIf count<5 Then
		For hud_ol.hud_ol = Each hud_ol
			hud_txt(1,y+hud_loff,hud_ol\txt$)
			If ms-hud_ol\timer>3000 Then
				Delete hud_ol
			EndIf
			y=y+15
		Next
	Else
		For hud_ol.hud_ol = Each hud_ol
			If count-i<=5 Then
				hud_txt(1,y+hud_loff,hud_ol\txt$)
				If ms-hud_ol\timer>3000 Then
					Delete hud_ol
				EndIf
				y=y+15
			EndIf
			i=i+1
		Next		
	EndIf
End Function

;--------------------Nachrichten (O)ben (R)echts hinzfgen
Function hud_or_add(txt1$,col1,txt2$="",txt3$="",col3=0)
	hud_or.hud_or=New hud_or
	hud_or\txt$[0]=txt1$
	hud_or\txt$[1]=txt2$
	hud_or\txt$[2]=txt3$
	hud_or\col[0]=col1
	hud_or\col[1]=col3
	hud_or\timer=ms
End Function

;--------------------Nachrichten (O)ben (R)echts anzeigen & updaten
Function hud_or_render()
	Local y=1,count,i,x
	For hud_or.hud_or = Each hud_or
		count=count+1
	Next
	If count=0 Then
		Return 0
	ElseIf count<5 Then
		For hud_or.hud_or = Each hud_or
			x=639-hud_txt_width(hud_or\txt$[0]+hud_or\txt$[1]+hud_or\txt$[2])
			hud_txt(x,y+hud_roff,hud_or\txt$[0],hud_or\col[0])
			x=x+hud_txt_width(hud_or\txt$[0])
			hud_txt(x,y+hud_roff,hud_or\txt$[1],0)
			x=x+hud_txt_width(hud_or\txt$[1])
			hud_txt(x,y+hud_roff,hud_or\txt$[2],hud_or\col[1])		
			If ms-hud_or\timer>5000 Then
				Delete hud_or
			EndIf
			y=y+15
		Next
	Else
		For hud_or.hud_or = Each hud_or
			If count-i<=5 Then
				x=639-hud_txt_width(hud_or\txt$[0]+hud_or\txt$[1]+hud_or\txt$[2])
				hud_txt(x,y+hud_roff,hud_or\txt$[0],hud_or\col[0])
				x=x+hud_txt_width(hud_or\txt$[0])
				hud_txt(x,y+hud_roff,hud_or\txt$[1],0)
				x=x+hud_txt_width(hud_or\txt$[1])
				hud_txt(x,y+hud_roff,hud_or\txt$[2],hud_or\col[1])
				If ms-hud_or\timer>5000 Then
					Delete hud_or
				EndIf
				y=y+15
			EndIf
			i=i+1
		Next		
	EndIf
End Function

;--------------------Nachricht (M)itte setzen
Function hud_m_add(msg$,timer=3000)
	hud_m$=msg$
	hud_mt=ms+timer
End Function

;--------------------Nachricht (M)itte anzeigen & updaten
Function hud_m_render()
	If hud_m$="" Then Return 0
	hud_txt(320,235,hud_m$,0,1)
	If ms-hud_mt>0 Then
		hud_m$=""
	EndIf
End Function

;--------------------Nachrichten (M)itte (L)inks hinzfgen
Function hud_ml_add(txt1$,col,txt2$="",update=1)
	hud_ml.hud_ml=New hud_ml
	hud_ml\txt$[0]=txt1$
	hud_ml\txt$[1]=txt2$
	hud_ml\col=col
	hud_ml\timer=ms
	con_add(txt1$+txt2$,0,update)
End Function

;--------------------Nachrichten (M)itte (L)inks anzeigen & updaten
Function hud_ml_render()
	Local y=240,x,count,i
	For hud_ml.hud_ml = Each hud_ml
		count=count+1
	Next
	If count=0 Then
		Return 0
	ElseIf count<5 Then
		For hud_ml.hud_ml = Each hud_ml
			x=1
			hud_txt(x,y,hud_ml\txt$[0],hud_ml\col)
			x=x+hud_txt_width(hud_ml\txt$[0])
			hud_txt(x,y,hud_ml\txt$[1],0)
			If ms-hud_ml\timer>6000 Then
				Delete hud_ml
			EndIf
			y=y+15
		Next
	Else
		For hud_ml.hud_ml = Each hud_ml
			If count-i<=5 Then
				x=1
				hud_txt(x,y,hud_ml\txt$[0],hud_ml\col)
				x=x+hud_txt_width(hud_ml\txt$[0])
				hud_txt(x,y,hud_ml\txt$[1],0)
				If ms-hud_ml\timer>6000 Then
					Delete hud_ml
				EndIf
				y=y+15
			EndIf
			i=i+1
		Next		
	EndIf
End Function

;--------------------Say
Function hud_say()
	If hud_say_mode=0 Then Return 0
	Local saytxt$
	If hud_say_mode=1 Then
		saytxt$="say: "
	ElseIf hud_say_mode=2
		saytxt$="say team: "
	EndIf
	saytxt$=saytxt$+hud_say_txt$
	If cursor Then saytxt$=saytxt$+"|"
	hud_txt(1,1+hud_loff,saytxt$)
	hud_loff=hud_loff+12
	If con_mode=0 And con_y=0 Then
		If Not hud_say_block
			;Input
			If key>31 Then hud_say_txt$=hud_say_txt$+Chr(key)
			
			;Delete
			If keydelete=1 Or (keydeletedown=1 And (ms-keydeletelast>70)) Then
				If Len(hud_say_txt$)>0 Then
					keydeletedown=0:keydeletelast=ms
					If keydelete=1 Then keydelete=0:keydeletelast=ms+500
					hud_say_txt$=LSet(hud_say_txt$, Len(hud_say_txt$)-1)
				EndIf
			EndIf
			
			;Cut / Copy / Paste
			If KeyDown(29) Then
				If KeyHit(47) Then
					hud_say_txt$=paste$()
					If Len(hud_say_txt$)>100 Then hud_say_txt$=Left(hud_say_txt$,100)
				ElseIf KeyHit(46) Then
					copy(hud_say_txt$)
				ElseIf KeyHit(45) Then
					copy(hud_say_txt$)
					hud_say_txt$=""
				EndIf
			EndIf
			
			;Enter
			If KeyDown(28) Then
				FlushKeys()
				If hud_say_mode=1 Then
					player_say(e_player,hud_say_txt$,1)
				Else
					player_sayteam(e_player,hud_say_txt$,1)
				EndIf
				FlushKeys()
				hud_say_mode=0
			EndIf
		EndIf
	EndIf
End Function


;--------------------HUD initialisieren
Function hud_hud_ini()
	
	If hud_main=0 Then hud_main=CreatePivot(cam)
	
	If hud_main_living=0 Then hud_main_living=CreatePivot(hud_main)
	If hud_main_dead=0 Then hud_main_dead=CreatePivot(hud_main)

	;---Health
	;Symbol
	If hud_health(0)=0 Then hud_health(0)=CreateSprite()
	EntityTexture hud_health(0),gfx_hud_symbols,0
	ScaleSprite hud_health(0),26,26
	PositionEntity hud_health(0),((3)*2)-640+26,-((448)*2)+480-26,640
	;Ziffern
	For i=1 To 3
		If hud_health(i)=0 Then hud_health(i)=CreateSprite()
		EntityTexture hud_health(i),gfx_hud_nums,0
		ScaleSprite hud_health(i),20,28
		PositionEntity hud_health(i),((3+5+(i*22))*2)-640+24,-((443)*2)+480-33,640
	Next
	
	;---Armory
	;Symbol
	If hud_armory(0)=0 Then hud_armory(0)=CreateSprite()
	EntityTexture hud_armory(0),gfx_hud_symbols,1
	ScaleSprite hud_armory(0),26,26
	PositionEntity hud_armory(0),((110)*2)-640+26,-((448)*2)+480-26,640
	;Ziffern
	For i=1 To 3
		If hud_armory(i)=0 Then hud_armory(i)=CreateSprite()
		EntityTexture hud_armory(i),gfx_hud_nums,0
		ScaleSprite hud_armory(i),20,28
		PositionEntity hud_armory(i),((110+5+(i*22))*2)-640+24,-((443)*2)+480-33,640
	Next
	
	;---Time
	;Symbol
	If hud_time(0)=0 Then hud_time(0)=CreateSprite()
	EntityTexture hud_time(0),gfx_hud_symbols,2
	ScaleSprite hud_time(0),26,26
	PositionEntity hud_time(0),((248)*2)-640+26,-((448)*2)+480-26,640
	;Sperator
	If hud_time(1)=0 Then hud_time(1)=CreateSprite()
	EntityTexture hud_time(1),gfx_hud_nums,10
	ScaleSprite hud_time(1),20,28
	PositionEntity hud_time(1),((320)*2)-640+20,-((443)*2)+480-28,640
	;Ziffern
	For i=2 To 5
		If hud_time(i)=0 Then hud_time(i)=CreateSprite()
		EntityTexture hud_time(i),gfx_hud_nums,0
		ScaleSprite hud_time(i),20,28
		Select i
			Case 2 PositionEntity hud_time(i),((248+5+(1*22))*2)-640+24,-((443)*2)+480-33,640
			Case 3 PositionEntity hud_time(i),((248+5+(2*22))*2)-640+24,-((443)*2)+480-33,640
			Case 4 PositionEntity hud_time(i),((300+2+(1*22))*2)-640+24,-((443)*2)+480-33,640
			Case 5 PositionEntity hud_time(i),((300+2+(2*22))*2)-640+24,-((443)*2)+480-33,640
		End Select
	Next
	
	;---Ammo
	;Sperator
	If hud_ammo(0)=0 Then hud_ammo(0)=CreateSprite()
	EntityTexture hud_ammo(0),gfx_hud_nums,11
	ScaleSprite hud_ammo(0),20,28
	PositionEntity hud_ammo(0),((568)*2)-640+20,-((446)*2)+480-28,640
	;Ziffern 1
	For i=1 To 3
		If hud_ammo(i)=0 Then hud_ammo(i)=CreateSprite()
		EntityTexture hud_ammo(i),gfx_hud_nums,0
		ScaleSprite hud_ammo(i),20,28
		PositionEntity hud_ammo(i),((474+5+(i*22))*2)-640+24,-((443)*2)+480-33,640
	Next
	;Ziffern 2
	For i=4 To 6
		If hud_ammo(i)=0 Then hud_ammo(i)=CreateSprite()
		EntityTexture hud_ammo(i),gfx_hud_nums,0
		ScaleSprite hud_ammo(i),20,28
		PositionEntity hud_ammo(i),((550+((i-3)*22))*2)-640+24,-((443)*2)+480-33,640
	Next
	
	;---Money
	;Symbol
	If hud_money(0)=0 Then hud_money(0)=CreateSprite()
	EntityTexture hud_money(0),gfx_hud_symbols,7
	ScaleSprite hud_money(0),26,26
	PositionEntity hud_money(0),((510)*2)-640+26,-((418)*2)+480-26,640
	;Ziffern
	For i=1 To 5
		If hud_money(i)=0 Then hud_money(i)=CreateSprite()
		EntityTexture hud_money(i),gfx_hud_nums,0
		ScaleSprite hud_money(i),20,28
		PositionEntity hud_money(i),((501+5+(i*22))*2)-640+24,-((413)*2)+480-33,640
	Next
	
	For i=0 To 6	
		If i<=3 Then
			;Health
			EntityColor hud_health(i),255,255,0
			EntityBlend hud_health(i),3
			EntityOrder hud_health(i),order_hud_display
			EntityParent hud_health(i),hud_main_living
			
			;Armory
			EntityColor hud_armory(i),255,255,0
			EntityBlend hud_armory(i),3
			EntityOrder hud_armory(i),order_hud_display
			EntityParent hud_armory(i),hud_main_living
		EndIf	
		If i<=5 Then
			;Timer
			EntityColor  hud_time(i),255,255,0
			EntityBlend hud_time(i),3
			EntityOrder hud_time(i),order_hud_display
			EntityParent hud_time(i),hud_main_living
			
			;Money
			EntityColor hud_money(i),255,255,0
			EntityBlend hud_money(i),3
			EntityOrder hud_money(i),order_hud_display
			EntityParent hud_money(i),hud_main_living
		EndIf
		;Ammo
		EntityColor hud_ammo(i),255,255,0
		EntityBlend hud_ammo(i),3
		EntityOrder hud_ammo(i),order_hud_display
		EntityParent hud_ammo(i),hud_main_living
	Next
	
	;---Symbols
	;Zone
	If hud_symbols(0)=0 Then hud_symbols(0)=CreateSprite()
	EntityTexture hud_symbols(0),gfx_hud_symbols,4
	ScaleSprite hud_symbols(0),26,26
	PositionEntity hud_symbols(0),((3)*2)-640+26,-((140)*2)+480-26,640
	EntityColor hud_symbols(0),0,255,0
	EntityBlend hud_symbols(0),3
	EntityOrder hud_symbols(0),order_hud_display
	EntityParent hud_symbols(0),hud_main_living
	;Bomb/Defuse
	If hud_symbols(1)=0 Then hud_symbols(1)=CreateSprite()
	EntityTexture hud_symbols(1),gfx_hud_symbols,3
	ScaleSprite hud_symbols(1),26,26
	PositionEntity hud_symbols(1),((3)*2)-640+26,-((170)*2)+480-26,640
	EntityColor hud_symbols(1),0,255,0
	EntityBlend hud_symbols(1),3
	EntityOrder hud_symbols(1),order_hud_display
	EntityParent hud_symbols(1),hud_main_living
	
	;---Radar
	If hud_radar=0 Then hud_radar=CreateSprite()
	EntityTexture hud_radar, gfx_hud_radar
	ScaleSprite hud_radar,100,100
	PositionEntity hud_radar,((3)*2)-640+100,-((3)*2)+480-100,640
	EntityColor hud_radar,0,255,0
	EntityAlpha hud_radar,0.3
	EntityBlend hud_radar,3
	EntityOrder hud_radar,order_hud_display
	EntityParent hud_radar,hud_main_living
	
	;---Board
	If hud_board=0 Then hud_board=CreateCube()
	ScaleMesh hud_board,600,440,1
	PositionEntity hud_board,((20)*2)-640+600,-((20)*2)+480-440,640
	EntityAlpha hud_board,0.75
	EntityColor hud_board,0,0,0
	EntityOrder hud_board,order_scoreboard
	EntityParent hud_board,hud_main
	
	;---Borders
	For i=0 To 1
		If hud_borders(i)=0 Then hud_borders(i)=CreateCube()
		ScaleMesh hud_borders(i),640,40,1
		EntityAlpha hud_borders(i),0.75
		EntityColor hud_borders(i),0,0,0
		EntityOrder hud_borders(i),order_hud_area
		EntityParent hud_borders(i),hud_main_dead
		If i=0 Then
			PositionEntity hud_borders(i),((0)*2)-640+640,-((0)*2)+480-40,640
		Else
			PositionEntity hud_borders(i),((0)*2)-640+640,-((440)*2)+480-40,640
		EndIf
	Next
	
	;---Body
	If hud_body=0 Then hud_body=CreateCube()
	ScaleMesh hud_body,400,380,1
	PositionEntity hud_body,((120)*2)-640+400,-((50)*2)+480-380,640
	EntityAlpha hud_body,0.75
	EntityColor hud_body,0,0,0
	EntityOrder hud_body,order_hud_area
	EntityParent hud_body,hud_main_dead
	
	;---Progress Border
	If hud_progress=0 Then hud_progress=CreateSprite()
	EntityTexture hud_progress, gfx_hud_progress
	ScaleSprite hud_progress,204,30
	PositionEntity hud_progress,((218)*2)-640+204,-((260)*2)+480-30,640
	EntityColor hud_progress,255,255,0
	EntityBlend hud_progress,3
	EntityOrder hud_progress,order_hud_display
	EntityParent hud_progress,hud_main_living
	EntityAlpha hud_progress,0.7
	
	;---Progress Bar
	If hud_progress_bar=0 Then hud_progress_bar=CreateCube()
	ScaleEntity hud_progress_bar,200,26,1
	PositionEntity hud_progress_bar,((220)*2)-640+200,-((260)*2)+480-26,640
	EntityColor hud_progress_bar,255,255,0
	EntityBlend hud_progress_bar,3
	EntityOrder hud_progress_bar,order_hud_display
	EntityParent hud_progress_bar,hud_main_living
	EntityAlpha hud_progress_bar,0.4
	
	;---Flash
	If hud_flash=0 Then hud_flash=CreateCube()
	ScaleMesh hud_flash,640,480,1
	EntityColor hud_flash, 255,255,255
	EntityBlend hud_flash, 3
	PositionEntity hud_flash,((0)*2)-640+640,-((0)*2)+480-480,640
	EntityOrder hud_flash,order_hud_light
	EntityParent hud_flash,hud_main_living
	HideEntity hud_flash
	
	;---Night Vision
	If hud_nv=0 Then hud_nv=CreateCube()
	ScaleMesh hud_nv,640,480,1
	EntityTexture hud_nv,gfx_nvshader
	EntityColor hud_nv, 0,200,0
	EntityAlpha hud_nv, 0.4
	EntityBlend hud_nv, 3
	PositionEntity hud_nv,((0)*2)-640+640,-((0)*2)+480-480,640
	EntityOrder hud_nv,order_hud_light
	EntityParent hud_nv,hud_main_living
	HideEntity hud_nv
	
	;---Sniper
	;If hud_sniper_main=0 Then hud_sniper_main=CreatePivot()
	;PositionEntity hud_sniper_main,((320)*2)-640,-((240)*2)+480,0
	;For i=0 To 4
	;	If hud_sniper(i)=0 Then hud_sniper(i)=CreateCube()
	;	EntityColor hud_sniper(i),0,0,0
	;	EntityOrder hud_sniper(i),order_hud_sniper
	;	EntityParent hud_sniper(i),hud_sniper_main
	;Next
	;oben (1)
	;ScaleMesh hud_sniper(1),(640*3),480,1
	;PositionEntity hud_sniper(1),((-640)*2)-640+(640*3),-((-304)*2)+480-480,640
	;unten (2)
	;ScaleMesh hud_sniper(2),(640*3),480,1
	;PositionEntity hud_sniper(2),((-640)*2)-640+(640*3),-((304)*2)+480-480,640	
	;links (3)
	;ScaleMesh hud_sniper(3),640,128,1
	;PositionEntity hud_sniper(3),((-384)*2)-640+640,-((176)*2)+480-128,640
	;rechts (4)
	;ScaleMesh hud_sniper(4),640,128,1
	;PositionEntity hud_sniper(4),((384)*2)-640+640,-((176)*2)+480-128,640
	;mitte (0)
	;ScaleMesh hud_sniper(0),128,128,1
	;PositionEntity hud_sniper(0),((256)*2)-640+128,-((176)*2)+480-128,640
	;EntityTexture hud_sniper(0),gfx_hud_sniper,0
	;Pivot
	;EntityParent hud_sniper_main,hud_main_living
	
End Function


;--------------------HUD updaten
Function hud_hud_update(health=1,kevlar=1,timer=1,ammo=1,money=1)
	If hud_main=0 Then Return 0
	Local ph=0
	For player.player=Each player
		If player\id=e_player Then ph=1:Exit
	Next
	If Not ph Then
		e_active=0
	Else
		If player\health>0 Then
			e_active=1
		Else
			e_active=0
		EndIf
	EndIf
	
	If e_active Then
		ShowEntity hud_main_living
		HideEntity hud_main_dead
		
		Local numstr$,numlen
		
		;Health
		If health Then
			numstr$=player\health
			;1
			If Len(numstr$)<3 Then
				numstr$="0"+numstr$
				HideEntity hud_health(1)
			Else
				ShowEntity hud_health(1)
				EntityTexture hud_health(1),gfx_hud_nums,Left(numstr$,1)
			EndIf
			;2
			If Len(numstr$)<3 Then
				numstr$="0"+numstr$
				HideEntity hud_health(2)
			Else
				ShowEntity hud_health(2)
				EntityTexture hud_health(2),gfx_hud_nums,Mid(numstr$,2,1)
			EndIf
			;3
			EntityTexture hud_health(3),gfx_hud_nums,Right(numstr$,1)
		EndIf
		If player\health<30 Then
			For i=0 To 3
				EntityColor hud_health(i),255,0,0
			Next
		Else
			For i=0 To 3
				EntityColor hud_health(i),255,255,0
			Next
		EndIf
		
		;Armory
		If kevlar Then
			numstr$=player\armor
			;1
			If Len(numstr$)<3 Then
				numstr$="0"+numstr$
				HideEntity hud_armory(1)
			Else
				ShowEntity hud_armory(1)
				EntityTexture hud_armory(1),gfx_hud_nums,Left(numstr$,1)
			EndIf
			;2
			If Len(numstr$)<3 Then
				numstr$="0"+numstr$
				HideEntity hud_armory(2)
			Else
				ShowEntity hud_armory(2)
				EntityTexture hud_armory(2),gfx_hud_nums,Mid(numstr$,2,1)
			EndIf
			;3
			EntityTexture hud_armory(3),gfx_hud_nums,Right(numstr$,1)
		EndIf
		
		;Timer
		If timer Then
			;1a
			If e_rt_m<10 Then
				numstr$="0"+e_rt_m
				HideEntity hud_time(2)
			Else
				numstr$=e_rt_m
				ShowEntity hud_time(2)
				EntityTexture hud_time(2),gfx_hud_nums,Left(numstr$,1)
			EndIf
			;2a
			EntityTexture hud_time(3),gfx_hud_nums,Right(numstr$,1)
			
			;1b
			If e_rt_s<10 Then
				numstr$="0"+e_rt_s
			Else
				numstr$=e_rt_s
			EndIf
			EntityTexture hud_time(4),gfx_hud_nums,Left(numstr$,1)
			;2b
			EntityTexture hud_time(5),gfx_hud_nums,Right(numstr$,1)
		EndIf
		
		;Ammo
		If ammo Then
			numstr$=player\sammoin[player\slot]
			;1a
			If Len(numstr$)<3 Then
				numstr$="0"+numstr$
				HideEntity hud_ammo(1)
			Else
				ShowEntity hud_ammo(1)
				EntityTexture hud_ammo(1),gfx_hud_nums,Left(numstr$,1)
			EndIf
			;2a
			If Len(numstr$)<3 Then
				numstr$="0"+numstr$
				HideEntity hud_ammo(2)
			Else
				ShowEntity hud_ammo(2)
				EntityTexture hud_ammo(2),gfx_hud_nums,Mid(numstr$,2,1)
			EndIf
			;3a
			EntityTexture hud_ammo(3),gfx_hud_nums,Right(numstr$,1)
			
			numstr$=player\sammo[player\slot]
			;1b
			If Len(numstr$)<3 Then
				numstr$="0"+numstr$
				HideEntity hud_ammo(4)
			Else
				ShowEntity hud_ammo(4)
				EntityTexture hud_ammo(4),gfx_hud_nums,Left(numstr$,1)
			EndIf
			;2b
			If Len(numstr$)<3 Then
				numstr$="0"+numstr$
				HideEntity hud_ammo(5)
			Else
				ShowEntity hud_ammo(5)
				EntityTexture hud_ammo(5),gfx_hud_nums,Mid(numstr$,2,1)
			EndIf
			;3b
			EntityTexture hud_ammo(6),gfx_hud_nums,Right(numstr$,1)
		EndIf
		
		;Money
		If money Then
			If hud_money_val>0 Then
				hud_money_val=hud_money_val-15
				If hud_money_val<0 Then
					hud_money_val=0
					hud_money_mode=0
				EndIf
				Select hud_money_mode
					Case -1	EntityColor hud_money(0),255,255-hud_money_val,0
					Case 0 EntityColor hud_money(0),255,255,0
					Case 1 EntityColor hud_money(0),255-hud_money_val,255,0
				End Select
			EndIf
			numstr$=player\money
			numlen=Len(numstr$)
			For i=1 To 5
				If 6-i<=numlen Then
					ShowEntity hud_money(i)
					EntityTexture hud_money(i),gfx_hud_nums,Mid(numstr$,i-(5-numlen),1)
					Select hud_money_mode
						Case -1	EntityColor hud_money(i),255,255-hud_money_val,0
						Case 0 EntityColor hud_money(i),255,255,0
						Case 1 EntityColor hud_money(i),255-hud_money_val,255,0
					End Select
				Else
					HideEntity hud_money(i)
				EndIf
			Next
		EndIf
		
		;Flash
		If hud_flash_a#>0.0 Then
			hud_flash_a#=hud_flash_a#-(0.005*spfak#)
			ShowEntity hud_flash
			EntityAlpha hud_flash, hud_flash_a#
			If hud_flash_a#<=0.0 Then
				hud_flash_a#=0.0
			EndIf
		Else
			HideEntity hud_flash
		EndIf
		
		;Nightvision
		If hud_nv_mode Then
			ShowEntity hud_nv
			EntityAlpha hud_nv,Rnd(0.250,0.350)
			EntityColor hud_nv,0,Rand(190,210),0
			RotateTexture gfx_nvshader, Rand(-360,360)
		Else
			HideEntity hud_nv
		EndIf
		
		;Zone Symbol
		HideEntity hud_symbols(0)
		Select player\tile_entity
			;Buy Zone
			Case 0,1
				If player\team=(player\tile_entity+1) Then
					ShowEntity hud_symbols(0)
					EntityTexture hud_symbols(0), gfx_hud_symbols,4
				EndIf
			;Rescue Zone
			Case 4
				ShowEntity hud_symbols(0)
				EntityTexture hud_symbols(0), gfx_hud_symbols,5
			;Escape Zone
			Case 6
				ShowEntity hud_symbols(0)
				EntityTexture hud_symbols(0), gfx_hud_symbols,5
		End Select
	
		
		;Bomb/Defuse Symbol
		HideEntity hud_symbols(1)
		;56 - Defuse
		If player\sweapon[8]=56 Then
			ShowEntity hud_symbols(1)
			EntityTexture hud_symbols(1), gfx_hud_symbols,3
			EntityColor hud_symbols(1),0,255,0
		EndIf
		;55 - Bomb
		If player\sweapon[7]=55 Then
			ShowEntity hud_symbols(1)
			EntityTexture hud_symbols(1), gfx_hud_symbols,6
			If player\tile_entity<>5 Then
				EntityColor hud_symbols(1),0,255,0
			Else
				If hud_blink Then
					EntityColor hud_symbols(1),255,0,0
				Else
					EntityColor hud_symbols(1),0,255,0
				EndIf
			EndIf
		EndIf

		;Progress
		If player\action>0 Then
			Local perc#,scale
			perc#=Float((Float(ms-player\actionstart)/Float(player\actiontotal-player\actionstart))*100.0)
			If perc#>100.0 Then perc#=100.0
			scale=(perc#*2.0)
			
			ScaleEntity hud_progress_bar,scale,26,1
			PositionEntity hud_progress_bar,((220)*2)-640+scale,-((261)*2)+480-26,640
			
			ShowEntity hud_progress
			ShowEntity hud_progress_bar
		Else
			HideEntity hud_progress
			HideEntity hud_progress_bar
		EndIf
		
		;Sniper
		;If player\weaponmode=0 Then
		;	HideEntity hud_sniper_main
		;Else
		;	;ShowEntity hud_sniper_main
		;	PositionEntity hud_sniper_main,((mx)*2)-640,-((my)*2)+480,0
		;	If player\weaponmode=1 Then
		;		EntityTexture hud_sniper(0),gfx_hud_sniper,0
		;	Else
		;		EntityTexture hud_sniper(0),gfx_hud_sniper,1
		;	EndIf			
		;EndIf
			
	Else
		HideEntity hud_main_living
		ShowEntity hud_main_dead
	EndIf
	
	;Scoreboard
	If op_bind_scores Then
		ShowEntity hud_board
	Else
		HideEntity hud_board
	EndIf
	
	;Blink
	If sp200go Then 
		hud_blink=1-hud_blink
	EndIf
		
End Function

;--------------------Scoreboard Zeichnen
Function hud_scoreboard()
	Local t=player_count(1)
	Local ct=player_count(2)
	Local spec=player_count(4)

	Local y=23
	Local x=23
	
	hud_txt(x,y,e_sv_name$+" ("+DottedIP(e_sv_ip)+":"+e_sv_port+")",0,0)
	hud_txt(x+370,y+2,"Score",0,0)
	hud_txt(x+430,y+2,"Deaths",0,0)
	hud_txt(x+500,y+2,"Ping",0,0)
	;hud_txt(x+573,y+2,"P2P",0,0)
	Color 100,100,100
	Rect 20,y+15,601,1
	Rect 19,19,603,442,0
	y=y+7
	
	
	If sp25go Then
		;Ordnen
		Local lowest,lowestid
		Local c=0
		Local i
		For pl.player=Each player
			pl\orderd=0
			pl\orderval=(pl\frags*10000)-(pl\deads*100)-pl\id
			c=c+1
		Next
		Dim order(c)
	
		;IDs in korrekter Reihenfolge in Array schreiben
		For i=1 To c
			lowest=999999999
			lowestid=-1
		
			For pl.player=Each player
				If pl\orderd=0 Then
					If pl\orderval<lowest Then
						lowestid=pl\id
						lowest=pl\orderval
					EndIf
				EndIf
			Next
			
			For pl.player=Each player
				If pl\id=lowestid Then
					pl\orderd=1
				EndIf
			Next
			
			order(i)=lowestid
		Next
		
		;Types nach der Reihenfolge im Array anordnen
		For i=1 To c
			For pl.player=Each player
				If pl\id=order(i) Then
					Insert pl Before First player
					Exit
				EndIf
			Next
		Next
	EndIf
	
	;Terrorists
	If t>0 Then
		y=y+23
		Color 100,0,0
		Rect 20,y+15,601,2
		If t<>1 Then
			hud_txt(x,y+2,"Terrorist Forces ("+t+" Players)",1,0)
		Else
			hud_txt(x,y+2,"Terrorist Forces (1 Player)",1,0)
		EndIf
		hud_txt(x+370,y+2,e_sv_score_t,1,0)
		y=y+2
		
		For player.player=Each player
			If player\team=1 Then
				y=y+18
				If player\id=e_player Then Rect 20,y-2,601,14
				hud_txt(x,y,player\name$,1,0)
				hud_txt(x+370,y,player\frags,1,0)
				hud_txt(x+430,y,player\deads,1,0)
				If player\id=e_server Then
					hud_txt(x+500,y,"0 (Server)",1,0)
				ElseIf player\bot Then
					hud_txt(x+500,y,"0 (Bot)",1,0)
				Else
					hud_txt(x+500,y,player\ping,1,0)
				EndIf
				If player\health<=0 Then
					hud_txt(x+300,y,"DEAD",1,0)
				ElseIf player\sweapon[7]=55 Then
					If e_team<>2 Then hud_txt(x+300,y,"BOMB",1,0)
				EndIf
				;<P2P>
				;If player\id<>e_player And player\bot=0 Then
				;	If player\udp_pinged Then
				;		DrawImage gfx_server,608,y,0
				;	Else
				;		DrawImage gfx_server,608,y,2
				;	EndIf
				;EndIf
			EndIf
		Next
	EndIf
	
	;Counter-Terrorists
	If ct>0 Then
		y=y+23
		Color 0,0,100
		Rect 20,y+15,601,2
		If ct<>1 Then
			hud_txt(x,y+2,"Counter-Terrorist Forces ("+ct+" Players)",2,0)
		Else
			hud_txt(x,y+2,"Counter-Terrorist Forces (1 Player)",2,0)
		EndIf
		hud_txt(x+370,y+2,e_sv_score_ct,2,0)
		y=y+2
		
		For player.player=Each player
			If player\team=2 Then
				y=y+18
				If player\id=e_player Then Rect 20,y-2,601,14
				hud_txt(x,y,player\name$,2,0)
				hud_txt(x+370,y,player\frags,2,0)
				hud_txt(x+430,y,player\deads,2,0)
				If player\id=e_server Then
					hud_txt(x+500,y,"0 (Server)",2,0)
				ElseIf player\bot Then
					hud_txt(x+500,y,"0 (Bot)",2,0)
				Else
					hud_txt(x+500,y,player\ping,2,0)
				EndIf
				If player\health<=0 Then
					hud_txt(x+300,y,"DEAD",2,0)
				ElseIf player\vip=1 Then
					hud_txt(x+300,y,"VIP",2,0)
				EndIf
				;<P2P>
				;If player\id<>e_player And player\bot=0 Then
				;	If player\udp_pinged Then
				;		DrawImage gfx_server,608,y,0
				;	Else
				;		DrawImage gfx_server,608,y,2
				;	EndIf
				;EndIf
			EndIf
		Next
	EndIf
	
	;Spectators
	If spec>0 Then
		y=y+23
		Color 50,50,50
		Rect 20,y+15,601,2
		If spec<>1 Then
			hud_txt(x,y+2,"Spectators ("+spec+" Players)",3,0)
		Else
			hud_txt(x,y+2,"Spectators (1 Player)",3,0)
		EndIf
		y=y+2
		
		For player.player=Each player
			If player\team<>1 And player\team<>2  Then
				y=y+18
				If player\id=e_player Then Rect 20,y-2,601,14
				hud_txt(x,y,player\name$,3,0)
				
				;<P2P>
				;If player\id<>e_player And player\bot=0 Then
				;	If player\udp_pinged Then
				;		DrawImage gfx_server,608,y,0
				;	Else
				;		DrawImage gfx_server,608,y,2
				;	EndIf
				;EndIf
			EndIf
		Next
		
	EndIf

End Function


;--------------------Radar Zeichnen/Updaten
Function hud_radar(draw=1,update=0)
	;Update
	If update Then
		If hud_radar_on Then
			SetBuffer ImageBuffer(gfx_radar)
			Color 0,0,0:Rect 0,0,106,106,1
			Local bx,by,bt	;Base x,y,team
			Local dis,ddir	;Distance+Winkel
			Local px,py		;Point x,y
			For player.player=Each player
				If player\id=e_player Then
					bx=player\x
					by=player\y
					bt=player\team
					Exit
				EndIf
			Next
			Local count_expected=player_count_living(bt)-1
			Local count_real=0
			;Player einzeichnen
			For player2.player=Each player
				If player2\health>0
					If player2\team=bt Then
						If player2\id<>e_player Then
							dis=Sqr((bx-player2\x)^2+(by-player2\y)^2)
							ddir=ATan2((player2\x)-(bx),(by)-(player2\y))
							dis=dis/16
							If dis>50 Then dis=50
							px=52+Sin(ddir)*dis
							py=53-Cos(ddir)*dis
							If player2\radio>ms And cursor=1 Then
								Color 255,255,0
								Rect px,py,3,3
							Else
								Color 200,200,255
								Rect px,py,2,2
							EndIf
							count_real=count_real+1
						EndIf
					EndIf
				EndIf
			Next
			;Bombe einzeichnen
			If map_gametype=3 Then
				If player\team=1 Then
					For item.item=Each item
						If item\typ=55 Or item\typ=100 Then
							dis=Sqr((bx-(item\x*32))^2+(by-(item\y*32))^2)
							ddir=ATan2(((item\x*32))-(bx),(by)-((item\y*32)))
							dis=dis/16
							If dis>50 Then dis=50
							px=52+Sin(ddir)*dis
							py=53-Cos(ddir)*dis
							Color 255,0,0
							If item\typ=55 Then
								Rect px,py,2,2
							Else
								WritePixel px,py,$FF0000
								WritePixel px-1,py-1,$FF0000
								WritePixel px+1,py-1,$FF0000
								WritePixel px-1,py+1,$FF0000
								WritePixel px+1,py+1,$FF0000
								WritePixel px-2,py-2,$FF0000
								WritePixel px+2,py-2,$FF0000
								WritePixel px-2,py+2,$FF0000
								WritePixel px+2,py+2,$FF0000
							EndIf
						EndIf
					Next
				EndIf
			EndIf
			
			;<<< Cheat >>>
			;If count_real>count_expected Then
			;	 player_leave(e_player,4,1)
			;EndIf
			
			SetBuffer BackBuffer()
		EndIf
	EndIf
	;Zeichnen
	If draw Then
		If e_active Then
			If hud_radar_on Then
				DrawImage gfx_radar,0,0
			EndIf
		EndIf
	EndIf
End Function


;--------------------Waffenauswahl
Function hud_wpnsel(slot)
	Local found,fslot,cslot
	For player.player=Each player
		If player\id=e_player Then
			If player\health>0 Then
				found=1
				Exit
			EndIf
		EndIf
	Next
	If found=0 Then Return 0
	Select slot
		;Primary
		Case 1
			If hud_slot<>1 Then
				e_play sfx_hudon
			Else
				e_play sfx_msel
			EndIf
			hud_slot=1
		;Secondary
		Case 2
			If hud_slot<>2 Then
				e_play sfx_hudon
			Else
				e_play sfx_msel
			EndIf
			hud_slot=2
		;Knife
		Case 3
			If hud_slot<>3 Then
				e_play sfx_hudon
			Else
				e_play sfx_msel
			EndIf
			hud_slot=3
		;Grenade
		Case 4
			If hud_slot<4 Or hud_slot>7 Then
				;Ersten belegten Grenade Slot whlen
				fslot=0
				If player\sweapon[3]<>0 Then fslot=1:hud_slot=4
				If fslot=0 And player\sweapon[4]<>0 Then fslot=1:hud_slot=5
				If fslot=0 And player\sweapon[5]<>0 Then fslot=1:hud_slot=6
				If fslot=0 And player\sweapon[6]<>0 Then fslot=1:hud_slot=7
				e_play sfx_hudon
			Else
				;Nchsten belegten Grenade Slot whlen
				e_play sfx_msel
				fslot=0
				cslot=hud_slot
				While fslot=0
					cslot=cslot+1
					If cslot=8 Then cslot=4
					If player\sweapon[cslot-1]<>0 Then
						hud_slot=cslot
						fslot=1
					EndIf
				Wend
			EndIf
		;Bomb
		Case 5
			If hud_slot<>8 Then
				e_play sfx_hudon
			Else
				e_play sfx_msel
			EndIf
			hud_slot=8
	End Select
	
	;Fastswitch
	If op_fastswitch=1 Then
		Local selc
		If hud_slot<4 Or hud_slot>7 Then
			selc=0
			If hud_slot>0 And hud_slot<16 Then
				If player\sweapon[hud_slot-1]<>0 Then selc=1
			EndIf
		Else
			selc=0
			If player\sweapon[3]<>0 Then selc=selc+1
			If player\sweapon[4]<>0 Then selc=selc+1
			If player\sweapon[5]<>0 Then selc=selc+1
			If player\sweapon[6]<>0 Then selc=selc+1
		EndIf
		If selc=1 Then
			player\action=0
			player_weapon(player\id, hud_slot-1, player\sweapon[hud_slot-1])
			hud_slot=0
		ElseIf selc=0 Then
			hud_slot=0
		EndIf
	EndIf
	
	Return 1
End Function

;--------------------Waffenauswahl anzeigen
Function hud_wpnsel_render()
	For player.player=Each player
		If player\id=e_player Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If player\health<=0 Then Return 0
	If hud_slot=0 Then Return 0
	SetFont font_norm
	
	Local x=110
	Local y=0
	
	Local slotsel
	
	;Slot 1
	y=0
	If hud_slot=1 Then
		Color 255,255,0
		Text x,y,"[1]"
		y=y+20
		Text x,y,weapon_name$(player\sweapon[0])
		x=x+100
	Else
		If player\sweapon[0]<>0 Then
			Color 170,170,0
		Else
			Color 200,0,0
		EndIf
		Text x,y,"[1]"
		x=x+20
	EndIf
	
	;Slot 2
	y=0
	If hud_slot=2 Then
		Color 255,255,0
		Text x,y,"[2]"
		y=y+20
		Text x,y,weapon_name$(player\sweapon[1])
		x=x+100
	Else
		If player\sweapon[1]<>0 Then
			Color 170,170,0
		Else
			Color 200,0,0
		EndIf
		Text x,y,"[2]"
		x=x+20
	EndIf
	
	;Slot 3
	y=0
	If hud_slot=3 Then
		Color 255,255,0
		Text x,y,"[3]"
		y=y+20
		Text x,y,weapon_name$(player\sweapon[2])
		x=x+100
	Else
		If player\sweapon[2]<>0 Then
			Color 170,170,0
		Else
			Color 200,0,0
		EndIf
		Text x,y,"[3]"
		x=x+20
	EndIf
	
	;Slot 4
	y=0
	If hud_slot>3 And hud_slot<8 Then
		Color 255,255,0
		Text x,y,"[4]"
		;Subs
		For i=3 To 6
			If player\sweapon[i]<>0 Then
				If hud_slot=(i+1) Then
					Color 255,255,0
				Else
					Color 170,170,0
				EndIf
				y=y+20
				Text x,y,weapon_name$(player\sweapon[i])
			EndIf
		Next
		x=x+100
	Else
		If (player\sweapon[3]+player\sweapon[4]+player\sweapon[5]+player\sweapon[6])<>0 Then
			Color 170,170,0
		Else
			Color 200,0,0
		EndIf
		Text x,y,"[4]"
		x=x+20
	EndIf
	
	;Slot 5
	y=0
	If hud_slot=8 Then
		Color 255,255,0
		Text x,y,"[5]"
		y=y+20
		Text x,y,weapon_name$(player\sweapon[7])
		x=x+100
	Else
		If player\sweapon[7]<>0 Then
			Color 170,170,0
		Else
			Color 200,0,0
		EndIf
		Text x,y,"[5]"
		x=x+20
	EndIf
End Function

;--------------------Spectating Anzeigen
Function hud_spectate()
	Local foundplayer,changed
	;Offset
	hud_loff=40
	hud_roff=40
	;DEAD, Spectating
	hud_txt(320, 10, "You are dead!", 1, 1)
	hud_txt(320, 22, "Spectating", 3, 1)
	;Spiel Daten Anzeigen
	hud_txt(639,10, "Time left: "+e_rt_m+":"+e_rt_s, 3, 2)
	For player.player=Each player
		If player\id=e_player Then
			If player\team=1 Or player\team=2 Then
				hud_txt(639,22, "$ "+player\money, 3, 2)
			EndIf
		EndIf
	Next
	
	;Hurts killen
	For hud_hurt.hud_hurt=Each hud_hurt
		FreeEntity hud_hurt\h
		Delete hud_hurt
	Next
	
	
	;Map gerade geladen? -> Briefing und zwischen Basepoints wechseln
	If hud_mapload Then
		hud_spec_screen=1
		If sp3000go Then
			While found=0
				For entity.entity=Each entity
					If entity\typ<4 Then
						If Rand(50)=1 Then
							found=1
							e_x=entity\x-9
							e_y=entity\y-7
							Exit
						EndIf
					EndIf
				Next
			Wend
		EndIf
	EndIf
		
	;Options
	Select hud_spec_screen
		;0 - None
		Case 0
			hud_txt(100,455,"None", 3, 1)
			If hud_body<>0 Then HideEntity hud_body
		;1 - Briefing
		Case 1
			hud_txt(100,455,"Briefing", 3, 1)
			If map_briefing Then
				For i=0 To 17
					hud_txt(130, 60+(i*15), map_info$(i), 3, 0)
				Next
				If hud_body<>0 Then ShowEntity hud_body
			Else
				hud_txt(130, 60, map_name$, 3, 0)
				hud_txt(130, 60+30, "No Briefing for this Map", 1, 0)
				If hud_body<>0 Then ShowEntity hud_body
			EndIf
			Select map_gametype
				Case 1 DrawImage gfx_hud_icons, 484,55,0
				Case 2 DrawImage gfx_hud_icons, 484,55,1
				Case 3 DrawImage gfx_hud_icons, 484,55,2
				Default  DrawImage gfx_hud_icons, 484,55,3
			End Select
			hud_txt(465,410,"Close", 3, 1)
			If hud_rect(465-50,405,100,20) Then
				hud_mapload=0
				hud_spec_screen=0
			EndIf
		;2 - Minimap
		Case 2
			hud_txt(100,455,"Minimap", 3, 1)
			If hud_body<>0 Then ShowEntity hud_body
			If sp200go Then
				If e_sv_warmode=0 Then
					e_minimap(1,0)
				Else
					e_minimap(0,1)
				EndIf
			EndIf
			;DrawBlock gfx_minimap,270,190
			;Zoom Minimap
			;X
			For x=0 To 100
				CopyRect x,0,1,200,(x)*2,0,ImageBuffer(gfx_minimap),ImageBuffer(gfx_minimap2)
				CopyRect x,0,1,200,(x)*2+1,0,ImageBuffer(gfx_minimap),ImageBuffer(gfx_minimap2)
			Next
			;Y
			For y=100 To 0 Step -1
				CopyRect 0,y,200,1,0,y*2,ImageBuffer(gfx_minimap2),ImageBuffer(gfx_minimap2)
				CopyRect 0,y,200,1,0,y*2+1,ImageBuffer(gfx_minimap2),ImageBuffer(gfx_minimap2)
			Next
			;Draw
			DrawBlock gfx_minimap2,270-50,190-50
			
			hud_txt(130, 60, "Minimap", 3, 0)
			DrawImage gfx_hud_icons, 484,55,4
			hud_txt(465,410,"Close", 3, 1)
			If hud_rect(465-50,405,100,20) Then
				hud_spec_screen=0
			EndIf
	End Select
	If hud_spec_screen>0 Then
		If e_sv_warmode Then DrawImage gfx_hud_icons, 484,55+32+5,5
	EndIf
	If hud_rect(100-50,450,100,20) Then
		hud_spec_screen=hud_spec_screen+1
		If hud_spec_screen=3 Then hud_spec_screen=0
		hud_mapload=0
	EndIf
		
	;Player
	If hud_spec_mode=1 Then
		foundplayer=0
		For player.player=Each player
			If player\id=hud_spec_player Then
				If player\health>0 Then
					If player\team=1 Or player\team=2 Then
						hud_txt(320, 455, player\name$+" ("+player\health+")", player\team, 1)
						foundplayer=1
						Exit
					EndIf
				EndIf
			EndIf
		Next
		If foundplayer=0 Then hud_txt(320, 455, "No Player", 3, 1)
	Else
		hud_txt(320, 455, "No Player", 3, 1)
	EndIf
	If hud_rect(320-120,450,240,20) Then
		com_specplayer()
	EndIf
	
	;Mode
	If e_sv_warmode=1 Then
		hud_spec_mode=0
		e_x=-100
		e_y=-100
	EndIf
	Select hud_spec_mode
		Case 0
			hud_txt(540,455,"Free Look", 3, 1)
		Case 1
			hud_txt(540,455,"Follow", 3, 1)
			If foundplayer Then
				e_scroll2player(hud_spec_player)
				For player.player=Each player
					If player\id=hud_spec_player
						If player\health>0 Then
							If cursor Then
								Color 160,160,160
							Else
								Color 255,255,255
							EndIf
							xo1#=Sin(player\dir)*40
							yo1#=-Cos(player\dir)*40
							xo2#=Sin(player\dir)*198
							yo2#=-Cos(player\dir)*198
							Line player\x+16+xo1#+e_px-(e_x*32), player\y+16+yo1#+e_py-(e_y*32),  player\x+16+xo2#+e_px-(e_x*32), player\y+16+yo2#+e_py-(e_y*32)
						EndIf
					EndIf
				Next
			EndIf
	End Select
	If hud_rect(540-50,450,100,20) Then
		com_specmode()
	EndIf
	
	;Zoom
	If md2 Then hud_zoomrect(mx,my)
	
	;Player auf die Mitte der Ansicht setzen
	For player.player=Each player
		If player\id=e_player Then
			player\x=(e_x+9)*32
			player\y=(e_y+7)*32
			Exit
		EndIf
	Next

End Function



;HUD Rect
Function hud_rect(x,y,xsize,ysize)
	over=0
	If mx>=x Then
		If my>=y Then
			If mx<=x+xsize Then
				If my<=y+ysize Then
					over=1
				EndIf
			EndIf
		EndIf
	EndIf
	If over Then
		Color 255,255,255
	Else
		Color 160,160,160
	EndIf
	Rect x,y,xsize,ysize,0
	If over Then
		If mh Then Return 1
	EndIf
	Return 0
End Function


;HUD FPS
Function hud_netgraph(x,y)
	Color 50,50,50
	Rect x,y,110,35
	
	hud_txt(x+1,y+1,"FPS: "+fps,3)
	hud_txt(x+1,y+12,"UP: "+e_sendbytes+"b/s",1)
	hud_txt(x+1,y+23,"DOWN: "+e_getbytes+"b/s",0)
End Function

;HUD Zoomrect
Function hud_zoomrect(rx,ry)
	rx=rx-30
	ry=ry-20
	;X
	For x=rx To rx+60
		CopyRect x,ry,1,40,(x-rx)*2,0,BackBuffer(),ImageBuffer(gfx_rzoom)
		CopyRect x,ry,1,40,(x-rx)*2+1,0,BackBuffer(),ImageBuffer(gfx_rzoom)
	Next
	;Y
	For y=80 To 0 Step -1
		CopyRect 0,y,640,1,0,y*2,ImageBuffer(gfx_rzoom),ImageBuffer(gfx_rzoom)
		CopyRect 0,y,640,1,0,y*2+1,ImageBuffer(gfx_rzoom),ImageBuffer(gfx_rzoom)
	Next
	;Draw
	DrawBlock gfx_rzoom,rx-30,ry-20
	Color 0,0,0
	Rect rx-31,ry-21,122,82,0
	Color 160,160,160
	Rect rx-32,ry-22,124,84,0
End Function

;HUD Zoom
Function hud_zoom()
	rx=mx-160
	ry=my-120
	If rx<0 Then
		rx=0
	ElseIf rx>640-320 Then
		rx=640-320
	EndIf
	If ry<0 Then
		ry=0
	ElseIf ry>480-240 Then
		ry=480-240
	EndIf
	;X
	For x=rx To rx+320
		CopyRect x,ry,1,480,(x-rx)*2,0,BackBuffer(),ImageBuffer(gfx_zoom)
		CopyRect x,ry,1,480,(x-rx)*2+1,0,BackBuffer(),ImageBuffer(gfx_zoom)
	Next
	;Y
	For y=240 To 0 Step -1
		CopyRect 0,y,640,1,0,y*2,ImageBuffer(gfx_zoom),ImageBuffer(gfx_zoom)
		CopyRect 0,y,640,1,0,y*2+1,ImageBuffer(gfx_zoom),ImageBuffer(gfx_zoom)
	Next
	;Draw
	DrawBlock gfx_zoom,0,0
End Function