;----------------------------------------TCP

;Server aus dem USGN laden
Function tcp_getserver(checkv=1)
	Local stream, v$, count$, status$, cacheip$, cacheport$, i, ok, ping,msl
	usgn_got=1
	con_add("",0)
	con_add("USGN: Connecting ...",0)
	ping=MilliSecs()
	stream=OpenTCPStream(usgn_dom$,80)
	If stream=0 Then con_add("Error: Can't initiale Connection",0):Return 0
	con_add("USGN: Connection successful (Ping: "+(MilliSecs()-ping)+"ms)",0)
	;WriteLine stream, "GET "+usgn_path$+"sv_load"+usgn_ext$+"game=Counter-Strike%202D"
	WriteLine stream, "GET "+usgn_path$+"/games/Counter-Strike%202D.usgn_out"
	
	;Status
	status$=ReadLine(stream)
	Select status$
		Case 1,2
		Case 0 con_add("Error: USGN is offline",0)
		Case "" CloseTCPStream(stream):con_add("Error: No USGN Response. USGN seems to be offline or busy. Try again later",0):Return 0
		Default
			CloseTCPStream(stream)
			If Left(status$,1)="<" Then
				con_add("Error: USGN is offline",0)
			Else
				con_add("Error: Unknown USGN Response ("+status$+")",0)
			EndIf
			Return 0
	End Select
	
	;Version
	v$=ReadLine(stream)
	v$=Trim(v$)
	If v$="" Then
		con_add("Error: Can't load Version Infomarations",0)
	Else
		con_add("USGN: Latest Version of Counter-Strike 2D is "+v$,0)
		If version$<>v$ Then
			men_msg("CS2D is out of Date! You need "+v$,2,50)
			Return -1
		EndIf
	EndIf
	
	;Count
	count$=ReadLine(stream)
	count$=Trim(count$)
	If count$="" Then
		con_add("Error: Can't load Server Informations",0)
		CloseTCPStream(stream)
		Return 0
	Else
		If status$<>0 Then
			Select count$
				Case 0 con_add("USGN: Found NO Game Servers",0)
				Case 1 con_add("USGN: Found 1 Game Server",0)
				Default con_add("USGN: Found "+count$+" Game Servers",0)
			End Select
		EndIf
	EndIf
	
	;Servers
	msl=MilliSecs()
	For serv.serv=Each serv
		Delete serv
	Next
	serv_c=count$
	ok=0
	For i=1 To count$
		cacheip$=""
		cacheport$=""
		cacheip$=ReadLine(stream)
		cacheip$=Trim(cacheip$)
		cacheport$=ReadLine(stream)
		cacheport$=Trim(cacheport$)
		If cacheip$="" Then
			If status$<>0 Then con_add("Error: Can't load Informations of Sever "+i,0)
		Else
			serv.serv=New serv
			serv\ip=udp_int(cacheip$)
			serv\port=cacheport$
			serv\cont=(msl-3200)+(i*50)
			ok=ok+1
		EndIf
	Next
	If status$=0 Then 
		For serv.serv=Each serv
			Delete serv
		Next
	EndIf
	
	;MSG
	Dim men_msgs$(4)
	msgc$=""
	msgc$=ReadLine(stream)
	Trim(msgc$)
	Dim splits$(10)
	split(msgc$, "|")
	men_msgs$(0)=splits$(0)
	men_msgs$(1)=splits$(1)
	men_msgs$(2)=splits$(2)
	men_msgs$(3)=splits$(3)
	men_msgs$(4)=splits$(4)
	con_add("",0,1)
	CloseTCPStream(stream)
	msgstream=ReadFile("temp/usgn_msg.inf")
	oldmsg$=""
	If msgstream<>0 Then
		oldmsg$=ReadLine(msgstream)
		CloseFile(msgstream)
	EndIf
	msgstream=WriteFile("temp/usgn_msg.inf")
	If msgstream<>0 Then
		WriteLine(msgstream,msgc$)
		CloseFile(msgstream)
	EndIf
	If oldmsg$<>msgc$ Then
		men_set(29)
		Return -2
	EndIf
	
	
	usgn_got=1
	Return 1
	
End Function


;Server im USGN speichern
Function tcp_setserver(port)
	Local stream, v$, count$, status$, ip$
	con_add("",0)
	con_add("USGN: Connecting ...",0)
	ping=MilliSecs()
	stream=OpenTCPStream(usgn_dom$,80)
	If stream=0 Then con_add("Error: Can't initiale Connection",0):Return 0
	con_add("USGN: Connection successful (Ping: "+(MilliSecs()-ping)+"ms)",0)
	con_add("USGN: Adding Server to Database ...",0)
	WriteLine stream, "GET "+usgn_path$+"sv_save"+usgn_ext$+"game=Counter-Strike%202D&port="+port
	
	;Status
	status$=ReadLine(stream)
	ip$=ReadLine(stream)
	CloseTCPStream(stream)
	Select status$
		Case 1 con_add("USGN: Server added!",0):Return udp_int(ip$)
		Case 0 con_add("Error: Can't add Server.",0):Return 0
		Case "" con_add("Error: No USGN Response. USGN seems to be offline or busy. Try again later",0):Return 0
		Default con_add("Error: Unknown USGN Response ("+status$+")",0):Return 0
	End Select
End Function



;Server aus USGN lschen
Function tcp_killserver(ip$,u=0)
	Local stream,i
	
	If ip$="0.0.0.0" Then Return 0
	
	;Key
	break1 = Instr(ip$,".")
	break2 = Instr(ip$,".",break1+1)
	break3 = Instr(ip$,".",break2+1)
	add1 = Mid(ip$,1,break1-1)
	add2 = Mid(ip$,break1+1,break2-1)
	add3 = Mid(ip$,break2+1,break3-1)
	add4 = Mid(ip$,break3+1)
	key=add1*3
	key=key+add2*8
	key=key-add3
	key=key+add4*5
	key=key-9346
	
	stream=OpenTCPStream(usgn_dom$,80)
	If stream=0 Then Return 0
	If u=1 Then
		WriteLine stream, "GET "+usgn_path$+"sv_kill"+usgn_ext$+"game=Counter-Strike%202D&ip="+ip$+"&key="+Str(key)+"&u=1"
	Else
		WriteLine stream, "GET "+usgn_path$+"sv_kill"+usgn_ext$+"game=Counter-Strike%202D&ip="+ip$+"&key="+Str(key)
	EndIf
	status$=ReadLine(stream)
	CloseTCPStream(stream)
	Select status$
		;1 - Killed
		Case 1
			con_add("USGN: Killed Server "+ip$+".",0,1)
			For serv.serv=Each serv
				If serv\ip=udp_int(ip$) Then
					Delete serv
					Exit
				EndIf
			Next
			Return 1
		;Default - Not Killed
		Default
			con_add("USGN: Unable to kill Server "+ip$+".",0,1)
			Return 0
	End Select
End Function

;Als Gameadmin anmelden
Function tcp_gameadmin(pas$)
	Local stream
	con_add("",0)
	stream=OpenTCPStream(usgn_dom$,80)
	If stream=0 Then con_add("Error",0):Return 0
	WriteLine stream, "GET "+usgn_path$+"sv_admin"+usgn_ext$+"game=Counter-Strike%202D&pas="+pas$
	
	;Status
	status$=ReadLine(stream)
	CloseTCPStream(stream)
	Select status$
		Case 1 con_add("Game Admin requested successfully",0)
				admin=1
				admin_ch=5
				For player.player=Each player
					If player\id=e_player Then
						player\gameadmin=1
						Exit
					EndIf
				Next
				Return 1
		Case 2 con_add("Game Admin request failed",0):Return 0
		Default con_add("Error",0):Return 0
	End Select
End Function