;Counter-Strike 2D
;2003-2004 Unreal Software
;www.unrealsoftware.de

;----------------------------------------Includes

;Includes
Include "includes/load_keys.bb"
Include "includes/load_fonts.bb"
Include "includes/load_entities.bb"
Include "includes/load.bb"
Include "includes/load_weapons.bb"
Include "includes/load_radio.bb"
Include "includes/hud.bb"
Include "includes/console.bb"
Include "includes/commands.bb"
Include "includes/parser.bb"
Include "includes/functions.bb"
Include "includes/engine.bb"
Include "includes/effects.bb"
Include "includes/menu.bb"
Include "includes/tcp.bb"
Include "includes/udp.bb"
Include "includes/game.bb"
Include "includes/game_basic.bb"
Include "includes/game_game.bb"
Include "includes/game_misc.bb"
Include "includes/game_entities.bb"
Include "includes/bots.bb"
Include "includes/bots_functions.bb"
Include "includes/editor.bb"
Include "includes/irc.bb"
Include "includes/transfer.bb"

;Version & Autoexec
parse("version")
parse("exec autoexec.cfg")
con_add("",0,0)

;----------------------------------------Intro
.intro
leave=0
Repeat
	If cmd_startup=1 And op_particles=1 Then
		men_intro()
	Else
		leave=1
		Exit
	EndIf
	If leave<>0 Then Exit
Forever
Select leave
	Case 0 Goto intro
	Case 1 Goto menu
	Case 2 Goto game
	Case 3 Goto editor
End Select

;----------------------------------------Menu
.menu
leave=0
Repeat
	men_render()
	If leave<>0 Then Exit
Forever
Select leave
	Case 0 Goto intro
	Case 1 Goto menu
	Case 2 Goto game
	Case 3 Goto editor
End Select


;----------------------------------------Game
.game
leave=0
e_ini()
Repeat
	game()
	If leave<>0 Then Exit
Forever
e_cls()
con_add("---Quit Game",0,1):con_add("",0,1)
men_refresh=ms-9000
men_update=ms-2000
Select leave
	Case 0 Goto intro
	Case 1 Goto menu
	Case 2 Goto game
	Case 3 Goto editor
End Select

;----------------------------------------Editor
.editor
ed_ini()
leave=0
:con_add("",0,1):con_add("---Editor",0,1):con_add("",0,1)
Repeat
	ed_render()
	If leave<>0 Then Exit
Forever
ed_cls()
con_add("---Quit Editor",0,1):con_add("",0,1)
Select leave
	Case 0 Goto intro
	Case 1 Goto menu
	Case 2 Goto game
	Case 3 Goto editor
End Select