;----------------------------------------Console

;--------------------Console Rendern
Function con_render(update, speed=1, maxout=480, allowmaxmin=1)
	Local i,y
	
	;Scroll
	If update Then
		If con_mode=1 Then
			If con_y>=maxout Then
				con_y=maxout
				con_mode=0
			Else
				con_y=con_y+speed
			EndIf
		ElseIf con_mode=2
			If con_y<=0 Then
				con_y=0
				con_mode=0
			Else
				con_y=con_y-speed
			EndIf
		EndIf
	EndIf
	
	;Draw
	PositionEntity con_sprite,(0)-320+320,-(-480+con_y)-240+240,320
	DrawImage gfx_conbuf,0,-480+con_y
	If cursor Then
		hud_txt(2, -17+con_y, con_in$+"|", 0)
	Else
		hud_txt(2, -17+con_y, con_in$, 0)
	EndIf
	
	;Maximize/Minimize
	If allowmaxmin Then
		If KeyHit(41) Then
			FlushKeys():key=0
			If con_mode=0 Then
				If con_y=0 Then
					con_mode=1
				Else
					con_mode=2
				EndIf
			Else
				If con_mode=1 Then
					con_mode=2
				Else
					con_mode=1
				EndIf
			EndIf
		EndIf
	EndIf
	
	;Input
	If con_mode=0 Then
		If con_y>=maxout Then
			;Input
			If key>31 Then con_in$=con_in$+Chr(key)
			
			;Delete
			If keydelete=1 Or (keydeletedown=1 And (ms-keydeletelast>70)) Then
				If Len(con_in$)>0 Then
					keydeletedown=0:keydeletelast=ms
					If keydelete=1 Then keydelete=0:keydeletelast=ms+500
					con_in$=LSet(con_in$, Len(con_in$)-1)
				EndIf
			EndIf
			
			;Enter
			If KeyHit(28) Then
				parse(con_in$,0)
				If con_in$<>"" Then con_lin$=con_in$
				con_in$=""
			EndIf
			
			;Recover Last Input
			If KeyHit(200) Then con_in$=con_lin$
			
			;Cut / Copy / Paste
			If KeyDown(29) Then
				If KeyHit(47) Then
					con_in$=paste$()
					If Len(con_in$)>50 Then con_in$=Left(con_in$,50)
				ElseIf KeyHit(46) Then
					copy(con_in$)
				ElseIf KeyHit(45) Then
					copy(con_in$)
					con_in$=""
				EndIf
			EndIf
		EndIf
	EndIf
	
End Function

;--------------------Consolen Zeile Hinzufgen
Function con_add(txt$, parse=1, update=1)
	Local i
	For i=100 To 1 Step -1
		con_txt$(i)=con_txt$(i-1)
	Next
	con_txt$(0)=txt$
	;Parsen
	If parse Then parse(txt$,0)
	;Console Buffer Updaten
	If update Then
		con_update()
	EndIf
	;Debuglog
	If op_debug_log Then
		WriteLine(logfile,"["+CurrentTime()+"] "+txt$)
	EndIf
End Function

;--------------------Console Buffer Updaten
Function con_update()
	If gfx_conbuf=0 Then Return 0
	SetBuffer ImageBuffer(gfx_conbuf)
	Color 0,0,0
	Rect 0,0,640,480,1
	For i=0 To 31
		hud_txt(2, -32+480-(i*15), con_txt$(i), 3)
	Next
	SetBuffer BackBuffer()
End Function