;----------------------------------------Editor

;Editor initialisieren
Function ed_ini()
	Local x,y,i,c
	load_screen("Loading Editor")

	;Engine Stuff
	e_cls()
	
	;Console hiden
	PositionEntity con_sprite,(0)-320+320,-(-480)-240+240,320

	;Grid Image
	gfx_grid=CreateImage(640,480)
	SetBuffer ImageBuffer(gfx_grid)
	Color 56,72,106
	For x=0 To 20
		For y=0 To 15
			Rect x*32,y*32,33,33,0
		Next
	Next
	SetBuffer BackBuffer()
	
	;Editor Standart Einstellungen
	ed_tile_mc=0
	
	;Map Standart Einstellungen
	map_code=0
	map_name$="noname"
	map_tileset$="normal.bmp"
	map_tilesc=0
	map_xsize=100
	map_ysize=100
	map_back$=""
	map_back_h=0
	map_back_x=0
	map_back_y=0
	map_back_scr_x=0
	map_back_scr_y=0
	map_bg_r=0
	map_bg_g=0
	map_bg_b=0
	ClsColor map_bg_r,map_bg_g,map_bg_b
	Dim map(map_xsize,map_ysize,3)
	
	;Editor Entity Liste
	c=0
	For i=0 To 255
		If entity_name$(i)<>"" Then c=c+1
	Next
	ed_list_c=c-1
	ed_list_sel=0
	ed_list_scr=0
	Dim ed_entity_ln$(ed_list_c)
	Dim ed_entity_lid(ed_list_c)
	x=0
	For i=0 To 255
		If entity_name$(i)<>"" Then
			ed_entity_ln$(x)=entity_name$(i)
			ed_entity_lid(x)=i
			x=x+1
		EndIf
	Next
	
	;Editor Sprite
	ed_sprite=CreateSprite(cam)
	ScaleSprite ed_sprite, 32,32
	EntityColor ed_sprite, 255,255,0
	EntityFX ed_sprite,1
	EntityAlpha ed_sprite, 0.5
	EntityOrder ed_sprite, order_hud_area
	
	;Standart Tiles laden
	e_loadtiles(map_tileset$,1)
	
	;Render Offset
	e_px=170
	e_py=0
	
	;Einstellungen
	men_ch(0)=1
	men_ch(1)=1
	men_ch(2)=1
	men_ch(3)=1
	men_ch(4)=0
	men_ch(5)=1
	ed_minimap=1
	
	;Menu 50 (New)
	ed_set(50)
End Function

;Editor schliessen
Function ed_cls()
	
	;Grid Image
	FreeImage gfx_grid
	
	;Editor Sprite
	FreeEntity ed_sprite
	
	;Editor Cache lschen
	Dim ed_cache(0,0)
	
	;Engine Stuff
	e_cls()
	
End Function

;Editor Men Setzen
Function ed_set(men)
	ed_men=men
	Select men
	
		Case 50
			men_in$(0)=""
			men_in$(1)=0
			men_in$(2)=0
			men_in$(3)=0
			men_in$(4)=0
			men_in$(5)=0
			men_in$(6)="normal.bmp"
			men_in$(7)=100
			men_in$(8)=100
		
		Case 55
			men_in$(0)=map_back$
			men_in$(1)=map_back_scr_x
			men_in$(2)=map_back_scr_y
			men_in$(3)=map_bg_r
			men_in$(4)=map_bg_g
			men_in$(5)=map_bg_b
			men_in$(6)=map_tileset$
			men_in$(7)=map_xsize
			men_in$(8)=map_ysize
			men_ch(6)=map_back_scr_tile
			
		Case 51
			men_in$(0)=""
		
		Case 52,53
			men_in$(0)=map_name$
		
	
	End Select
End Function

;Editor Obstacles
Function ed_obstacles()
	Local x,y,xp,yp,sx,sy,ex,ey	
	xp=e_px
	yp=e_py
	sx=e_x
	sy=e_y
	ex=e_x+20
	ey=e_y+15
	If ex>map_xsize Then ex=map_xsize
	If ey>map_ysize Then ey=map_ysize
	x=0
	y=0
	For x=sx To ex
		yp=e_py
		For y=sy To ey
			If x>=0 Then
				If y>=0 Then
					Select map(x,y,3)
						Case 0
						Case 1 DrawImage gfx_editor,xp,yp,0
						Case 2 DrawImage gfx_editor,xp,yp,1
						Case 3 DrawImage gfx_editor,xp,yp,0 
						Case 10,11,12,13,14,15
						Default DrawImage gfx_editor,xp,yp,2
					End Select
				EndIf
			EndIf
			yp=yp+32
		Next
		xp=xp+32
	Next
End Function

;Editor Entities (zeichnen)
Function ed_entities()
	Local x,y,xp,yp,sx,sy,ex,ey
	Color 56,72,106
	sx=e_x
	sy=e_y
	ex=e_x+20
	ey=e_y+15
	If ex>map_xsize Then ex=map_xsize
	If ey>map_ysize Then ey=map_ysize
	xp=e_px
	yp=e_py
	For entity.entity = Each entity
		x=entity\x
		y=entity\y
		If x>=sx Then
			If x<=ex Then
				If y>=sy Then
					If y<=ey Then
						Select entity\typ
							;0 - T Base
							Case 0 DrawImage gfx_editor,x*32+xp-(e_x*32),y*32+yp-(e_y*32),6
							;1 - CT Base
							Case 1 DrawImage gfx_editor,x*32+xp-(e_x*32),y*32+yp-(e_y*32),7
							;25 - Breakable
							Case 25 DrawImage gfx_editor,x*32+xp-(e_x*32),y*32+yp-(e_y*32),0
									DrawImage gfx_editor,x*32+xp-(e_x*32),y*32+yp-(e_y*32),3
							;X - Globals
							Case 8,9,10,11,52
									DrawImage gfx_editor,x*32+xp-(e_x*32),y*32+yp-(e_y*32),5
							;Default
							Default DrawImage gfx_editor,x*32+xp-(e_x*32),y*32+yp-(e_y*32),3
						End Select
					EndIf
				EndIf
			EndIf
		EndIf	
	Next
End Function

;Editor Waypoints (zeichnen)
Function ed_waypoints(links=1)
	Local x,y,xp,yp,sx,sy,ex,ey
	Local wp1x,wp1y,wp2x,wp2y
	SetFont font_norm
	Color 255,255,0
	sx=e_x
	sy=e_y
	ex=e_x+20
	ey=e_y+15
	If ex>map_xsize Then ex=map_xsize
	If ey>map_ysize Then ey=map_ysize
	xp=e_px
	yp=e_py
	;Waypoints
	For pf_wp.pf_wp = Each pf_wp
		x=pf_wp\x
		y=pf_wp\y
		If x>=sx Then
			If x<=ex Then
				If y>=sy Then
					If y<=ey Then
						DrawImage gfx_editor,x*32+xp-(e_x*32),y*32+yp-(e_y*32),4
						Text x*32+xp-10-(e_x*32),y*32+yp-(e_y*32),pf_wp\id
					EndIf
				EndIf
			EndIf
		EndIf	
	Next
	;Links
	If links Then
		For pf_link.pf_link=Each pf_link
			For pf_wp.pf_wp=Each pf_wp
				If pf_wp\id=pf_link\wp1 Then
					wp1x=pf_wp\x
					wp1y=pf_wp\y
					Exit
				EndIf
			Next
			If pf_link\wp2>-1 Then
				For pf_wp.pf_wp=Each pf_wp
					If pf_wp\id=pf_link\wp2 Then
						wp2x=pf_wp\x
						wp2y=pf_wp\y
						Exit
					EndIf
				Next
				Line wp1x*32+16+xp-(e_x*32),wp1y*32+16+yp-(e_y*32),wp2x*32+16+xp-(e_x*32),wp2y*32+16+yp-(e_y*32)
			Else
				Line wp1x*32+16+xp-(e_x*32),wp1y*32+16+yp-(e_y*32),mx,my
			EndIf
		Next
	EndIf
End Function


;Editor Map Skalieren
Function ed_scalemap(xs,ys)
	Local x,y,tx,ty
	
	;Gren Maximum (x*y<99999)
	While xs*ys>99999
		xs=xs-1
		ys=ys-1
	Wend
	
	;Gren Minimum (2*2)
	If xs<2 Then xs=2
	If ys<2 Then ys=2
	
	;Cachen
	Dim map_c(map_xsize,map_ysize,3)
	For x=0 To map_xsize
		For y=0 To map_ysize
			map_c(x,y,0)=map(x,y,0)
			map_c(x,y,1)=map(x,y,1)
			map_c(x,y,2)=map(x,y,2)
			map_c(x,y,3)=map(x,y,3)
		Next
	Next
	
	;Scalen
	Dim map(xs,ys,3)
	
	;Cache laden
	tx=map_xsize
	ty=map_ysize
	If xs<tx Then tx=xs
	If ys<ty Then ty=ys
	For x=0 To tx
		For y=0 To ty
			map(x,y,0)=map_c(x,y,0)
			map(x,y,1)=map_c(x,y,1)
			map(x,y,2)=map_c(x,y,2)
			map(x,y,3)=map_c(x,y,3)
		Next
	Next
	
	;Cache lschen, gre Speichern
	Dim map_c(0,0,3)
	map_xsize=xs
	map_ysize=ys
End Function

;Editor rendern
Function ed_render()

	;Cachen
	speed()
	mxo=mx
	myo=my
	mx=MouseX()
	my=MouseY()
	mz=MouseZSpeed()
	mh=MouseHit(1)
	md=MouseDown(1)
	mh2=MouseHit(2)
	md2=MouseDown(2)
	mh3=MouseHit(3)
	md3=MouseDown(3)
	key=GetKey()
	keydelete=KeyHit(14)
	keydeletedown=KeyDown(14)
	If mh Then men_sel=-1: FlushKeys()
	ed_info$=""
	
	
	
	;Move Complete Map
	If KeyHit(29) Then FlushKeys()
	If KeyDown(29) Then
		If KeyHit(203) Or KeyHit(30) Then
			For x=0 To map_xsize-1
				For y=0 To map_ysize
					map(x,y,0)=map(x+1,y,0)
					map(x,y,3)=tile_mode(map(x,y,0))
				Next
			Next
		EndIf
		If KeyHit(205) Or KeyHit(32) Then
			For x=map_xsize To 1 Step -1
				For y=0 To map_ysize
					map(x,y,0)=map(x-1,y,0)
					map(x,y,3)=tile_mode(map(x,y,0))
				Next
			Next
		EndIf
		If KeyHit(200) Or KeyHit(17) Then
			For x=0 To map_xsize
				For y=0 To map_ysize-1
					map(x,y,0)=map(x,y+1,0)
					map(x,y,3)=tile_mode(map(x,y,0))
				Next
			Next
		EndIf
		If KeyHit(208) Or KeyHit(31) Then
			For x=0 To map_xsize
				For y=map_ysize To 1 Step -1
					map(x,y,0)=map(x,y-1,0)
					map(x,y,3)=tile_mode(map(x,y,0))
				Next
			Next
		EndIf
	EndIf
	
		
	If ed_men<50 Then
	
		;Tile Cursor
		If men_op(0)=1 And ed_rect=1 Then
			ed_rect_sprite(ed_rectx,ed_recty,(mx-170)/32+e_x,my/32+e_y)
		Else
			ScaleSprite ed_sprite,32,32
			PositionEntity ed_sprite,((((mx-170)/32)*32+170)*2)-640+32,-(((my/32)*32)*2)+480-32,640
		EndIf
		
		;Map
		x=0
		y=0
		If men_ch(0) Then x=1
		If men_ch(1) Or men_op(1)=0 Then y=1
		e_px=170
		e_render(x,y,1)
		If men_op(1)=2 Then ed_waypoints()
		
		;3D
		RenderWorld()
		
		;Grid
		If men_ch(3) Then DrawImage gfx_grid,170,0
		
		;Obstacles
		If men_ch(4) Then ed_obstacles()
		
		;Entities
		If men_ch(2) Or men_op(1)=1 Then ed_entities()
		
		;Minimap
		If ed_minimap Then
			If sp200go Then e_minimap()
			DrawBlock gfx_minimap,540,0
			Color 56,72,106
			Rect 539,-1,102,102,0
			If mx>=540 Then
				If my<=100 Then
					ed_info$="Mini Map: left mousebutton to jump, right mousebutton to deactivate"
					If mh2 Then ed_minimap=0:
					If mh Then
						e_x=e_x-50+1+(mx-540)
						e_y=e_y-50+(my)
						mh=0
					EndIf
					md=0
					mh=0
					mh2=0
					md2=0
				EndIf
			EndIf
		Else
			Color 56,72,106
			Rect 630,0,10,10
			Color 160,160,160
			Rect 630+4,0+1,2,8,1
			Rect 630+1,0+4,8,2,1
			
			If mx>=630 Then
				If my<=10 Then
					Color 255,255,255
					Rect 630+4,0+1,2,8,1
					Rect 630+1,0+4,8,2,1
					ed_info$="Mini Map: click to activate"
					If mh Or mh2 Then ed_minimap=1
				EndIf
			EndIf
		EndIf

		;Klick in Map Gebiet
		If mx>=170 Then
			If mh Then ed_edarea=1
			
			;MAP EDITIEREN
			If men_op(1)=0 Then
				
				;Get
				If md2 Then
					ed_tile_sel=ed_tile_get((mx-170)/32+e_x,my/32+e_y)
					ed_tile_get_mc(ed_tile_sel)
					If ed_tile_sel<ed_tile_off Or ed_tile_sel>ed_tile_off+21 Then
						While ed_tile_off+21<ed_tile_sel
							ed_tile_off=ed_tile_off+7
						Wend
						While ed_tile_off+21>ed_tile_sel
							ed_tile_off=ed_tile_off-7
						Wend
						If ed_tile_off<0 Then ed_tile_off=0
					EndIf
				EndIf
				
				;Set
				If men_op(0)=0
					If md And ed_edarea Then
						ed_tile_set((mx-170)/32+e_x,my/32+e_y,ed_tile_sel)
					EndIf
				EndIf
				
				;Rect
				If men_op(0)=1
					If mh Then
						If ed_rect=0 Then
							ed_rect=1
							ed_rectx=(mx-170)/32+e_x
							ed_recty=my/32+e_y
						Else
							ed_rect=0
							ed_rect(ed_rectx,ed_recty,(mx-170)/32+e_x,my/32+e_y,ed_tile_sel)
						EndIf
					EndIf
					If mh2 Then ed_rect=0
					If ed_rect=1 Then
						
					EndIf
				EndIf
				
				;Fill
				If men_op(0)=2
					If mh Then
						ed_fill((mx-170)/32+e_x,my/32+e_y,ed_tile_sel)
					EndIf
				EndIf
			
			
			;ENTITIES EDITIEREN
			ElseIf men_op(1)=1 Then
			
				;Klick
				If mh Then
					ed_entity_set((mx-170)/32+e_x,my/32+e_y,ed_entity_lid(ed_list_sel))
				Else
				;Over?
					ed_entity_over((mx-170)/32+e_x,my/32+e_y)
				EndIf
				
				;Copy & Paste
				If (KeyDown(29) Or KeyDown(157)) Then
				
					;Paste
					If KeyHit(47) Then
						
						For entityc.entityc=Each entityc
							x=(mx-170)/32+e_x
							y=my/32+e_y
							
							If ed_entity_set(x,y,0)
								For entity.entity=Each entity
									If entity\x=x And entity\y=y Then
										
										
										entity\name$=entityc\name$
										entity\typ=entityc\typ
										
										;entity\h=entityc\h
										;entity\x=entityc\x
										;entity\y=entityc\y
										
										entity\trigger$=entityc\trigger
										
										For i=0 To 9
											entity\value_int[i]=entityc\value_int[i]
											entity\value_str[i]=entityc\value_str[i]
										Next
														
										ed_entity_men_load(x,y,0)
										ed_entity_men_save()
										
										Exit
									
									EndIf
								Next
							EndIf
							Exit
						Next
					
					;Copy
					ElseIf KeyHit(46)
						
						x=(mx-170)/32+e_x
						y=my/32+e_y
						
						For entity.entity=Each entity
							If entity\x=x Then
								If entity\y=y Then
									For entityc.entityc=Each entityc
										Delete entityc
									Next
									entityc.entityc=New entityc
									
									entityc\name$=entity\name
									entityc\typ=entity\typ
									;entityc\h=entity\h
									entityc\x=entity\x
									entityc\y=entity\y
									entityc\trigger$=entity\trigger
									
									For i=0 To 9
										entityc\value_int[i]=entity\value_int[i]
										entityc\value_str[i]=entity\value_str[i]
									Next
									
									Exit
								EndIf
							EndIf
						Next
						
					EndIf
				EndIf
				
			
			;WAYPOINTS EDITIEREN
			Else
				
				;Klick
				If mh Then
					ed_wp_set((mx-170)/32+e_x,my/32+e_y)
				EndIf
				
				;Rechtsklick
				If mh2 Then
					ed_wp_delete((mx-170)/32+e_x,my/32+e_y)
				EndIf
				
			EndIf
		EndIf
		
		;Scrollen
		If Not KeyDown(29) Then
			If sp25go Then
				If KeyDown(203) Or KeyDown(30) Then e_x=e_x-1
				If KeyDown(205) Or KeyDown(32) Then e_x=e_x+1
				If KeyDown(200) Or KeyDown(17) Then e_y=e_y-1
				If KeyDown(208) Or KeyDown(31) Then e_y=e_y+1
			EndIf
		EndIf

	Else
		ed_edarea=0
	EndIf

	;Menuleiste
	If ed_men<50 Then
		DrawBlockRect gfx_splash,0,0,0,0,170,480
		Color 56,72,106
		Rect 170,465,470,15,1
	Else
		DrawBlock gfx_splash,0,0
		DrawBlock gfx_splashdark,170,170
	EndIf
	Color 255,255,0
	SetFont font_big:Text 10,140,"- Editor -"
	SetFont font_small:Text 10,130,"Unreal Software's Counter-Strike 2D"
	
	;File Options	
	SetFont font_norm
	If men_button(10,5,"New",1,"Create a new Counter-Strike 2D map") Then ed_set(50)
	If men_button(60,5,"Open",1,"Open a Counter-Strike 2D map") Then ed_set(51)
	If men_button(110,5,"Save",1,"Save this Counter-Strike 2D map ") Then ed_set(52)
	
	;Edit - What
	men_option(80,170,"Map",0,1,1,"Edit map tiles")
	men_option(80,190,"Entities",1,1,1,"Edit entities")
	men_option(80,210,"Waypoints",2,1,1,"Edit waypoints")
	
	;Tool - How
	x=1
	If men_op(1)<>0 Then x=0
	men_option(10,170,"Set",0,0,x,"Left mouse: set tile / set entity     right mouse: get tile")
	men_option(10,190,"Rect",1,0,x,"1. click: define top left corner    2. click: define bottom right corner")
	men_option(10,210,"Fill",2,0,x,"Click into an area to fill it with the selected tiles")
	
	;Show?
	men_check(10,30,"Back",0,1,"Show background")
	men_check(10,50,"Map",1,1,"Show map layer")
	men_check(10,70,"Entities",2,1,"Show entities")
	men_check(80,30,"Grid",3,1,"Show grid")
	men_check(80,50,"Obstacles",4,1,"Mark obstacles")
	men_check(80,70,"Sprites",5,1,"Show Sprites")
	
	;Map Properties
	If men_button(10,90,"Map Properties",1,"Set map properties") Then ed_set(55)
	
	;Tile Auswahl
	If men_op(1)=0 Then
		Color 0,0,0
		Rect 10,232,4*32+1,7*32+1
		Color 160,160,160
		Rect 10,232,4*32+2,7*32+2,0
		i=ed_tile_off
		If gfx_tiles<>0 Then
			For x=0 To 3
				For y=0 To 6
					If i>map_tilesc Then x=10:y=10:Exit
					DrawImage gfx_tiles,11+x*32,233+y*32,i
					If mx>11+x*32 Then
						If my>233+y*32 Then
							If mx<43+x*32 Then
								If my<265+y*32 Then
									Color 255,255,255
									Rect 11+x*32,233+y*32,32,32,0
									If mh Then
										ed_tile_sel=i
										ed_tile_get_mc(i)
									EndIf
								EndIf
							EndIf
						EndIf
					EndIf
					If ed_tile_sel=i Then
						Color 255,255,0
						Rect 11+x*32,233+y*32,32,32,0
					EndIf
					i=i+1
				Next
			Next
		EndIf
		x=1
		If ed_tile_off<=0 Then x=0
		If men_button(10,460,"<<",x,"Show previous tiles") Then ed_tile_off=ed_tile_off-7
		If men_button(45,460,"Tile Prop.",1,"Set tile properties ") Then ed_set(60)
		x=1
		If ed_tile_off+28>=map_tilesc Then x=0
		If men_button(123,460,">>",x,"Show next tiles") Then ed_tile_off=ed_tile_off+7
	;Entity Auswahl
	ElseIf men_op(1)=1
		ed_entitylist(10,232,100)
	;Waypoint Optionen
	ElseIf men_op(1)=2
		SetFont font_norm
		If men_button(10,232,"Save",1,"Save waypoints for this map") Then e_waypoints_save(map_name$)
		If men_button(10,252,"Load",1,"Load waypoints for this map") Then e_waypoints_load(map_name$)
		If men_button(10,292,"Clear",1,"Delete all waypoints in this map") Then
			For pf_wp.pf_wp=Each pf_wp
				Delete pf_wp
			Next
			For pf_link.pf_link=Each pf_link
				Delete pf_link
			Next
		EndIf
	EndIf
	
	
	;Menus
	Select ed_men
		
		;50 - New
		Case 50
			Color 255,255,0
			SetFont font_big:Text 170,140,"- New -"
			
			men_input(175,175,438,"Map Background Image (gfx/backgrounds/..., optional):",0,1,"Background Image, optional")
			men_input(175,220,100,"Scroll X:",1,1,"Background Image Scoll X Speed")
			men_input(280,220,100,"Scroll Y:",2,1,"Background Image Scoll Y Speed")
			men_check(390,240,"Tile Scrolling",6,1,"Background Scrolling depending on the Tile Scrolling")
			men_input(175,265,100,"Color R:",3,1,"Background Color Red (0-255)")
			men_input(280,265,100,"Color G:",4,1,"Background Color Green (0-255)")
			men_input(385,265,100,"Color B:",5,1,"Background Color Blue (0-255)")
			Color men_in$(3),men_in$(4),men_in$(5): Rect 490,281,20,20,1
			men_input(175,310,438,"Map Tileset (gfx/tiles/...):",6,1,"Tileset for this map")
			men_input(175,355,100,"Map X Size:",7,1,"Map X Size (Tiles)")
			men_input(280,355,100,"Map Y Size:",8,1,"Map Y Size (Tiles)")
			
			If (Int(men_in$(7))*Int(men_in$(8)))>99999 Then
				SetFont font_norm
				Color 255,0,0
				Text 385,355, "Warning:"
				Text 385,372, "Map is too huge!"
			EndIf
			
			If men_button(175,440,"OK",1,"OK") Then
				e_cls()
				map_back$=men_in$(0)
				map_back_scr_x=men_in$(1)
				map_back_scr_y=men_in$(2)
				map_back_scr_tile=men_ch(6)
				map_bg_r=men_in$(3)
				map_bg_g=men_in$(4)
				map_bg_b=men_in$(5)
				e_loadtiles(men_in$(6),1)
				map_xsize=men_in$(7)
				map_ysize=men_in$(8)
				Dim map(map_xsize,map_ysize,3)
				ClsColor map_bg_r,map_bg_g,map_bg_b
				If map_back$<>"" And Instr(map_back$,".")=0 Then map_back$=map_back$+".jpg"
				If FileType("gfx/backgrounds/"+map_back$)=1 Then map_back_h=LoadImage("gfx/backgrounds/"+map_back$)
				ed_set(0)
			EndIf
		
		;51 - Open
		Case 51
			Color 255,255,0
			SetFont font_big:Text 170,140,"- Open -"
			
			men_input(175,175,438,"Filename (maps/...):",0)
			If men_button(175,210,"Open",1,"Open this map") Then load_screen("Loading"):Delay 500:e_map_load(men_in$(0)):ed_men=0
			
			If men_button(175,440,"Close",1,"Close this menu") Then ed_set(0)
			
		
		;52 - Save
		Case 52
			Color 255,255,0
			SetFont font_big:Text 170,140,"- Save -"
			
			men_input(175,175,438,"Filename (maps/...):",0)
			If men_button(175,210,"Save",1,"Save this map") Then load_screen("Saving"):Delay 500:e_map_save(men_in$(0)):ed_men=0
			
		;53 - Save + Quit
		Case 53
			Color 255,255,0
			SetFont font_big:Text 170,140,"- Save & Quit -"
			
			SetFont font_norm
			Color 160,160,160
			Text 175,175,"Save map before closing?"
			
			men_input(175,195,438,"Filename (maps/...):",0)
			If men_button(175,230,"Save and Quit",1,"Save this map and close the map editor") Then e_map_save(men_in$(0)):leave=1
			If men_button(175,270,"Quit, don't Save",1,"Quit the map editor without saving the map") Then leave=1
			
			If men_button(175,440,"Cancel",1,"Cancel") Then ed_set(0)
			
			
		
		;55 - Map Properties
		Case 55
			Color 255,255,0
			SetFont font_big:Text 170,140,"- Map Properties -"
			
			men_input(175,175,438,"Map Background Image (gfx/backgrounds/..., optional):",0,1,"Background Image, optional")
			men_input(175,220,100,"Scroll X:",1,1,"Background Image Scoll X Speed")
			men_input(280,220,100,"Scroll Y:",2,1,"Background Image Scoll Y Speed")
			men_check(390,240,"Tile Scrolling",6,1,"Background Scrolling depending on the Tile Scrolling")
			men_input(175,265,100,"Color R:",3,1,"Background Color Red (0-255)")
			men_input(280,265,100,"Color G:",4,1,"Background Color Green (0-255)")
			men_input(385,265,100,"Color B:",5,1,"Background Color Blue (0-255)")
			Color men_in$(3),men_in$(4),men_in$(5): Rect 490,281,20,20,1
			men_input(175,310,438,"Map Tileset (gfx/tiles/...):",6,1,"Tileset for this map")
			men_input(175,355,100,"Map X Size:",7,1,"Map X Size (Tiles)")
			men_input(280,355,100,"Map Y Size:",8,1,"Map Y Size (Tiles)")
			
			If Int(men_in$(7))<map_xsize Or Int(men_in$(8))<map_ysize Then
				SetFont font_norm
				Color 255,0,0
				Text 385,355, "Warning:"
				Text 385,372, "Map areas will be deleted!"
			ElseIf (Int(men_in$(7))*Int(men_in$(8)))>99999 Then
				SetFont font_norm
				Color 255,0,0
				Text 385,355, "Warning:"
				Text 385,372, "Map is too huge!"
			EndIf
						
			If men_button(175,440,"OK",1,"OK") Then
				map_back$=men_in$(0)
				map_back_scr_x=men_in$(1)
				map_back_scr_y=men_in$(2)
				map_back_scr_tile=men_ch(6)
				map_bg_r=men_in$(3)
				map_bg_g=men_in$(4)
				map_bg_b=men_in$(5)
				e_loadtiles(men_in$(6),1)
				ed_scalemap(men_in$(7),men_in$(8))
				ClsColor map_bg_r,map_bg_g,map_bg_b
				If map_back$<>"" And Instr(map_back$,".")=0 Then map_back$=map_back$+".jpg"
				If FileType("gfx/backgrounds/"+map_back$)=1 Then
					map_back_h=LoadImage("gfx/backgrounds/"+map_back$)
				Else
					map_back_h=0
				EndIf
				ed_set(0)
			EndIf
			
		;60 - Tile Properties
		Case 60
			Color 255,255,0
			SetFont font_big:Text 170,140,"- Tile Properties -"
			
			SetFont font_norm
			Color 160,160,160
			Text 175,175, "Selected Tile:"
			Text 215,202, "ID/Frame: "+ed_tile_sel
			DrawImage gfx_tiles, 175,195,ed_tile_sel
			Rect 175,195,32,32,0
			
			men_option(175,260,"Normal",0,2,1,"Normal, walkable tile")
			men_option(175,280,"Wall",1,2,1,"Wall tile. Not walkable. You can't shoot trough it.")
			men_option(175,300,"Obstacle",2,2,1,"Obstacle tile. Not walkable but you CAN shoot trough it.")
			If men_option(175,320,"Floor",3,2,1,"Walkable floor tile with sound.") Then men_op(3)=0 : men_op(4)=0
			If men_option(175,340,"Deadly",4,2,1,"Deadly tile. Kills player.") Then men_op(3)=0 : men_op(4)=0
			men_option(175,360,"Wall Block",5,2,1,"Block. No shadow. Not walkable. You can't shoot trough it.")
			men_option(175,380,"Obstacle Block",6,2,1,"Block. No shadow. Not walkable. You CAN shoot trough it.")
			
			Select men_op(2)
			
				Case 3
					men_option(300,260,"Dirt",0,3,1,"Tile has a 'dirt'-sound")
					men_option(300,280,"Snow",1,3,1,"Tile has a 'snow'-sound")
					men_option(300,300,"Step",2,3,1,"Tile has a 'step'-sound")
					men_option(300,320,"Tile",3,3,1,"Tile has a 'tile'-sound")
					men_option(300,340,"Wade",4,3,1,"Tile has a 'wade'-sound")
					men_option(300,360,"Metal",5,3,1,"Tile has a 'metal'-sound")
					
					If men_button(300,400,"Sound Preview",1,"") Then
						Select men_op(3)
							Case 0 e_play sfx_dirt(Rand(0,3))
							Case 1 e_play sfx_snow(Rand(0,3))
							Case 2 e_play sfx_step(Rand(0,3))
							Case 3 e_play sfx_tile(Rand(0,3))
							Case 4 e_play sfx_wade(Rand(0,3))
							Case 5 e_play sfx_metal(Rand(0,3))
						End Select
					EndIf
					
				Case 4
					men_option(300,260,"Normal",0,3,1,"Normal death")
					men_option(300,280,"Explosion",1,3,1,"Player explodes")
					men_option(300,300,"Toxic",2,3,1,"Player dies in a toxic liquid")
					men_option(300,320,"Abyss",3,3,1,"Player falls into an abyss")
					
					If men_button(300,380,"Sound Preview",1,"") Then
						Select men_op(3)
							Case 0 e_play sfx_die(Rand(0,2))
							Case 1 e_play sfx_explode(Rand(0,2))
							Case 2 e_play sfx_die_toxic
							Case 3 e_play sfx_die_abyss
						End Select
					EndIf

			End Select
			
			If mh Then ed_tile_set_mc(ed_tile_sel)
			
			If men_button(175,440,"OK",1,"OK") Then ed_tile_update(): ed_set(0)
			
			If men_button(400,440,"Save as default",1,"Save current tile properties as default properties for this tileset") Then ed_tile_save_mc()
			
			If men_button(530,440,"Load default",ed_tile_mc,"Load default tile properties for this tileset") Then ed_tile_load_mc()
		
		
		;70 - Entity Properties
		Case 70
			
			ed_entity_men(ed_selent_id)
			
	
	End Select
	
	;Info Text
	SetFont font_small
	Color 255,255,0
	Text 170,467,ed_info$

	;Keys
	If KeyHit(1) Then
		ed_set(53)
	EndIf
		
	;Zeiger
	DrawImage gfx_pointer, mx,my,0
	If ed_men<50 Then
		If mx>170 Then
			Text mx+20,my-5,"("+((mx-170)/32+e_x)+"|"+(my/32+e_y)+")"
		EndIf
	EndIf
	
	Flip op_vsync
End Function

;Tile setzen
Function ed_tile_set(x,y,frame)
	If x>=0 Then
		If y>=0 Then
			If x<=map_xsize Then
				If y<=map_ysize Then 
					map(x,y,0)=frame
					map(x,y,3)=tile_mode(frame)
				EndIf
			EndIf
		EndIf
	EndIf
End Function

;Tile auslesen
Function ed_tile_get(x,y)
	If x>=0 Then
		If y>=0 Then
			If x<=map_xsize Then
				If y<=map_ysize Then
					Return map(x,y,0)
				EndIf
			EndIf
		EndIf
	EndIf
End Function

;Tile set mode code
Function ed_tile_set_mc(tileid)
	Local c
	Select men_op(2)
		Case 0 c=0
		Case 1 c=1
		Case 2 c=2
		Case 5 c=3
		Case 6 c=4	
		Case 3
			Select men_op(3)
				Case 0 c=10
				Case 1 c=11
				Case 2 c=12
				Case 3 c=13
				Case 4 c=14
				Case 5 c=15
			End Select
		Case 4
			Select men_op(3)
				Case 0 c=50
				Case 1 c=51
				Case 2 c=52
				Case 3 c=53
			End Select
	End Select
	tile_mode(tileid)=c
	ed_tile_update()
	Return c
End Function

;Tile get mode code
Function ed_tile_get_mc(tileid)
	Local c
	c=tile_mode(tileid)
	men_op(2)=0
	men_op(3)=0
	men_op(4)=0
	Select c
		Case 0 	men_op(2)=0
		Case 1 	men_op(2)=1
		Case 2 	men_op(2)=2
		Case 3 	men_op(2)=5
		Case 4 	men_op(2)=6
		Case 10	men_op(2)=3 : men_op(3)=0
		Case 11	men_op(2)=3 : men_op(3)=1
		Case 12	men_op(2)=3 : men_op(3)=2
		Case 13	men_op(2)=3 : men_op(3)=3
		Case 14	men_op(2)=3 : men_op(3)=4
		Case 15	men_op(2)=3 : men_op(3)=5
		Case 50	men_op(2)=4 : men_op(3)=0
		Case 51	men_op(2)=4 : men_op(3)=1
		Case 52	men_op(2)=4 : men_op(3)=2
		Case 53	men_op(2)=4 : men_op(3)=3
	End Select
End Function

;Tile save mode code
Function ed_tile_save_mc()
	load_screen("Saving"):Delay 500
	Local dotpos,name$,stream,i
	dotpos=Instr(map_tileset$,".")
	name$=Left(map_tileset$,dotpos-1)
	stream=WriteFile("gfx/tiles/"+name$+".inf")
	WriteLine stream, "Unreal Software's Counter-Strike 2D Tileset Informations"
	For i=0 To map_tilesc
		WriteLine stream, tile_mode(i)
	Next
	CloseFile(stream)	
End Function

;Tile load mode code
Function ed_tile_load_mc()
	load_screen("Loading"):Delay 500
	Local dotpos,name$,stream,i
	dotpos=Instr(map_tileset$,".")
	name$=Left(map_tileset$,dotpos-1)
	If FileType("gfx/tiles/"+name$+".inf")=1 Then
		stream=ReadFile("gfx/tiles/"+name$+".inf")
		ReadLine(stream)
		For i=0 To map_tilesc
			tile_mode(i)=ReadLine(stream)
		Next
		CloseFile(stream)
	EndIf
	ed_tile_get_mc(ed_tile_sel)
	ed_tile_update()
End Function

;Tile Update
Function ed_tile_update()
	Local x,y
	For x=0 To map_xsize
		For y=0 To map_ysize
			map(x,y,3)=tile_mode(map(x,y,0))
		Next
	Next
End Function


;Fllen
Function ed_fill(x,y,f2)
	Local ff,count,limit
	limit=MilliSecs()
	For fill.fill=Each fill
		Delete fill
	Next
	fill.fill=New fill
	fill\x=x
	fill\y=y
	count=1
	ff=map(x,y,0)
	If ff=f2 Then Return 0
	While count>0
		For fill.fill = Each fill
			
			;Fill Daten
			x=fill\x
			y=fill\y
			map(x,y,0)=f2
			map(x,y,3)=tile_mode(f2)
			Delete fill
			count=count-1
			
			;Links
			If x-1>=0 Then
				If map(x-1,y,0)=ff Then
					fill.fill=New fill
					fill\x=x-1
					fill\y=y
					count=count+1
					map(x-1,y,0)=f2
				EndIf
			EndIf
			
			;Rechts
			If x+1<=map_xsize Then
				If map(x+1,y,0)=ff Then
					fill.fill=New fill
					fill\x=x+1
					fill\y=y
					count=count+1
					map(x+1,y,0)=f2
				EndIf
			EndIf
			
			;Oben
			If y-1>=0 Then
				If map(x,y-1,0)=ff Then
					fill.fill=New fill
					fill\x=x
					fill\y=y-1
					count=count+1
					map(x,y-1,0)=f2
				EndIf
			EndIf
			
			;Unten
			If y+1<=map_ysize Then
				If map(x,y+1,0)=ff Then
					fill.fill=New fill
					fill\x=x
					fill\y=y+1
					count=count+1
					map(x,y+1,0)=f2
				EndIf
			EndIf
			
			;Infinitive Loop Canceln
			If MilliSecs()-limit>3000 Then Return 0
			
			
		Next
	Wend
End Function

;Rechteck
Function ed_rect(x1,y1,x2,y2,frame)
	Local sx,sy,ex,ey
	
	If x1>x2 Then
		sx=x2
		ex=x1
	Else
		sx=x1
		ex=x2
	EndIf
	
	If y1>y2 Then
		sy=y2
		ey=y1
	Else
		sy=y1
		ey=y2
	EndIf

	For x=sx To ex
		For y=sy To ey
			ed_tile_set(x,y,frame)
		Next
	Next
End Function

;Rechteck Auswahlsprite
Function ed_rect_sprite(x1,y1,x2,y2)
	Local sx,sy,ex,ey
	Local dx,dy
	Local xsize,ysize
	
	If x1>x2 Then
		dx=x1-x2
		sx=x2
		ex=x1
	Else
		dx=x2-x1
		sx=x1
		ex=x2
	EndIf
	
	If y1>y2 Then
		dy=y1-y2
		sy=y2
		ey=y1
	Else
		dy=y2-y1
		sy=y1
		ey=y2
	EndIf
	
	xsize=(dx+1)*32
	ysize=(dy+1)*32
	
	ScaleSprite ed_sprite,xsize,ysize
	PositionEntity ed_sprite,(((sx-e_x)*32+170)*2)-640+xsize,-(((sy-e_y)*32)*2)+480-ysize,640
End Function

;Waypoint/Path setzen
Function ed_wp_set(x,y)
	If x<0 Then Return 0
	If y<0 Then Return 0
	If x>map_xsize Then Return 0
	If y>map_ysize Then Return 0 

	Local set=0
	Local wpid=0
	For pf_wp.pf_wp=Each pf_wp
		If pf_wp\x=x Then
			If pf_wp\y=y Then
				set=1
				wpid=pf_wp\id
			EndIf
		EndIf
	Next
	
	;Waypoint setzen
	If set=0 Then
		Local freeid=0
		Local gotid=-1
		Local noid=1
		While gotid=-1
			noid=1
			For pf_wp.pf_wp=Each pf_wp
				If pf_wp\id=freeid Then
					noid=0
					Exit
				EndIf
			Next
			If noid Then
				gotid=freeid
			Else
				freeid=freeid+1
			EndIf
		Wend
		pf_wp.pf_wp=New pf_wp
		pf_wp\id=gotid
		pf_wp\x=x
		pf_wp\y=y
		ed_wplinkmode=0
		For pf_link.pf_link=Each pf_link
			If pf_link\wp2=-1 Then
				pf_link\wp2=gotid
				Exit
			EndIf
		Next
	;Path setzen
	Else
		If ed_wplinkmode=0 Then
			pf_link.pf_link=New pf_link
			pf_link\wp1=wpid
			pf_link\wp2=-1
			ed_wplinkmode=1
		Else
			For pf_link.pf_link=Each pf_link
				If pf_link\wp2=-1 Then
					pf_link\wp2=wpid
					ed_wplinkmode=0
				EndIf
			Next
		EndIf
	EndIf
End Function

;Waypoint/Path lschen
Function ed_wp_delete(x,y)
	If x<0 Then Return 0
	If y<0 Then Return 0
	If x>map_xsize Then Return 0
	If y>map_ysize Then Return 0 

	Local set=0
	Local wpid=0
	For pf_wp.pf_wp=Each pf_wp
		If pf_wp\x=x Then
			If pf_wp\y=y Then
				For pf_link.pf_link=Each pf_link
					If pf_link\wp1=pf_wp\id Then
						Delete pf_link
					ElseIf pf_link\wp2=pf_wp\id Then
						Delete pf_link
					EndIf
				Next
				Delete pf_wp
			EndIf
		EndIf
	Next
	
	Return 0
End Function


;Entity Liste
Function ed_entitylist(x,y,id)
	Local over,yo,i, scrollpos, scrollperc
	SetFont font_norm
	If mx>x Then
		If my>y Then
			If mx<x+139 Then
				If my<y+225 Then
					over=1
					If mh Then men_sel=id
				EndIf
			EndIf
		EndIf
	EndIf
	
	scrollperc=(Float(Float(ed_list_scr)/Float((ed_list_c-10))))*100.0
	scrollpos=(194.0*Float(scrollperc))/100.0
	
	If men_sel=id Then
		If men_getkey=0
			If KeyHit(200) Then ed_list_scr=ed_list_scr-1
			If KeyHit(208) Then ed_list_scr=ed_list_scr+1
		EndIf
		If mz<>0 Then ed_list_scr=ed_list_scr-mz
		If ed_list_scr<0 Then ed_list_scr=0
		If ed_list_scr>ed_list_c-10 Then ed_list_scr=ed_list_c-10
	EndIf
	
	Color 0,0,0
	If men_sel=id Then Color 30,30,30
	Rect x,y,139,226,1
	If over Then Color 255,255,255 Else Color 160,160,160
	Rect x,y,130,226,0
	Rect x+129,y,10,226,0
	i=ed_list_scr
	For yo=0 To 10
		Color 130,130,130
		If mx>x Then
			If my>y+1+(yo*20) Then
				If mx<x+129
					If my<y+22+(yo*20)
						If men_sel=id Then Color 50,50,50 Else Color 30,30,30
						If yo=10 Then
							Rect x+1,y+1+(yo*20),128,24,1
						Else
							Rect x+1,y+1+(yo*20),128,20,1
						EndIf
						Color 255,255,255
						If mh Then
							ed_list_sel=i
						EndIf
					EndIf
				EndIf
			EndIf
		EndIf
		If i=ed_list_sel Then Color 255,255,0
		Text x+2,y+2+(yo*20),ed_entity_ln$(i)
		i=i+1
		If i>ed_list_c Then Exit
	Next
	
	Color 160,160,160
	
	If mx>x+129 Then
		If my>y+1 Then
			If mx<x+140 Then
				If my<y+1+224 Then 
					If men_sel=id Then Color 50,50,50 Else Color 30,30,30
					Rect x+130,y+1,8,224
					Color 130,130,130
					If men_sel=id Then Color 160,160,160
					If md Then
						yo=0
						yo=my-y-42
						yo=Float((Float(yo)/260.0))*100.0
						ed_list_scr=(ed_list_c*yo)/100.0
						Color 255,255,255
					EndIf
				EndIf
			EndIf
		EndIf
	EndIf
	
	If mx>=x+129 Then
		If my>=y+1+scrollpos Then
			If mx<=x+129+8 Then
				If my<=y+1+scrollpos+30 Then
					Color 255,255,255
				EndIf
			EndIf
		EndIf
	EndIf
	
	If ed_list_scr<0 Then ed_list_scr=0
	If ed_list_scr>ed_list_c-10 Then ed_list_scr=ed_list_c-10
	scrollperc=(Float(Float(ed_list_scr)/Float((ed_list_c-10))))*100.0
	scrollpos=(194.0*Float(scrollperc))/100.0
	Rect x+130,y+1+scrollpos,8,30

End Function

;Entity setzen
Function ed_entity_set(px,py,typ)
	Local free
	free=1
	For entity.entity = Each entity
		If entity\x=px Then
			If entity\y=py Then
				ed_entity_men_load(px,py)
				ed_set(70)
				Return 0
			EndIf
		EndIf
	Next
	entity.entity = New entity
	entity\x=px
	entity\y=py
	entity\typ=typ
	Return 1
End Function

;Entity over
Function ed_entity_over(x,y)
	Local ax,ay,a
	For entity.entity = Each entity
		If entity\x=x Then
			If entity\y=y Then
				;Info
				ed_info$="Entity: "+entity_name$(entity\typ)+" @ ("+entity\x+"|"+entity\y+")"
				;Area
				Color 255,255,0
				If entity_area(entity\typ)>0 Then
					a=entity_area(entity\typ)
					For ax = x-a To x+a
						For ay = y-a To y+a
							Rect ax*32+e_px-(e_x*32),ay*32+e_py-(e_y*32),33,33,0
						Next
					Next
				Else
					Rect x*32+e_px-(e_x*32),y*32+e_py-(e_y*32),33,33,0
				EndIf
				;Special Men
				Select entity\typ
					;22 - env_sprite
					Case 22
						Color 56,72,106
						Rect 171,1,150,50
						SetFont font_small
						Color 255,255,0
						Text 172,1,"- "+entity_name$(22)+" -"
						Text 172,16,"Numpad: move"
						Text 172,26,"Ctrl + Numpad: scale"
						Text 172,36,"Numpad 7/9: rotate"
						If sp25go Then
							If KeyDown(219) Or KeyDown(157) Then
								If KeyDown(75) Then entity\value_int[0]=entity\value_int[0]-1:e_setup_sprite(entity\x,entity\y)
								If KeyDown(77) Then entity\value_int[0]=entity\value_int[0]+1:e_setup_sprite(entity\x,entity\y)
								If KeyDown(72) Then entity\value_int[1]=entity\value_int[1]-1:e_setup_sprite(entity\x,entity\y)
								If KeyDown(80) Then entity\value_int[1]=entity\value_int[1]+1:e_setup_sprite(entity\x,entity\y)
							Else
								If KeyDown(75) Then entity\value_int[2]=entity\value_int[2]-1:e_setup_sprite(entity\x,entity\y)
								If KeyDown(77) Then entity\value_int[2]=entity\value_int[2]+1:e_setup_sprite(entity\x,entity\y)
								If KeyDown(72) Then entity\value_int[3]=entity\value_int[3]-1:e_setup_sprite(entity\x,entity\y)
								If KeyDown(80) Then entity\value_int[3]=entity\value_int[3]+1:e_setup_sprite(entity\x,entity\y)
							EndIf
							If KeyDown(71) Then entity\value_int[4]=entity\value_int[4]+1:e_setup_sprite(entity\x,entity\y)
							If KeyDown(73) Then entity\value_int[4]=entity\value_int[4]-1:e_setup_sprite(entity\x,entity\y)
						EndIf
					;DEFAULT
					Default
						Color 56,72,106
						Rect 171,1,150,12
						SetFont font_small
						Color 255,255,0
						Text 172,1,"- "+entity_name$(entity\typ)+" -"
				End Select
				Return 1
			EndIf
		EndIf
	Next
	Return 0
End Function

;Entity Propertie Menu
Function ed_entity_men(id)

	Color 255,255,0
	SetFont font_big:Text 170,140,"- Entity Properties -"
	
	SetFont font_norm
	Color 160,160,160
	Text 175,175, "Entity Type: "+entity_name$(ed_selent_id)
	
	men_input(175,200,200,"Name:",0,1,"Entity Name")
	men_input(175,245,95,"X:",1,1,"Entity X Position")
	men_input(280,245,95,"Y:",2,1,"Entity Y Position")
	men_input(175,290,200,"Trigger:",3,0,"Name of the trigger target entity")

	Select id
	
		;info_t,info_ct,info_vip
		Case 0,1,2
			men_input_dir(380,216,120,4,1,"View Direction")

		;info_hostage	
		Case 3
			men_input_dir(380,261,65,4,1,"View Direction")
			men_input(380,200,200,"Look:",5,1,"Hostage Look")
		
		;info_rescuepoint
		;Case 4
		
		;info_bombspot
		Case 5
			men_input(380,200,200,"Explosion Range:",4,1,"Range of bomb explosion")
			
		;info_escapepoint,info_target
		;6,7
		
		;info_animation
		Case 8
			men_input(380,200,95,"Start:",4,1,"Animation start frame")
			men_input(485,200,95,"End:",5,1,"Animation end frame")
			men_input(380,245,200,"Speed:",6,1,"Animation speed (ms)")
			
		;info_storm	
		Case 9
			men_input_dir(380,261,65,4,1,"Storm Direction")
			men_input(380,200,200,"Power:",5,1,"Storm Power (0=no storm)")
			
		;info_tilefx
		Case 10
			men_input(380,200,95,"Frame:",4,1,"FX frame")
			men_input(485,200,95,"FX:",5,1,"Effect (0=none, 1-3=distortion, 4-6=waves)")
			men_input(380,245,200,"Speed:",6,1,"Animation speed (ms)")
			men_input(380,290,95,"Scroll X:",7,1,"Tile Scroll X Speed")
			men_input(485,290,95,"Scroll Y:",8,1,"Tile Scroll Y Speed")

		;env_item
		Case 21
			men_input(380,200,200,"Item:",4,1,"Item ID")
			;men_input(380,245,200,"Count:",5,1,"Item Count (0 = 1 item!)")
			
		;env_sprite
		Case 22
			men_input(380,200,230,"File:",4,1,"Image file")
			men_input(380,245,95,"X Size:",5,1,"Sprite X size (Pixel)")
			men_input(485,245,95,"Y Size:",6,1,"Sprite Y size (Pixel)")
			men_input(380,290,95,"X Offset:",7,1,"Sprite X offset (Pixel)")
			men_input(485,290,95,"Y Offset:",8,1,"Sprite Y offset (Pixel)")
			men_input(380,335,95,"Alpha:",9,1,"Sprite alpha 0.0 (invisible) - 1.0 (visible)")
			men_input(485,335,25,"R:",10,1,"Sprite color red (0-255)")
			men_input(515,335,25,"G:",11,1,"Sprite color green (0-255)")
			men_input(545,335,25,"B:",12,1,"Sprite color blue (0-255)")
			Color men_in$(10),men_in$(11),men_in$(12): Rect 575,351,5,20,1
			men_input(380,380,95,"FX:",13,1,"Sprite FX mode")
			men_input(485,380,95,"Blend:",14,1,"Sprite blend mode")
			men_input_dir(300,350,65,15,1,"Sprite rotation")
			men_input(175,335,95,"Mode:",16,1,"Sprite mode (1=normal; 2=alphamap; 4=masked; ...)")
			men_input(175,380,95,"Rot. Speed:",17,1,"Sprite Rotation Speed (0=none, >0=clockwise dir, <0=against cw dir)")
			
			
		;env_sound
		Case 23
			men_input(380,200,230,"File:",4,1,"Sound file")
			men_input(380,245,95,"Volume:",5,1,"Sound volume 0.0 (loudless) - 1.0 (loud)")
			men_check(380,290,"Start off",6,1,"Starts only when triggered")
			men_check(380,310,"Is NOT looped",7,1,"Plays only once")
			men_check(380,330,"Play everywhere",8,1,"Plays the sound everywhere")
			
		;env_decal
		Case 24
			men_input(380,200,95,"Frame:",4,1,"Decal frame")
			men_input(485,200,25,"R:",5,1,"Decal color red (0-255)")
			men_input(515,200,25,"G:",6,1,"Decal color green (0-255)")
			men_input(545,200,25,"B:",7,1,"Decal color blue (0-255)")
			Color men_in$(5),men_in$(6),men_in$(7): Rect 575,216,5,20,1
			men_input(380,245,95,"Alpha:",8,1,"Decal alpha 0.0 (invisible) - 1.0 (visible)")
			men_input_dir(485,245,90,9,1,"Decal rotation")
			
		;env_breakable
		Case 25
			men_input(380,200,95,"Frame:",4,1,"Breakable frame")
			men_input(485,200,95,"Health:",5,1,"Breakable health points")
			men_input(380,245,200,"Material:",6,1,"Breakable material (0=wood; 1=stone; 2=metal; 3=flesh; 4=glass; 5=nothing)")
			men_check(380,290,"Explode on destruction",7,1,"Create explosion on destruction")
			men_input(380,310,95,"Expl. range:",8,men_ch(7),"Explosion Range")
			men_input(485,310,95,"Expl. power:",9,men_ch(7),"Explosion Power")
			;men_check(380,355,"No shadow",8,1,"Breakable without shadows")
			men_option(380,355,"No shadow",1,4,1,"Breakable without shadows")
			men_option(380,375,"Wall shadow",0,4,1,"Breakable with wall shadow (big)")
			men_option(380,395,"Obstacle shadow",2,4,1,"Breakable with obstacle shadow (small)")
			
			
		;env_explode
		Case 26
			men_input(380,200,95,"Expl. range:",4,1,"Explosion Range")
			men_input(485,200,95,"Expl. power:",5,1,"Explosion Power")
			
		;env_hurt
		Case 27
			men_input(380,200,200,"Damage:",4,1,"Damage caused per second")
			
		;env_image
		Case 28
			men_input(380,200,230,"File:",4,1,"Image file")
			men_input(380,245,95,"X Offset:",5,1,"Image X offset (Pixel)")
			men_input(485,245,95,"Y Offset:",6,1,"Image Y offset (Pixel)")
			
		;gen_particles
		Case 50
			men_input(380,200,95,"Age min.:",4,1,"Minimum particle age")
			men_input(485,200,95,"Age max.:",5,1,"Maximum particle age")
			men_input(380,245,95,"X fly min.:",6,1,"Minimum particle x fly speed")
			men_input(485,245,95,"X fly max.:",7,1,"Maximum particle x fly speed")
			men_input(380,290,95,"Y fly min.:",8,1,"Minimum particle y fly speed")
			men_input(485,290,95,"Y fly max.:",9,1,"Maximum particle y fly speed")
			men_input(380,335,25,"R:",10,1,"Particle color red (0-255)")
			men_input(410,335,25,"G:",11,1,"Particle color green (0-255)")
			men_input(440,335,25,"B:",12,1,"Particle color blue (0-255)")
			Color men_in$(10),men_in$(11),men_in$(12): Rect 470,351,5,20,1
			
		;gen_sprites
		Case 51
			men_input(380,200,200,"Frame:",4,1,"Sprite frame")
			men_input(380,245,95,"X fly min.:",5,1,"Minimum sprite x fly speed")
			men_input(485,245,95,"X fly max.:",6,1,"Maximum sprite x fly speed")
			men_input(380,290,95,"Y fly min.:",7,1,"Minimum sprite y fly speed")
			men_input(485,290,95,"Y fly max.:",8,1,"Maximum sprite y fly speed")
			men_input(380,335,25,"R:",9,1,"Sprite color red (0-255)")
			men_input(410,335,25,"G:",10,1,"Sprite color green (0-255)")
			men_input(440,335,25,"B:",11,1,"Sprite color blue (0-255)")
			Color men_in$(9),men_in$(10),men_in$(11): Rect 470,351,5,20,1
			men_input(380,380,95,"Type:",12,0,"Sprite type")
			men_input(485,380,95,"Alpha:",13,1,"Sprite alpha 0.0 (invisible) - 1.0 (visible)")
			
		;gen_weather
		Case 52
			men_input(380,200,200,"Weather type:",4,1,"Weather type (0=rain; 1=snow; 2=fog)")
			x=1
			If Int(men_in(4))=2 Then x=0
			men_input(380,245,200,"Amount:",5,x,"Weather particle amount (1 - 30)")
			
		;gen_fx
		Case 53
			men_input(380,200,200,"FX type:",4,1,"FX type (0=waves; 1=smoke; 2=fire; 3=steam)")
			men_input(380,245,95,"X range min.:",5,1,"Minimum x range")
			men_input(485,245,95,"X range max.:",6,1,"Maximum x range")
			men_input(380,290,95,"Y range min.:",7,1,"Minimum y range")
			men_input(485,290,95,"Y range max.:",8,1,"Maximum y range")
			men_input(380,335,95,"Delay:",9,1,"FX delay (millisecs)")
			
		;func_teleport
		Case 70
			men_input(380,200,95,"X Destination:",4,1,"Teleport X destination")
			men_input(485,200,95,"Y Destination:",5,1,"Teleport Y destination")
			
			
		;Default: No Properties
		Default
			Color 255,0,0
			Text 380,265, "This Entity has no properties"
	
	
	End Select
		
	If men_button(175,440,"OK",1,"OK") Then
		ed_entity_men_save()
		ed_set(0)
	EndIf
	
	If men_button(175,420,"Cancel",1,"Cancel") Then ed_set(0)
	
	;Lschen
	If men_button(245,440,"Delete",1,"Delete this Entity") Then
			For entity.entity=Each entity
				If entity\x=ed_selent_x Then
					If entity\y=ed_selent_y Then
						Select entity\typ
							;Hostage lschen
							Case 3
								For hostage.hostage=Each hostage
									If hostage\x/32=entity\x Then
										If hostage\y/32=entity\y Then
											If hostage\h<>0 Then FreeEntity hostage\h
											Delete hostage
										EndIf
									EndIf
								Next
							;Item lschen
							Case 21
								For item.item=Each item
									If item\x=entity\x Then
										If item\y=entity\y Then
											FreeEntity item\h
											Delete item
										EndIf
									EndIf
								Next
							;Sprite lschen
							Case 22
								If entity\h<>0 Then FreeEntity entity\h
							;Decal lschen
							Case 24
								For decal.decal=Each decal
									If decal\x/32=entity\x Then
										If decal\y/32=entity\y Then
											FreeEntity decal\h
											Delete decal
										EndIf
									EndIf
								Next
						End Select
						
						;Entity lschen
						Delete entity
						Exit
					EndIf
				EndIf
			Next
		ed_set(0)
	EndIf
	
	;Kopieren
	If men_button(325,440,"Copy",1,"Copy this entity (paste with strg+v)") Then
		For entity.entity=Each entity
			If entity\x=ed_selent_x Then
				If entity\y=ed_selent_y Then
					For entityc.entityc=Each entityc
						Delete entityc
					Next
					entityc.entityc=New entityc
					
					entityc\name$=entity\name
					entityc\typ=entity\typ
					;entityc\h=entity\h
					entityc\x=entity\x
					entityc\y=entity\y
					entityc\trigger$=entity\trigger
					
					For i=0 To 9
						entityc\value_int[i]=entity\value_int[i]
						entityc\value_str[i]=entity\value_str[i]
					Next
					
					ed_set(0)
					Exit
				EndIf
			EndIf
		Next
	EndIf
	
End Function

;Entity Properties vom Entity in Men laden
Function ed_entity_men_load(x,y,mm=1)
	Local i
	If mm Then MoveMouse(184,448)
	For entity.entity = Each entity
		If entity\x=x Then
			If entity\y=y Then
				ed_selent_id=entity\typ
				ed_selent_x=x
				ed_selent_y=y
				
				For i=0 To 255
					If ed_entity_lid(i)=ed_selent_id Then
							ed_list_sel=i
						Exit
					EndIf
				Next
				
				men_in$(0)=entity\name$
				men_in$(1)=x
				men_in$(2)=y
				men_in$(3)=entity\trigger$
				
				Select ed_selent_id
					
					;info_t,info_ct,info_vip
					Case 0,1,2
						men_in$(4)=entity\value_int[0]
					
					
					;info_hostage
					Case 3
						men_in$(4)=entity\value_int[0]
						men_in$(5)=entity\value_int[1]
						
					;info_bombspot
					Case 5
						men_in$(4)=entity\value_int[0]
						
					;info_animation
					Case 8
						men_in$(4)=entity\value_int[0]
						men_in$(5)=entity\value_int[1]
						men_in$(6)=entity\value_int[2]
						
					;info_storm
					Case 9
						men_in$(4)=entity\value_int[0]
						men_in$(5)=entity\value_int[1]
						
					;info_tilefx
					Case 10
						men_in$(4)=entity\value_int[0]
						men_in$(5)=entity\value_int[1]
						men_in$(6)=entity\value_int[4]
						men_in$(7)=entity\value_int[2]
						men_in$(8)=entity\value_int[3]
					
					;env_item
					Case 21
						men_in$(4)=entity\value_int[0]
						men_in$(5)=entity\value_int[1]
					
					;env_sprite
					Case 22
						men_in$(5)=entity\value_int[0]
						men_in$(6)=entity\value_int[1]
						men_in$(7)=entity\value_int[2]
						men_in$(8)=entity\value_int[3]
						men_in$(15)=entity\value_int[4]
						men_in$(10)=entity\value_int[5]
						men_in$(11)=entity\value_int[6]
						men_in$(12)=entity\value_int[7]
						men_in$(13)=entity\value_int[8]
						men_in$(14)=entity\value_int[9]
						men_in$(4)=entity\value_str$[0]
						men_in$(9)=entity\value_str$[1]
						men_in$(16)=entity\value_str$[2]
						men_in$(17)=entity\value_str$[3]
						
					;env_sound
					Case 23
						men_ch(6)=entity\value_int[0]
						men_ch(7)=entity\value_int[1]
						men_ch(8)=entity\value_int[2]
						men_in$(4)=entity\value_str$[0]
						men_in$(5)=entity\value_str$[1]
						
					;env_decal
					Case 24
						men_in$(4)=entity\value_int[0]
						men_in$(5)=entity\value_int[1]
						men_in$(6)=entity\value_int[2]
						men_in$(7)=entity\value_int[3]
						men_in$(9)=entity\value_int[4]
						men_in$(8)=entity\value_str$[0]
						
					;env_breakable
					Case 25
						men_in$(4)=entity\value_int[0]
						men_in$(5)=entity\value_int[1]
						men_in$(6)=entity\value_int[2]
						men_ch(7)=entity\value_int[3]
						men_in$(8)=entity\value_int[4]
						men_in$(9)=entity\value_int[5]
						men_op(4)=entity\value_int[6]
						
					;env_explode
					Case 26
						men_in$(4)=entity\value_int[0]
						men_in$(5)=entity\value_int[1]
						
					;env_hurt
					Case 27
						men_in$(4)=entity\value_int[0]
						
					;env_image
					Case 28
						men_in$(5)=entity\value_int[0]
						men_in$(6)=entity\value_int[1]
						men_in$(4)=entity\value_str$[0]
						
					;gen_particles
					Case 50
						men_in$(4)=entity\value_int[0]
						men_in$(5)=entity\value_int[1]
						men_in$(6)=entity\value_int[2]
						men_in$(7)=entity\value_int[3]
						men_in$(8)=entity\value_int[4]
						men_in$(9)=entity\value_int[5]
						men_in$(10)=(Int(entity\value_str$[0]) And $FF0000)/$10000
						men_in$(11)=(Int(entity\value_str$[0]) And $FF00)/$100
						men_in$(12)=(Int(entity\value_str$[0]) And $FF)
						
					;gen_sprites
					Case 51
						men_in$(4)=entity\value_int[0]
						men_in$(9)=entity\value_int[1]
						men_in$(10)=entity\value_int[2]
						men_in$(11)=entity\value_int[3]
						men_in$(5)=entity\value_int[4]
						men_in$(6)=entity\value_int[5]
						men_in$(7)=entity\value_int[6]
						men_in$(8)=entity\value_int[7]
						men_in$(12)=entity\value_int[8]
						men_in$(13)=entity\value_str$[0]
						
					;gen_weather
					Case 52
						men_in$(4)=entity\value_int[0]
						men_in$(5)=entity\value_int[1]
						
					;gen_fx
					Case 53
						men_in$(4)=entity\value_int[0]
						men_in$(5)=entity\value_int[1]
						men_in$(6)=entity\value_int[2]
						men_in$(7)=entity\value_int[3]
						men_in$(8)=entity\value_int[4]
						men_in$(9)=entity\value_int[5]
						
					;func_teleport
					Case 70
						men_in$(4)=entity\value_int[0]
						men_in$(5)=entity\value_int[1]
	
					
				End Select
				
				Return 0
			EndIf
		EndIf
	Next	
End Function

;Entity Properties aus Men im Entity speichern
Function ed_entity_men_save()
	For entity.entity = Each entity
		If entity\x=ed_selent_x Then
			If entity\y=ed_selent_y Then
				
				entity\name$=men_in$(0)
				x=men_in$(1)
				y=men_in$(2)
				entity\trigger$=men_in$(3)
				
				Select ed_selent_id
					
					;info_t,info_ct,info_vip
					Case 0,1,2
						entity\value_int[0]=men_in$(4)
						
					;info_hostage
					Case 3
						entity\value_int[0]=men_in$(4)
						entity\value_int[1]=men_in$(5)
						
					;info_bombspot
					Case 5
						entity\value_int[0]=men_in$(4)
						
					;info_animation
					Case 8
						entity\value_int[0]=men_in$(4)
						entity\value_int[1]=men_in$(5)
						entity\value_int[2]=men_in$(6)
						
					;info_storm
					Case 9
						entity\value_int[0]=men_in$(4)
						entity\value_int[1]=men_in$(5)
						
					;info_tilefx
					Case 10
						entity\value_int[0]=men_in$(4)
						entity\value_int[1]=men_in$(5)
						entity\value_int[2]=men_in$(7)
						entity\value_int[3]=men_in$(8)
						entity\value_int[4]=men_in$(6)
					
					;env_item
					Case 21
						entity\value_int[0]=men_in$(4)
						entity\value_int[1]=men_in$(5)
					
					;env_sprite
					Case 22
						entity\value_int[0]=men_in$(5)
						entity\value_int[1]=men_in$(6)
						entity\value_int[2]=men_in$(7)
						entity\value_int[3]=men_in$(8)
						entity\value_int[4]=men_in$(15)
						entity\value_int[5]=men_in$(10)
						entity\value_int[6]=men_in$(11)
						entity\value_int[7]=men_in$(12)
						entity\value_int[8]=men_in$(13)
						entity\value_int[9]=men_in$(14)
						entity\value_str$[0]=men_in$(4)
						entity\value_str$[1]=men_in$(9)
						entity\value_str$[2]=men_in$(16)
						entity\value_str$[3]=men_in$(17)
						e_setup_sprite(entity\x,entity\y)
						
					;env_sound
					Case 23
						entity\value_int[0]=men_ch(6)
						entity\value_int[1]=men_ch(7)
						entity\value_int[2]=men_ch(8)
						entity\value_str$[0]=men_in$(4)
						entity\value_str$[1]=men_in$(5)
						
					;env_decal
					Case 24
						entity\value_int[0]=men_in$(4)
						entity\value_int[1]=men_in$(5)
						entity\value_int[2]=men_in$(6)
						entity\value_int[3]=men_in$(7)
						entity\value_int[4]=men_in$(9)
						entity\value_str$[0]=men_in$(8)
						For decal.decal=Each decal
							If decal\x/32=entity\x Then
								If decal\y/32=entity\y Then
									FreeEntity decal\h
									Delete decal
								EndIf
							EndIf
						Next
						If entity\value_int[0]>=0 And entity\value_int[0]<=15 Then
							e_add_decal(entity\x*32,entity\y*32,gfx_decals,entity\value_int[0],entity\value_str$[0],entity\value_int[1],entity\value_int[2],entity\value_int[3],60*1000*100,entity\value_int[4])
						EndIf
						
					;env_breakable
					Case 25
						entity\value_int[0]=men_in$(4)
						entity\value_int[1]=men_in$(5)
						entity\value_int[2]=men_in$(6)
						entity\value_int[3]=men_ch(7)
						entity\value_int[4]=men_in$(8)
						entity\value_int[5]=men_in$(9)
						entity\value_int[6]=men_op(4)
						
					;env_explode
					Case 26
						entity\value_int[0]=men_in$(4)
						entity\value_int[1]=men_in$(5)
						
					;env_hurt
					Case 27
						entity\value_int[0]=men_in$(4)
						
					;env_image
					Case 28
						entity\value_int[0]=men_in$(5)
						entity\value_int[1]=men_in$(6)
						entity\value_str$[0]=men_in$(4)
						
					;gen_particles
					Case 50
						entity\value_int[0]=men_in$(4)
						entity\value_int[1]=men_in$(5)
						entity\value_int[2]=men_in$(6)
						entity\value_int[3]=men_in$(7)
						entity\value_int[4]=men_in$(8)
						entity\value_int[5]=men_in$(9)
						entity\value_str$[0]=Int(men_in$(10))*$10000+Int(men_in$(11))*$100+Int(men_in$(12))
						
					;gen_sprites
					Case 51
						entity\value_int[0]=men_in$(4)
						entity\value_int[1]=men_in$(9)
						entity\value_int[2]=men_in$(10)
						entity\value_int[3]=men_in$(11)
						entity\value_int[4]=men_in$(5)
						entity\value_int[5]=men_in$(6)
						entity\value_int[6]=men_in$(7)
						entity\value_int[7]=men_in$(8)
						entity\value_int[8]=men_in$(12)
						entity\value_str$[0]=men_in$(13)
						
					;gen_weather
					Case 52
						entity\value_int[0]=men_in$(4)
						If Int(men_in$(5))<1 Then men_in$(5)=1
						If Int(men_in$(5))>30 Then men_in$(5)=30
						entity\value_int[1]=men_in$(5)
						
					;gen_fx
					Case 53
						entity\value_int[0]=men_in$(4)
						entity\value_int[1]=men_in$(5)
						entity\value_int[2]=men_in$(6)
						entity\value_int[3]=men_in$(7)
						entity\value_int[4]=men_in$(8)
						entity\value_int[5]=men_in$(9)
						
					;func_teleport
					Case 70
						entity\value_int[0]=men_in$(4)
						entity\value_int[1]=men_in$(5)
					
				End Select
				
				Return 0
			EndIf
		EndIf
	Next	
End Function