;----------------------------------------Game Entities

;--------------------Entities anzeigen/berechnen
Function e_render_entities()
	For entity.entity=Each entity
		If entity_updaterate(entity\typ)=1 Then
		
			Select entity\typ
			
				;info_animation
				Case 8
					If ms-entity\value_int[9]>entity\value_int[2] Then
						entity\value_int[9]=ms
						;Nchstes Frame
						entity\value_int[8]=entity\value_int[8]+1
						;Animation zu ende? Reset
						If entity\value_int[8]>entity\value_int[1] Then
							entity\value_int[8]=entity\value_int[0]
						EndIf
						;Zeichnen
						SetBuffer ImageBuffer(gfx_tiles_temp, entity\value_int[0])
							DrawBlock gfx_tiles,0,0,entity\value_int[8]
						SetBuffer BackBuffer()
					EndIf
					
				;info_tilefx
				Case 10
					If ms-entity\value_int[9]>entity\value_int[4] Then
						entity\value_int[9]=ms
						;Scrollen
						entity\value_int[7]=entity\value_int[7]+entity\value_int[2]
						entity\value_int[8]=entity\value_int[8]+entity\value_int[3]
						;Zeichnen
						SetBuffer ImageBuffer(gfx_tiles_temp, entity\value_int[0])
							TileBlock gfx_tiles,entity\value_int[7],entity\value_int[8],entity\value_int[0]
							Select entity\value_int[1]
								;0 - None
								Case 0
								;1,2,3 - Distortion
								Case 1,2,3
									dist=50
									If entity\value_int[1]=2 Then dist=100
									If entity\value_int[1]=3 Then dist=500
									For i=0 To dist
										x=Rand(0,31)
										y=Rand(0,31)
										CopyRect x,y,1,1,x+Rand(-1,1),y+Rand(-1,1)
									Next
								;4,5,6 - Waves
								Case 4,5,6
									entity\value_int[6]=entity\value_int[6]+10
									If entity\value_int[1]=5 Then entity\value_int[6]=entity\value_int[6]+10
									If entity\value_int[1]=6 Then entity\value_int[6]=entity\value_int[6]+10
									If entity\value_int[6]>360 Then entity\value_int[6]=entity\value_int[6]-360
									sub=0
									For y=0 To 32
										CopyRect 0,y,32,1,Sin(sub+entity\value_int[6]),y
										sub=sub+10
									Next
									sub=0
									For x=0 To 32
										CopyRect x,0,1,32,x,Sin(sub+entity\value_int[6])
										sub=sub+10
									Next
							End Select
						SetBuffer BackBuffer()
					EndIf
					
				;info_quake
				Case 14
					If (e_quake#<=0) Then e_quake#=Rand(20,50)
				
				;env_sprite
				Case 22
					;Exists?
					If entity\h<>0 Then
						;not negative?
						If entity\value_int[0]>0 And entity\value_int[1]>0 Then
							;In View?
							Local sprx,spry,vx,vy,unculled=0
							sprx=(entity\x*32)+entity\value_int[2]
							spry=(entity\y*32)+entity\value_int[3]
							vx=e_x*32-e_px
							vy=e_y*32-e_py
							If (sprx+entity\value_int[0])>=vx Then
								If (spry+entity\value_int[1])>=vy Then
									If sprx<=vx+640 Then
										If spry<=vy+480 Then
											;In View! Show + Rotate
											unculled=1
											ShowEntity entity\h
											If Float(entity\value_str$[3])<>0.0 Then
												entity\value_str$[9]=Float(entity\value_str$[9])+Float(entity\value_str$[3])
												RotateSprite entity\h,Float(entity\value_str$[9])
											EndIf
										EndIf
									EndIf
								EndIf
							EndIf
							;Not in View! Hide!
							If Not unculled Then
								HideEntity entity\h
							EndIf
						Else
							;Negative: Show Everytime
							ShowEntity entity\h
						EndIf
					EndIf
					
				
				;env_sound
				Case 23
					;Start Silent=off / triggered
					If entity\value_int[0]=0 Or entity\value_int[8]=1 Then
						;Loop?
						If entity\value_int[1]=0
							;Nicht mehr am spielen?
							If Not ChannelPlaying(entity\value_int[9]) Then
								;Play everywhere
								If entity\value_int[2]=1 Then
									If entity\h<>0 Then
										entity\value_int[9]=e_play(entity\h,entity\value_str$[1])
									EndIf
								;Play normal
								Else
									If entity\h<>0 Then
										entity\value_int[9]=e_sound(entity\h,entity\x*32,entity\y*32, entity\value_str$[1])
									EndIf
								EndIf
							;Updaten
							Else
								;Nur bei Play normal Volume und Pan Updaten, alle 100 ms
								If entity\value_int[2]<>1 Then
									e_sound_update(entity\value_int[9],entity\x*32,entity\y*32, entity\value_str$[1])
								EndIf
							EndIf
						EndIf
					EndIf
					
				;env_breakable
				Case 25
					If entity\value_int[9]=0
						DrawImage gfx_tiles_temp, (entity\x*32)-(e_x*32-e_px),(entity\y*32)-(e_y*32-e_py),entity\value_int[0]
					EndIf
				
				;env_image
				Case 28
					If entity\h<>0 Then
						DrawImage entity\h,(entity\x*32+entity\value_int[0])-(e_x*32-e_px),(entity\y*32+entity\value_int[1])-(e_y*32-e_py)
					EndIf
				
				;gen_particles
				Case 50
					If sp25go Then
						e_add_par2d(entity\value_str$[0],Rand(entity\value_int[0],entity\value_int[1]),(entity\x*32)+16,(entity\y*32)+16,Rand(entity\value_int[2],entity\value_int[3]),Rand(entity\value_int[4],entity\value_int[5]))
					EndIf
				
				;gen_sprites
				Case 51
					If sp50go Then
						e_add_sprite_fragment(entity\value_int[0],entity\value_int[1],entity\value_int[2],entity\value_int[3],(entity\x*32)+16,(entity\y*32)+16,entity\value_int[8],Rand(entity\value_int[4],entity\value_int[5]),Rand(entity\value_int[6],entity\value_int[7]),entity\value_str$[0])
					EndIf
				
				;gen_weather
				Case 52
					Select entity\value_int[0]
						;0 - Rain
						Case 0
							If sp50go Then
								For i=0 To entity\value_int[1]
									e_add_sprite_raindrop(Rand(-320,320),Rand(-240,240))
								Next
							EndIf
						;1 - Snow
						Case 1
							If sp100go Then
								For i=0 To entity\value_int[1] 
									e_add_sprite_snowflake(Rand(-320,320),Rand(-240,240))
									If i>15 Then Exit
								Next
							EndIf
						;2 - Fog
						Case 2
							If sp3000go Then
								If Abs(entity\x-(e_x+9))<29 And Abs(entity\y-(e_y+7))<27 Then
									x=e_add_smoke((entity\x*32)+16+Rand(-10,10),(entity\y*32)+16+Rand(-10,10),Rnd(15,40),Rnd(-0.122,0.122),Rnd(-0.122,0.122),12000,Rnd(0.95,1.3),Rand(0,360))
									EntityBlend x,3
								EndIf
							EndIf
					End Select
					
				;gen_fx
				Case 53
					If ms-entity\value_int[9]>=entity\value_int[5] Then
						If Abs(entity\x-(e_x+9))<20 And Abs(entity\y-(e_y+7))<17 Then
							Select entity\value_int[0]
								;0 - Waves
								Case 0
									e_add_sprite_wave(entity\x*32+Rand(entity\value_int[1],entity\value_int[2]),entity\y*32+Rand(entity\value_int[3],entity\value_int[4]),Rand(5,16),Rnd(0.3,0.7))
								;1 - Smoke
								Case 1
									e_add_sprite_smokepuff(entity\x*32+Rand(entity\value_int[1],entity\value_int[2]),entity\y*32+Rand(entity\value_int[3],entity\value_int[4]),Rand(10,32),Rnd(0.3,0.7))
								;2 - Fire
								Case 2
									e_add_sprite_fire(entity\x*32+Rand(entity\value_int[1],entity\value_int[2]),entity\y*32+Rand(entity\value_int[3],entity\value_int[4]),Rand(10,32),Rnd(0.3,0.7))
									If Rand(10)=1 Then e_add_sprite_smokepuff(entity\x*32+Rand(entity\value_int[1],entity\value_int[2]),entity\y*32+Rand(entity\value_int[3],entity\value_int[4]),Rand(30,50),Rnd(0.3,0.7))
								;3 - Steam
								Case 3
									x=e_add_sprite_smokepuff(entity\x*32+Rand(entity\value_int[1],entity\value_int[2]),entity\y*32+Rand(entity\value_int[3],entity\value_int[4]),Rand(10,32),Rnd(0.3,0.7))
									EntityBlend x,3
							End Select
						EndIf
						entity\value_int[9]=ms
					EndIf
			
			
			End Select
		
		EndIf
	Next
End Function


;--------------------Entities triggern (by Name)
Function e_trigger_entities(name$)
	For entity.entity=Each entity
		If entity\name$=name$ Then
			e_trigger_entity(entity\x,entity\y)		
		EndIf
	Next
End Function

;--------------------Entity triggern
Function e_trigger_entity(x,y)
	For entity.entity=Each entity
		If entity\x=x Then
			If entity\y=y Then 
				
				Exit
			EndIf
		EndIf
	Next
End Function

;--------------------Sprite initialisieren
Function e_setup_sprite(x,y)
	For entity.entity=Each entity
		If entity\x=x Then
			If entity\y=y Then
				If entity\h=0 Then entity\h=CreateSprite()
				If e_res_get(entity\value_str$[0],1,entity\value_str$[2])<>0 Then
					EntityTexture entity\h,e_res_get(entity\value_str$[0],1,entity\value_str$[2])
				Else
					If e_res_load(entity\value_str$[0],1,entity\value_str$[2])<>0 Then
						If e_res_get(entity\value_str$[0],1,entity\value_str$[2])<>0 Then
							EntityTexture entity\h,e_res_get(entity\value_str$[0],1,entity\value_str$[2])
						EndIf
					EndIf
				EndIf
				ScaleSprite entity\h,entity\value_int[0],entity\value_int[1]
				Local rx=(entity\x*32)+entity\value_int[2]
				Local ry=(entity\y*32)+entity\value_int[3]
				PositionEntity entity\h,((rx)*2)-640+entity\value_int[0],-((ry)*2)+480-entity\value_int[1],640
				RotateSprite entity\h,entity\value_int[4]
				EntityColor entity\h,entity\value_int[5],entity\value_int[6],entity\value_int[7]
				EntityFX entity\h,entity\value_int[8]
				EntityBlend entity\h,entity\value_int[9]
				EntityAlpha entity\h,Float(entity\value_str$[1])
				
				;Order
				If e_entityspriteorder>order_entitysprite Or e_entityspriteorder<order_entitysprite_max Then
					e_entityspriteorder=order_entitysprite
				Else
					e_entityspriteorder=e_entityspriteorder-1
				EndIf
				EntityOrder entity\h,e_entityspriteorder
				
				Return 1
			EndIf
		EndIf
	Next
	Return 0
End Function

;--------------------Item
Function e_setup_item(typ,x,y,ammo,ammoin)
	item.item=New item
	item\typ=typ
	item\h=CreateSprite()
	ScaleSprite item\h,32,32
	PositionEntity item\h,((x*32)*2)-640+32,-((y*32)*2)+480-32,640
	;Waffe
	If typ>=1 And typ<=49 Then
		EntityTexture item\h,gfx_weaponsd,weapon_frame_dropped(typ)
	;Grenades
	ElseIf typ>=51 And typ<=54 Then
		EntityTexture item\h,gfx_weapons,weapon_frame(typ)
	;Bomb
	ElseIf typ=100 Then
		EntityTexture item\h,gfx_items,0
	;Items
	Else
		EntityTexture item\h,gfx_items,weapon_frame_dropped(typ)
	EndIf
	RotateSprite item\h,Rand(-180,180)
	EntityOrder item\h,order_item
	item\x=x
	item\y=y
	item\ammo=ammo
	item\ammoin=ammoin
	If x>=0 Then
		If y>=0 Then
			If x<=map_xsize Then
				If y<=map_ysize Then
					If tile_mode(map(x,y,0))=14 Then
						EntityAlpha item\h,0.4
					EndIf
				EndIf
			EndIf
		EndIf
	EndIf
End Function


;--------------------Breakable
Function e_hurt_breakable(x,y,dam)
	For entity.entity=Each entity
		If entity\x=x Then
			If entity\y=y Then
				If entity\value_int[9]=1 Then Exit
				entity\value_int[1]=entity\value_int[1]-dam
				
				;Partikel
				Select entity\value_int[2]
					;0 - Wood
					Case 0
						e_add_sprite_fragment(Rand(0,3),Rand(140,200),120,0,x*32,y*32,Rand(-20,20),Rand(-20,20),Rand(-20,20))
						e_sound(sfx_mat_wood(Rand(0,2)),x*32,y*32,1)
						
					;1 - Stone
					Case 1
						e_add_sprite_fragment(Rand(4,6),130,130,130,x*32,y*32,Rand(-20,20),Rand(-20,20),Rand(-20,20))
						e_sound(sfx_mat_stone(Rand(0,2)),x*32,y*32,1)
					
					;2 - Metal
					Case 2
						e_add_sprite_fragment(Rand(4,6),130,130,130,x*32,y*32,Rand(-20,20),Rand(-20,20),Rand(-20,20))
						e_sound(sfx_mat_metal(Rand(0,2)),x*32,y*32,1)
					
					;3 - Flesh
					Case 3
						e_add_sprite_fragment(Rand(8,15),Rand(100,255),0,0,x*32,y*32,Rand(-20,20),Rand(-20,20),Rand(-20,20))
						e_sound(sfx_mat_stone(Rand(0,2)),x*32,y*32,1)
					
					;4 - Glass
					Case 4
						e_add_sprite_fragment(Rand(4,6),200,200,230,x*32,y*32,Rand(-20,20),Rand(-20,20),Rand(-20,20),Rnd(0.4,0.8))
						e_sound(sfx_mat_glass(Rand(0,2)),x*32,y*32,1)
						
					;5 - Nothing
					Case 5
						
					;Default
					Default
						e_add_sprite_fragment(Rand(0,15),Rand(0,255),Rand(0,255),Rand(0,255),x*32,y*32,Rand(-20,20),Rand(-20,20),Rand(-20,20),Rnd(0.5,1.0))
						e_sound(sfx_mat_wood(Rand(0,2)),x*32,y*32,1)
				End Select
				
				;Kaputt?
				If e_player=e_server Then
					If entity\value_int[1]<=0 Then
						If entity\value_int[9]=0 Then
							e_kill_breakable(x,y,1,1)
						EndIf
					EndIf
				EndIf
				
				Exit
			EndIf
		EndIf
	Next
End Function


Function e_kill_breakable(x,y,fx=1,send=1)
	For entity.entity=Each entity
		If entity\x=x Then
			If entity\y=y Then
				
				If fx Then
					;Partikel
					Select entity\value_int[2]
						;0 - Wood
						Case 0
							For i=1 To 15
								e_add_sprite_fragment(Rand(0,3),Rand(140,200),120,0,x*32,y*32,Rand(-10,10),Rand(-10,10),Rand(-10,10))
							Next
							e_sound(sfx_mat_wood(Rand(0,2)),x*32,y*32,0.8)
							For wink=0 To 360 Step 60
								e_add_sprite_smokepuff((x*32)+16+Sin(wink)*15,(y*32)+16-Cos(wink)*15,Rand(5,15),Rnd(0.4,0.6))
							Next
							
						;1 - Stone
						Case 1
							For i=1 To 15
								e_add_sprite_fragment(Rand(4,6),130,130,130,x*32,y*32,Rand(-10,10),Rand(-10,10),Rand(-10,10))
							Next
							e_sound(sfx_mat_stone(Rand(0,2)),x*32,y*32)
							For wink=0 To 360 Step 60
								e_add_sprite_smokepuff((x*32)+16+Sin(wink)*15,(y*32)+16-Cos(wink)*15,Rand(5,15),Rnd(0.4,0.6))
							Next
						
						;2 - Metal
						Case 2
							For i=1 To 15
								e_add_sprite_fragment(Rand(4,6),130,130,130,x*32,y*32,Rand(-10,10),Rand(-10,10),Rand(-10,10))
							Next
							e_sound(sfx_mat_metal(Rand(0,2)),x*32,y*32)
						
						;3 - Flesh
						Case 3
							For i=1 To 15
								e_add_sprite_fragment(Rand(8,15),Rand(100,255),0,0,x*32,y*32,Rand(-10,10),Rand(-10,10),Rand(-10,10))
							Next
							e_sound(sfx_mat_stone(Rand(0,2)),x*32,y*32)
						
						;4 - Glass
						Case 4
							For i=1 To 15
								e_add_sprite_fragment(Rand(4,6),200,200,230,x*32,y*32,Rand(-10,10),Rand(-10,10),Rand(-10,10),Rnd(0.4,0.8))
							Next
							e_sound(sfx_mat_glass(Rand(0,2)),x*32,y*32)
							
						;5 - Nothing
						Case 5
							
						;Default
						Default
							For i=1 To 15
								e_add_sprite_fragment(Rand(0,15),Rand(0,255),Rand(0,255),Rand(0,255),x*32,y*32,Rand(-10,10),Rand(-10,10),Rand(-10,10),Rnd(0.5,1.0))
							Next
							e_sound(sfx_mat_wood(Rand(0,2)),x*32,y*32)
					End Select
					
					;Damage
					If entity\value_int[3]=1
						e_add_explosion(x*32+16,y*32+16,70+entity\value_int[4],0.8)
						e_sound(sfx_explode(Rand(0,2)),x*32+16,y*32+16)
						If e_player=e_server Then
							game_damagewave(x*32+16,y*32+16,entity\value_int[5],entity\value_int[4],weapon=-1,triggerplayer=200,x,y)
						EndIf
					EndIf
					
				EndIf
				
				;Destroy
				entity\value_int[9]=1
				map(x,y,3)=tile_mode(map(x,y,0))
				map(x,y,1)=-1
				e_shadows()
				
				;Send
				If send Then
					If e_player=e_server Then
						For player.player=Each player
							If player\id<>e_player Then
								udp_iniimp(player\ip,player\port,10)
								udp_w_byte(110)
								udp_w_int(x)
								udp_w_int(y)
								udp_w_byte(e_sv_rsession)
								udp_sendimp()
								udp_sendb(12)
							EndIf
						Next
					EndIf
				EndIf
				
				
				Return 1
			EndIf
		EndIf
	Next
	Return 0
End Function