;----------------------------------------Game Functions

;--------------------Player hinzufgen
Function player_add(name$,bot=1,ip=0,port=0,forceid=-1)
	Local count=0,i,freeid=-1,ok
	
	;Name check
	If Len(name$)=0 Then name$="Player"
	
	;Player mit IP&Port existiert bereits?
	If e_bot=0 Then
		For player.player=Each player
			If player\ip=ip Then
				If player\port=port Then
					con_add("Error: Double join - removing first player...")
					player_leave(player\id,1)
				EndIf
			EndIf
		Next
	EndIf
	
	;ID bestimmen
	If forceid=-1 Then
		For i=0 To 255
			ok=1
			For player.player = Each player
				If player\id=i Then
					ok=0
					Exit
				EndIf
			Next
			If ok=1 Then
				freeid=i
				Exit
			EndIf
		Next
	Else
		freeid=forceid
	EndIf
	
	;Player hinzufgen
	player.player = New player
	player\id=freeid
	player\name$=name$
	player\bot=bot
	player\ip=ip
	player\port=port
	player\sv_lastping=MilliSecs()
	player\money=800
	player\roundlived=-1
		
	;Ausgabe
	hud_ol_add(name$+" connected")
	Return freeid
			
End Function


;--------------------Player lschen
Function player_leave(id,mode=0,send=1)
	If op_debug Then con_add("Deleting Player "+id+" by 'player_leave'-Function")
	;Senden
	If send Then
		If mode=3 Then
			;Server Leave an alle Clients senden
			For player.player=Each player
				If player\id<>e_server Then
					udp_iniimp(player\ip,player\port)
					udp_w_byte(252)
					udp_w_byte(mode)
					udp_sendimp()
					udp_sendb(5)
				EndIf
			Next
		Else
			;Client Leave an Server senden
			For player.player=Each player
				If player\id=e_server Then
					udp_iniimp(player\ip,player\port)
					udp_w_byte(252)
					udp_w_byte(mode)
					udp_w_byte(id)
					udp_sendimp()
					udp_sendb(5)
					Exit
				EndIf
			Next
		EndIf
	;Als Server weiterleiten
	ElseIf e_player=e_server Then
		For player.player=Each player
			If (player\id<>id) And (player\id<>e_server) Then
				udp_iniimp(player\ip,player\port)
				udp_w_byte(252)
				udp_w_byte(mode)
				udp_w_byte(id)
				udp_sendimp()
				udp_sendb(5)
			EndIf
		Next
	EndIf
	;3 - Server leave
	If mode=3 Then
		If e_player=e_server Then
			e_cls()
			leave=1
			men_set(20)
		Else
			e_cls()
			leave=1
			men_msg("Server went offline!",2,20)
		EndIf
	;0/1 - Client leave/Ping Timeout
	ElseIf mode=0 Or mode=1 Then
		If id=e_player Then
			leave=1
			If mode=0 Then
				If e_bot=0 Then
					men_set(20)
				Else
					men_set(30)
				EndIf
			Else
				men_msg("Ping Timeout!",2,20)
			EndIf
			e_cls()
		Else
			For player.player = Each player
				If player\id=id Then
					If mode=0 Then
						hud_ol_add(player\name$+" has left the game")
					Else
						hud_ol_add(player\name$+" has left the game (Ping Timeout)")
					EndIf
					Exit
				EndIf
			Next
		EndIf
	;2 - Kick
	ElseIf mode=2 Then
		If id=e_player Then
			e_cls()
			leave=1
			men_msg("You have been kicked!",2,20)	
		Else
			For player.player = Each player
				If player\id=id Then
					hud_ol_add(player\name$+" has left the game (kicked)")
					Exit
				EndIf
			Next
		EndIf
	;4 - Cheat Kick
	ElseIf mode=4 Then
		If id=e_player Then
			e_cls()
			leave=1
			men_cheat_timer=MilliSecs()
			men_msg("Cheat detected!",5,20)	
		Else
			For player.player = Each player
				If player\id=id Then
					hud_ol_add(player\name$+" has left the game (Cheat detected!)")
					Exit
				EndIf
			Next
		EndIf
	EndIf
	;Zeug droppen
	For player.player = Each player
		If player\id=id Then
			;Zeug droppen
			If player\bot=1 Or player\id=e_player Then
				If player\sweapon[player\slot]<50 Then player_drop(player\id,player\slot,player\sweapon[player\slot],player\sammo[player\slot],player\sammoin[player\slot],(player\x+16)/32,(player\y+16)/32,1)
				If player\sweapon[8]<>0 Then player_drop(player\id,8,player\sweapon[8],player\sammo[8],player\sammoin[8],(player\x+16)/32,(player\y+16)/32,1)
				If player\sweapon[7]<>0 Then player_drop(player\id,7,player\sweapon[7],player\sammo[7],player\sammoin[7],(player\x+16)/32,(player\y+16)/32,1)
			EndIf
			;Lschen
			If player\h<>0 Then FreeEntity player\h
			Delete player
			Exit
		EndIf
	Next
	;Runde beenden?
	If leave<>1 Then game_roundend()
End Function

;--------------------Player Set (Player Daten zuteilen)
Function player_set()
	Local ok,id

	id=ReadByte(udp)
	
	ok=0
	For player.player = Each player
		If player\id=id Then
			ok=1
			Exit
		EndIf
	Next
	
	If Not ok Then
		;Anlegen falls nicht vorhanden
		player.player=New player
	EndIf
	
	player\id=id
	player\name$=ReadLine(udp)	
	player\team=ReadByte(udp)
	player\look=ReadByte(udp)
	player\vip=ReadByte(udp)
	player\ip=ReadInt(udp)
	player\port=ReadInt(udp)
	player\health=ReadByte(udp)
	player\x=ReadInt(udp)
	player\y=ReadInt(udp)
	player\dir=ReadShort(udp)
	player\frags=ReadShort(udp)-32767
	player\deads=ReadShort(udp)-32767
	player\sweapon[7]=ReadByte(udp)
	player\sweapon[8]=ReadByte(udp)
	player\gameadmin=ReadByte(udp)
	
	player_ini(id)
	player_turn(id,player\dir,0)
	PositionEntity player\h,((player\x)*2)-640+32,-((player\y)*2)+480-32,640
	
	If player\health>0 And player\forcedeath=0 Then
		ShowEntity player\h
	Else
		HideEntity player\h
	EndIf
		
End Function




;--------------------Player Team whlen
Function player_team(id, team, send=1)
	Local set=0,lived=0
	
	;Teamchange
	For player.player = Each player
		If player\id = id Then
			If player\health>0 Then
				If player\team=1 Or player\team=2 Then lived=1
			EndIf
			Select team
				Case 0 hud_ol_add(player\name$+" joins the Spectators")
				Case 1 hud_ol_add(player\name$+" joins the Terrorist Forces")
				Case 2 hud_ol_add(player\name$+" joins the Counter-Terrorist Forces")
			End Select
			player\team = team
			If team=0 Then
				player\health=0
				player_ini(id,1)
			Else
				player\health=0
				player_ini(id,0)
			EndIf
			set=1
			Exit
		EndIf
	Next
	
	;Global Cache
	If id=e_player Then
		e_team=team
	EndIf
	
	;Send - Client
	If send Then
		If set Then
			If e_player<>e_server Then
				For player.player = Each player
					If player\id = e_server Then
						udp_iniimp(player\ip,player\port)
						udp_w_byte(102)
						udp_w_byte(id)
						udp_w_byte(team)
						udp_sendimp()	
						udp_sendb(5)
						Exit
					EndIf
				Next
			EndIf
		EndIf
	EndIf
	;Send - Server
	If e_player=e_server Then
		For player.player = Each player
			If (player\id<>id) And (player\id<>e_server) Then
				udp_iniimp(player\ip,player\port)
				udp_w_byte(102)
				udp_w_byte(id)
				udp_w_byte(team)
				udp_sendimp()
				udp_sendb(5)
			EndIf
		Next
	EndIf
	
	;Lebenden Spieler bei Teamchange umbringen
	If set And e_player=e_server Then
		If lived Then
			player_kill(id,200,0,1)
		EndIf
	EndIf
	Return set
End Function

;--------------------Player Look whlen
Function player_look(id, look, send=1)
	Local set=0

	For player.player = Each player
		If player\id = id Then
			player\look=look
			set=1
			Exit
		EndIf
	Next
	

	;Send - Client
	If send Then
		If set Then
			If e_player<>e_server Then
				For player.player = Each player
					If player\id = e_server Then
						udp_iniimp(player\ip,player\port)
						udp_w_byte(103)
						udp_w_byte(id)
						udp_w_byte(look)
						udp_sendimp()	
						udp_sendb(5)
						Exit
					EndIf
				Next
			EndIf
		EndIf
	EndIf
	;Send - Server
	If e_player=e_server Then
		For player.player = Each player
			If (player\id<>id) And (player\id<>e_server) Then
				udp_iniimp(player\ip,player\port)
				udp_w_byte(103)
				udp_w_byte(id)
				udp_w_byte(look)
				udp_sendimp()	
				udp_sendb(5)
			EndIf
		Next
	EndIf

	Return set
End Function

;--------------------Player Name whlen
Function player_name(id, name$, send=1)
	Local set=0,oldname$

	name$=Trim(name$)
	If Len(name$)>25 Then name$=Left(name$,25)
	name$=Trim(name$)
	If name$="" Then Return 0

	For player.player = Each player
		If player\id = id Then
			oldname$=player\name$
			player\name$=name$
			hud_ml_add("",0,"* "+oldname$+" changed name to "+name$,update=1)
			set=1
			Exit
		EndIf
	Next
	
	;Send - Client
	If send Then
		If set Then
			If e_player<>e_server Then
				For player.player = Each player
					If player\id = e_server Then
						udp_iniimp(player\ip,player\port)
						udp_w_byte(93)
						udp_w_byte(id)
						udp_w_line(name$)
						udp_sendimp()
						udp_sendb(14)
						Exit
					EndIf
				Next
			EndIf
		EndIf
	EndIf
	;Send - Server
	If e_player=e_server Then
		For player.player = Each player
			If (player\id<>id) And (player\id<>e_server) Then
				udp_iniimp(player\ip,player\port)
				udp_w_byte(93)
				udp_w_byte(id)
				udp_w_line(name$)
				udp_sendimp()
				udp_sendb(14)
			EndIf
		Next
	EndIf

	Return set
End Function

;--------------------Player Money geben/abziehen
Function player_money(id,money)
	If money=0 Then Return 0
	For player.player=Each player
		If player\id=id Then
			player\money=player\money+money
			If money>0 Then
				If player\money>16000 Then player\money=16000
				If id=e_player Then
					hud_money_val=255
					hud_money_mode=1
				EndIf
				Return 1
			Else
				If player\money<0 Then player\money=0
				If id=e_player Then
					hud_money_val=255
					hud_money_mode=-1
				EndIf
				Return 1
			EndIf
		EndIf
	Next
	Return 0
End Function

;--------------------Player (Sprites) initialisieren
Function player_ini(id,hide=1)
	Local set=0
	
	For player.player = Each player
		If player\id = id Then
			
			;Main Sprite
			If player\h=0 Then
				player\h=CreateSprite()
				ScaleSprite player\h, 32,32
				EntityOrder player\h, order_player
			EndIf
			If player\vip=0 Then
				EntityTexture player\h, gfx_players, ((player\team-1)*4)+player\look
			Else
				EntityTexture player\h, gfx_players, 8
			EndIf
			
			;Equipment
			If player\equipment_h=0 Then
				player\equipment_h=CreateSprite(player\h)
				ScaleSprite player\equipment_h, 32,32
				EntityOrder player\equipment_h, order_player
			EndIf
			HideEntity player\equipment_h
			If player\sweapon[8]=56 Then ShowEntity player\equipment_h:EntityTexture player\equipment_h, gfx_equipment, 1
			If player\sweapon[7]=55 Then ShowEntity player\equipment_h:EntityTexture player\equipment_h, gfx_equipment, 0
			
			;Weapon
			If player\weapon_h=0 Then
				player\weapon_h=CreateSprite(player\h)
				ScaleSprite player\weapon_h, 32,32
				EntityOrder player\weapon_h, order_player
				EntityTexture player\weapon_h, gfx_weapons,0
			EndIf
			
			;Shadow
			If player\shadow_h=0 Then
				player\shadow_h=CreateSprite(player\h)
				EntityTexture player\shadow_h, gfx_playershadow
				EntityColor player\shadow_h, 0,0,0
				EntityAlpha player\shadow_h, 0.4
				ScaleSprite player\shadow_h, 32,32
				EntityOrder player\shadow_h, order_playershadow
			EndIf
			
			;Legs
			If player\legs_h=0 Then
				player\legs_h=CreateSprite(player\h)
				EntityTexture player\legs_h, gfx_playerlegs, player\legs_frame
				ScaleSprite player\legs_h, 32,32
				EntityOrder player\legs_h, order_playerlegs
			EndIf
			
			;Marker
			If op_mark Then
				If player\id=e_player Then
					If player_marker<>0 Then FreeEntity player_marker
					player_marker=CreateSprite()
					EntityTexture player_marker, gfx_marker
					ScaleSprite player_marker, 56,56
					EntityBlend player_marker, 3
					EntityOrder player_marker, order_playermarker
					If player\team=1 Then
						EntityColor player_marker, 255,0,0
					ElseIf player\team=2
						EntityColor player_marker, 0,0,255
					EndIf
					PositionEntity player_marker,((player\x)*2)-640+28,-((player\y)*2)+480-28,640
					EntityParent player_marker, player\h
				EndIf
			EndIf
			
			;Show/Hide
			If hide Then
				HideEntity player\h
				If player_marker<>0 Then HideEntity player_marker
			ElseIf player\health>0 And player\forcedeath=0 Then
				ShowEntity player\h
				If player_marker<>0 Then ShowEntity player_marker
			Else
				HideEntity player\h
				If player_marker<>0 Then HideEntity player_marker
			EndIf
			
			set=1
			Exit
		EndIf
	Next
	
	Return set
End Function


;--------------------Player an eine Startposition setzen
Function player_start(id,x=0,y=0,dir=0,mission=0,money=0,send=1,fakesend=0)
	Local set=0,starttyp,startpistol,free,freeexists,player2.player,playerx,playery,playerdir
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If Not player\h Then Return 0
	
	
	;Health auf 100 fr Start
	player\health=100
	
	;Start Entity und Start Pistole bestimmen
	Select player\team
		;Terrorist
		Case 1
			starttyp=0		;Entitytype=0 (T Base)
			startpistol=2	;Pistol=2 (Glock)
		;Counter-Terrorist
		Case 2
			starttyp=1		;Entitytype=1 (CT Base)
			startpistol=1	;Pistol=1 (USP)
		;Default
		Default
			player\health=0	;Health die zuvor auf 100 gesetzt wurde wieder auf 0!
			Return 0
	End Select
	
	;---Positionen als Server vergeben
	If send Then
		
		player\forcedeath=0:player\health=100
		
		;Mission bereits vergeben? Wenn nicht: Jetzt vergeben!
		mission=0
		If Not (e_sv_playergiven<>0) Then
			;AS-Map
			If map_gametype=1 Then
				If player\team=2 Then
					mission=1
					e_sv_playergiven=1
				EndIf
			;DE-Map
			ElseIf map_gametype=3 Then
				If player\team=1 Then
					mission=1
					e_sv_playergiven=1
				EndIf
			EndIf
		;Mission bereits vergeben: hat dieser Spieler sie?
		Else
			If player\id=e_sv_playergive Then
				mission=1
				If map_gametype=1 And player\team=1 Then mission=0
				If map_gametype=3 And player\team=2	Then mission=0
			EndIf
		EndIf
		
		;AS-Maps: VIP Starttyp auf VIP Base ndern
		If map_gametype=1 Then
			If player\team=2 Then
				If player\id=e_sv_playergive Then
					starttyp=2	;Entitytype=2 (VIP Base)
				EndIf
			EndIf
		EndIf
			
		
		;Existiert noch min. eine freie Base?
		freeexists=0
		For entity.entity = Each entity
			If entity\typ=starttyp Then
				free=1	
				For player2.player = Each player
					If (Int(player2\x)/32)=entity\x Then
						If (Int(player2\y)/32)=entity\y Then
							free=0
							Exit
						EndIf
					EndIf
				Next
				If free Then freeexists=freeexists+1
			EndIf
		Next
		
		;Zufllig an eine freie Base setzen
		If freeexists>0
			set=0
			While set=0
				For entity.entity = Each entity
					If entity\typ=starttyp Then
						If Rand(5)=1 Then
							free=1
							
							;Base besetzt?		
							For player2.player = Each player
								If (Int(player2\x)/32)=entity\x Then
									If (Int(player2\y)/32)=entity\y Then
										free=0
										Exit
									EndIf
								EndIf
							Next
							
							;An Base setzen wenn nicht besetzt
							If free=1 Then
								player\x=entity\x*32
								player\y=entity\y*32
								player_pos(player\id, player\x,player\y, 0)
								player\dir=entity\value_int[0]
								player_turn(id,player\dir,0)
								set=1
								Exit
							EndIf
							
						EndIf
					EndIf
				Next
			Wend	
		;Zufllig an eine volle Base setzen
		Else
			set=0
			While set=0
				For entity.entity = Each entity
					If entity\typ=starttyp Then
						If Rand(5)=1 Then
							player\x=entity\x*32
							player\y=entity\y*32
							player_pos(player\id, player\x,player\y, 0)
							player\dir=entity\value_int[0]
							player_turn(id,player\dir,0)
							set=1
							Exit
						EndIf
					EndIf
				Next
			Wend			
		EndIf
				
		;Senden
		If fakesend=0 Then
			For player2.player = Each player
				If player2\id <> e_player Then
					udp_iniimp(player2\ip,player2\port)
					udp_w_byte(104)
					udp_w_byte(player\id)
					udp_w_int(player\x)
					udp_w_int(player\y)
					udp_w_short(player\dir)
					udp_w_byte(mission)
					udp_w_int(player\sv_givemoney)
					udp_w_byte(e_sv_rsession)
					udp_sendimp()
					udp_sendb(20)
				EndIf
			Next
		EndIf
		
	;---Werte als Client Empfangen
	Else
		player\x=x
		player\y=y
		player\forcedeath=0:player\health=100
		player_pos(player\id, player\x,player\y, 0)
		player\dir=dir
		player_turn(id,dir,0)
		player\sv_givemoney=money
	EndIf
	
	;---Zustzliches bei Versender(Server) und Empfnger(Client) gleich ist:
	
	;Einstellen
	player\health=100
	player\forcedeath=0
	player\spray=ms
	player\radio=0
	player\weaponmode=0
	player\roundlived=e_sv_rsession
	
	;Action
	If player\action<>1 Then
		player\action=0
		player\actionstart=0
		player\actiontotal=0
	EndIf
	
	;Messer
	player\sweapon[2]=50
	
	;Startpistole
	If player\id=e_player Or e_player=e_server Then
		If player\sweapon[0]=0 Then
			If player\sweapon[1]=0 Or (player\sweapon[1]=startpistol And (player\sammoin[1]+player\sammo[1])=0) Then
				player\sweapon[1]=startpistol
				player\sammoin[1]=weapon_ammoin(startpistol)
				player\sammo[1]=weapon_ammoin(startpistol)*2
				player\slot=1
				player_weapon(player\id, 1, startpistol,1)
			EndIf
		EndIf
	EndIf
	
	;No Weapons
	For entity.entity=Each entity
		If entity\typ=12 Then
			player\sweapon[1]=0
			player\sammoin[1]=0
			player\sammo[1]=0
			player\sweapon[0]=0
			player\sammoin[0]=0
			player\sammo[0]=0
			player_weapon(player\id, 2, 50,1)
		EndIf
	Next
	
	;Shoottimer
	player\shoottimer=ms+1000
		
	;Geld
	player_money(id,2100)
	
	;Mission
	If mission Then
		e_sv_playergive=player\id
		;AS
		If map_gametype=1 Then
			player\vip=1
			player\armor=200
			player\mission=1
			EntityTexture player\h, gfx_players, 8
			For i=0 To 14
				player\sweapon[i]=0
				player\sammo[14]=0
				player\sammoin[14]=0
			Next
			player\sweapon[1]=startpistol
			player\sammoin[1]=weapon_ammoin(1)
			player\sammo[1]=weapon_ammoin(1)*2
			player\sweapon[2]=50
			player\slot=1
			player_weapon(player\id, 1, 1,1)
			
		;DE
		ElseIf map_gametype=3 Then
			player\sweapon[7]=55
			player\mission=1
		EndIf
	Else
		player\mission=0
		player\vip=0
		If player\sweapon[7]=55 Then player\sweapon[7]=0
	EndIf
	
	;Bot
	If player\bot Then
		player\bot_enemy_id=-1
		player\bot_enemy_rescan=0
		player\bot_enemy_freeline=0
		player\bot_enemy_freeline_rescan=0
		player\bot_enemy_lasthit=0
		player\bot_buy_timer=ms+Rand(200,800)
		player\bot_buy_step=1
		player\bot_obj[0]=0
		player\bot_mm_walk=0
		player\bot_flashed=0
	EndIf
	
	;Max Armoer
	If player\armor>100 Then
		If player\vip=0 Then
			player\armor=100
		EndIf
	EndIf
	
	;Man selber
	If player\id=e_player Then
		hud_mapload=0
		hud_flash_a#=0.0
	EndIf
	
	;Ini
	player_ini(player\id,0)
		
End Function


;--------------------Player drehen
Function player_turn(id, dir, send=1)
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If Not player\h Then Return 0
	
	Local xo,yo
	
	;Richtung nur anpassen und senden, wenn sie sich verndert hat
	If player\dir=dir
		send=0
	Else
		player\dir=dir
	EndIf
	RotateSprite player\h,-dir
	RotateSprite player\equipment_h,-dir
	RotateSprite player\weapon_h,-dir
	
	;Legs
	xf=8
	xo=Sin(dir)*xf
	yo=-Cos(dir)*xf
	PositionEntity player\legs_h,((player\x-xo)*2)-640+32,-((player\y-yo)*2)+480-32,640,1
		
	;Weapon
	xf=16
	If player\sweapon[player\slot]>=51 And player\sweapon[player\slot]<=54 Then
		xf=10 ;Grenade Offset
	EndIf
	xo=Sin(dir)*xf
	yo=-Cos(dir)*xf
	PositionEntity player\weapon_h,((player\x+xo)*2)-640+32,-((player\y+yo)*2)+480-32,640,1
	
	;Send
	If send Then
		If player\id=e_player Then
			udp_ch_dir=1
		EndIf
	EndIf
	
End Function



;--------------------Player tten
Function player_kill(id, killer, killweapon=0, send=1)
	Local i
	
	;Killer
	;0-100	= Player (+Death)
	;200	= Custom (+Death)
	;201	= Custom
	;202	= Custom (+Death, -Frag)
	;203	= Custom (Nothing)

	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If player\forcedeath Then Return 0
	
	;Zeug droppen
	If player\bot=1 Or player\id=e_player Then
		If player\sweapon[player\slot]<50 Then player_drop(player\id,player\slot,player\sweapon[player\slot],player\sammo[player\slot],player\sammoin[player\slot],(Int(player\x)+16)/32,(Int(player\y)+16)/32,1)
		If player\sweapon[8]<>0 Then player_drop(player\id,8,player\sweapon[8],player\sammo[8],player\sammoin[8],(Int(player\x)+16)/32,(Int(player\y)+16)/32,1)
		If player\sweapon[7]<>0 Then player_drop(player\id,7,player\sweapon[7],player\sammo[7],player\sammoin[7],(Int(player\x)+16)/32,(Int(player\y)+16)/32,1)
	EndIf
	;Kill - Werte auf 0
	player\health=0
	player\armor=0
	player\roundlived=e_sv_rsession
	;VIP?
	If player\vip Then
		If killer<>203 Then
			game_roundend(1)
		EndIf
	EndIf
	;Alle Sachen lschen
	For i=0 To 14
		player\sweapon[i]=0
		player\sammoin[i]=0
		player\sammo[i]=0
	Next
	player\forcedeath=1
	If player\id=e_player Then
		hud_nv_mode=0
		e_weapon=0
		If killer<=100 Then
			hud_spec_mode=1
			hud_spec_player=killer
		EndIf
	EndIf
	HideEntity player\h
	;0-100 / 200
	If killer<=200 Then
		player\deads=player\deads+1
		If killer=200 Then
			Select killweapon
				Case 0:e_sound(sfx_die(Rand(0,2)),player\x,player\y,1,450)
				Case 1:e_sound(sfx_explode(Rand(0,2)),player\x,player\y,1,50):e_add_explosion(player\x,player\y,Rand(100,200))
				Case 2:e_sound(sfx_die_toxic,player\x,player\y,1,50)
				Case 3:e_sound(sfx_die_abyss,player\x,player\y,1,50)
				Default e_sound(sfx_die(Rand(0,2)),player\x,player\y,1,450)
			End Select
		Else
			If killer<>203 Then e_sound(sfx_die(Rand(0,2)),player\x,player\y,1,450)
		EndIf
		If killer<>203 Then
			;Blood
			e_add_decal(player\x,player\y,gfx_decals,Rand(1,5),Rnd(0.8,1),Rand(200,255),0,0,5000,Rand(360))
			If op_blood>2 Then
				For i=0 To Rand(1,3)
					e_add_physical(player\x+Rand(32),player\y+Rand(32),1,Rand(30,60)*1000,0.5,Rnd(-2,2),Rnd(-2,2))
				Next
			EndIf
			If op_blood>0 Then
				e_add_sprite_bloodlake(player\x+16,player\y+16,Rnd(10,15),Rand(360),Rnd(0.6,0.99))
				For i=1 To (op_blood*5)
					e_add_sprite_fragment(Rand(8,15),Rand(100,255),0,0,player\x,player\y,0,Rand(-15,15),Rand(-15,15))
				Next
				For i=1 To (op_blood*25)
					e_add_par2d($D20000,Rand(200,1000),player\x+16,player\y+16,Rand(-10,10),Rand(-10,10))
				Next
				For i=1 To (op_blood*3)
					h=e_add_sprite_fragment(0,128,128,128,player\x,player\y,0,Rand(-15,15),Rand(-15,15),1)
					EntityTexture h,gfx_bodyparts,Rand(0,7)
					ScaleSprite h,22,22
				Next
			EndIf
		EndIf
	;202
	ElseIf killer=202
		player\deads=player\deads+1
		player\frags=player\frags-1
		e_sound(sfx_die(Rand(0,2)),player\x,player\y,1,450)
	EndIf
	
	;Frag + Geld fr Killer
	Local ph2=0
	If killer<200 Then	
		If killer>-1 Then
			For player2.player=Each player
				If player2\id=killer Then
					;Frag
					If player2\team<>player\team Then
						player2\frags=player2\frags+1
						player_money(killer,300)
					;Teamkill
					Else
						If player2\id<>player\id Then
							player2\frags=player2\frags-1
							player_money(killer,-3300)
							If player2\id=e_player Or player2\bot=1 Then
								player_radio(player2\id,31,1)
							EndIf
						EndIf
					EndIf
		
					;Bot
					If player\bot Then
						bot_enemy_id=-1
						bot_enemy_rescan=ms+Rand(400,1000)
					EndIf
					
					ph2=1
					Exit
				EndIf
			Next
		EndIf
	EndIf
	
	;Nachricht
	If killer<=100 And killer>-1 Then
		If ph2 Then
			If player2\id<>player\id Then
				hud_or_add(player2\name$+" ", player2\team, weapon_name(killweapon)+" ", player\name$, player\team)
				con_add(player2\name$+" killed "+player\name$+" with "+weapon_name(killweapon),0,1)
			Else
				hud_or_add(player\name$+" ", player\team, weapon_name(killweapon))
				con_add(player\name$+" killed himself with "+weapon_name(killweapon),0,1)
			EndIf
		EndIf
	ElseIf killer<>203 Then
		hud_or_add(player\name$+" ", player\team, "died")
		con_add(player\name$+" died",0,1)
	EndIf
		
	;Send - Client
	If send Then
		If e_player<>e_server Then
			For player.player = Each player
				If player\id = e_server Then
					udp_iniimp(player\ip,player\port)
					udp_w_byte(41)
					udp_w_byte(id)
					udp_w_byte(killer)
					udp_w_byte(killweapon)
					udp_w_byte(e_sv_rsession)	
					udp_sendimp()
					udp_sendb(7)
					Exit
				EndIf
			Next
		EndIf
	EndIf
	;Send - Server
	If e_player=e_server Then
		For player.player = Each player
			If player\id<>e_server Then
				udp_iniimp(player\ip,player\port)
				udp_w_byte(41)
				udp_w_byte(id)
				udp_w_byte(killer)
				udp_w_byte(killweapon)
				udp_w_byte(e_sv_rsession)	
				udp_sendimp()
				udp_sendb(7)
			EndIf
		Next
	EndIf
	
	;Bots die diesen Spieler anivisiert haben umstellen
	If e_bot Then
		For player.player=Each player
			If player\bot Then
				If player\health>0 Then
					If player\bot_enemy_id=id Then
						player\bot_enemy_id=-1
						player\bot_enemy_rescan=ms+Rand(300,900)
					EndIf
				EndIf
			EndIf
		Next
	EndIf
	
	;Hostages die diesem Spieler gefolgt sind umstellen
	For hostage.hostage=Each hostage
		If hostage\followid=id Then
			hostage\followid=-1
		EndIf
	Next
	
	;Round Restart? (Server only)
	If e_player=e_server Then 
		If killer<>203 Then
			game_roundend()
		EndIf
	EndIf
End Function


;--------------------Player angreifen
Function player_attack(id, send=1, damage=1)
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If player\h=0 Then Return 0
	If player\health<1 Then Return 0
	
	Local sendx=player\x
	Local sendy=player\y
	Local flamerdown#=0
	Local playerdamaged=0
	Local damagedid[32]
		
	;Timer erlaubt neuen Schuss / Nachricht wurde empfangen ?
	If player\shoottimer-ms<=0 Or send=0 Then
		
		;Waffe whlen?
		If id=e_player Then
			If hud_slot<>0 Then
				If player\sweapon[hud_slot-1]<>0 Then
					player\action=0
					player_weapon(e_player, hud_slot-1, player\sweapon[hud_slot-1])
					hud_slot=0
					e_play sfx_sel
					Return 0
				Else
					hud_slot=0
					e_play sfx_denysel
					Return 0
				EndIf
			EndIf
			If op_bind_attack=2 Then Return 0
		EndIf
		
		;Munition / Messer / Empfangen ?
		Local ok=0
		If send=0 Then
			ok=1
		ElseIf player\sammoin[player\slot]>0 Then
			ok=1
		ElseIf player\sweapon[player\slot]=50
			ok=1
		ElseIf player\sweapon[player\slot]=55 Then
			ok=1
		EndIf
		If ok Then
						
			Local aw=player\sweapon[player\slot]
			Local plx,ply,pldir,pldirdisp,pldisp,xo#,yo#,hit,sx#,sy#,stx,sty,player2.player,i,maxdis
			Local blood
			Local hurtany,hurtblock=-1
			
			;Cancel
			If aw=0 Then Return 0
			
			;Schusssound
			e_sound(weapon_sfx(aw),player\x,player\y)
			
			;Schuss
			player\shoottimer=ms+weapon_freq(aw)*weapon_freqfak
			player\shoot=1
			
			;Cachen
			plx=player\x+16
			ply=player\y+16
			pldir=player\dir
			pldisp=weapon_disp(aw)
			pldirdisp=pldir+Rand(-pldisp,pldisp)
			sx#=player\x+16
			sy#=player\y+16
			xo#=Sin(pldirdisp)*4
			yo#=-Cos(pldirdisp)*4
			startx=sx
			starty=sy
			
			
			;---Granate
			If aw>=51 And aw<=54 Then
				If player\sammoin[player\slot]>0 Then
					player\sammoin[player\slot]=player\sammoin[player\slot]-1
					player_gren(id,-1,Int(player\x),Int(player\y),player\dir,aw,1)
					If player\sammoin[player\slot]<=0 Then
						player\sweapon[player\slot]=0
						player_bestweapon(player\id, 1)
					EndIf
					player\shoottimer=ms+500
					Return 1
				Else
					Return 0
				EndIf
			EndIf
			
			;---Messer
			If aw=50 Then
				e_add_sprite_knifeslash(player\x,player\y,player\dir)
				;Getroffen?
				sx#=sx#+xo#*4
				sy#=sy#+yo#*4
				;Player
				For player2.player = Each player
					If player2\id <> id Then
						If player2\health>0 Then
							If RectsOverlap(sx,sy,2,2,player2\x,player2\y,32,32)Then 
								
								For i=0 To 2
									e_add_sprite_fragment(Rand(8,15),Rand(100,255),0,0,player2\x,player2\y,Rand(-10,10),Rand(-10,10),Rand(-10,10))
								Next
									
								For i=0 To 5
									x=Rand(0,8)
									e_add_par2d($D20000,Rand(1000,5000),player2\x+16+(xo*x),player2\y+16+(yo*x),Rand(-6,6),Rand(-6,6))
								Next
									
								player_hurt(player2\id, player\id, weapon_damage(player\sweapon[player\slot])/3, player\sweapon[player\slot],1)
								
								e_sound(sfx_w_knife_hit,player2\x,player2\y)
								
								maxdis=5
								Exit
									
							EndIf
						EndIf
					EndIf
				Next
				;Hostage
				For hostage.hostage=Each hostage
					If hostage\health>0 Then
						If RectsOverlap(sx,sy,2,2,hostage\x,hostage\y,32,32)Then
							
							For i=0 To 2
								e_add_sprite_fragment(Rand(8,15),Rand(100,255),0,0,hostage\x,hostage\y,Rand(-10,10),Rand(-10,10),Rand(-10,10))
							Next
									
							For i=0 To 5
								x=Rand(0,8)
								e_add_par2d($D20000,Rand(1000,5000),hostage\x+16+(xo*x),hostage\y+16+(yo*x),Rand(-6,6),Rand(-6,6))
							Next
							
							If player\id=e_player Or player\bot=1 Then
								game_hostage_hurt(hostage\id, player\id, weapon_damage(player\sweapon[player\slot])/3, player\sweapon[player\slot],1)
							EndIf
							
							e_sound(sfx_w_knife_hit,hostage\x,hostage\y)
							
							maxdis=5
							Exit
							
						EndIf
					EndIf
				Next
				;Breakable
				stx=Int((sx#-16)/32)
				sty=Int((sy#-16)/32)
				If stx>=0 Then
					If sty>=0 Then
						If stx<=map_xsize Then
							If sty<=map_ysize Then
								If map(stx,sty,3)>0 And map(stx,sty,3)<4 Then
									If map(stx,sty,1)=25 Then
										e_hurt_breakable(stx,sty,weapon_damage(player\sweapon[player\slot])/3)
									EndIf
								EndIf
							EndIf
						EndIf
					EndIf
				EndIf
				;Send - Client
				If send Then
					If e_player<>e_server Then
						For player.player = Each player
							If player\id = e_server Then
								WriteByte(udp),10
								WriteByte(udp),id
								WriteByte(udp),e_sv_rsession
								SendUDPMsg(udp, player\ip, player\port)
								udp_sendb(3)
								Exit
							EndIf
						Next
					EndIf
				EndIf
				;Send - Server
				If e_player=e_server Then
					For player.player = Each player
						If (player\id<>id) And (player\id<>e_server) Then
							WriteByte(udp),10
							WriteByte(udp),id
							WriteByte(udp),e_sv_rsession
							SendUDPMsg(udp, player\ip, player\port)
							udp_sendb(3)
						EndIf
					Next
				EndIf

				Return 1	
			EndIf
			
			;---Bombe
			If aw=55 Then
				If player\action=2 Then Return 0
				player_action(player\id,2,1,1)
				Return 1
			EndIf
			
			;Action Cancel
			player\action=0
			
			;Munition weg
			player\sammoin[player\slot]=player\sammoin[player\slot]-1
			
			;Autoreload
			If player\sammoin[player\slot]=0 Then
				player_reload(player\id,1,1)
			EndIf
			
			;Damage ermitteln
			Local pldam
			Select player\weaponmode
				Case 0 pldam=weapon_damage(player\sweapon[player\slot])/3
				Case 1 pldam=weapon_damage_z1(player\sweapon[player\slot])/3
				Case 2 pldam=weapon_damage_z2(player\sweapon[player\slot])/3
				Default pldam=weapon_damage(player\sweapon[player\slot])/3
			End Select
			Local svch_weapon=player\sweapon[player\slot]
			Local svch_weaponmode=player\weaponmode
			
			;Schuss bis zu Kollision oder Ende der Waffenreichweite bewegen
			For maxdis=0 To weapon_range(aw)
				;Bewegen
				sx#=sx#+xo#
				sy#=sy#+yo#
				
				stx=Int((sx#-16)/32)
				sty=Int((sy#-16)/32)
				
				;Flugbahnpartikel
				If aw<45 Or aw>49 Then
					;Default
					If Rand(2)<>1 Then
						par2d.par2d=New par2d
						par2d\col=$FFFF00
						par2d\age=ms+Rand(50,200)
						par2d\x=sx#
						par2d\y=sy#
						par2d\fx=Rand(-2,2)
						par2d\fy=Rand(-2,2)
					EndIf
				Else
					;Laser
					If aw=45 Then 
						par2d.par2d=New par2d
						par2d\col=$00FF00
						par2d\age=ms+Rand(50,200)
						par2d\x=sx#
						par2d\y=sy#
						par2d\fx=Rand(-1,1)
						par2d\fy=Rand(-1,1)
						If Rand(2)<>1 Then
							h=e_add_sprite_fire(sx,sy,Rand(5,10),Rnd(0.4,0.7))
							EntityColor h,0,255,0
						EndIf
					;Flamethrower
					ElseIf aw=46 Then
						If Rand(2)<>1 Then
							If maxdis<15 Then
								h=e_add_sprite_fire(sx,sy,Rand(6,20),Rnd(0.3,0.5)+flamerdown#)
								If maxdis<10 Then
									EntityColor h,50,50,255
								Else
									If Rand(5)=1 Then EntityColor h,50,50,255
								EndIf
							ElseIf maxdis<20 Then
								e_add_sprite_fire(sx,sy,Rand(12,30),Rnd(0.3,0.5)+flamerdown#)
							Else
								e_add_sprite_fire(sx,sy,Rand(16,40),Rnd(0.3,0.5)+flamerdown#)
							EndIf	
						EndIf
						flamerdown#=flamerdown#+0.02
					EndIf
				EndIf
				
				;Bei Maprand abbrechen
				If stx<0 Then Exit
				If sty<0 Then Exit
				If stx>map_xsize Then Exit
				If sty>map_ysize Then Exit
				
				
				;Bei Wnden abbrechen + Partikel
				If map(stx,sty,3)=1 Or map(stx,sty,3)=3 Then
					
					;Funken Partikel
					For i=0 To Rand(1,5)
						par2d.par2d=New par2d
						par2d\col=$FFFF00
						par2d\age=ms+Rand(100,300)
						par2d\x=sx
						par2d\y=sy
						par2d\fx=Rand(-7,7)
						par2d\fy=Rand(-7,7)
					Next
					
					;Einschusslicht / Sound
					If aw<>46 Then
						If Rand(4)=1 Then
							e_add_sprite_muzzleflash(sx-32,sy-32,Rand(50,80),Rand(360))
							e_sound(sfx_ric(Rand(0,4)),sx,sy,1,200)
						EndIf
						If aw=45 Then
							h=e_add_sprite_fire(sx,sy,Rand(30,50),Rnd(0.8,2))
							EntityColor h,0,255,0
						EndIf
					EndIf
					
					;Einschussrauch
					If op_smoke Then
						If Rand(2)=1 Then
							e_add_sprite_smokepuff(sx,sy,Rand(4,10),Rnd(0.3,0.5))
						EndIf
					EndIf
					
					;Breakable?
					If map(stx,sty,1)=25 Then
						e_hurt_breakable(stx,sty,pldam)
					Else
					
						;Normale, solide Wand?
						If map(stx,sty,3)=1
						
							;Einschussloch
							e_add_par2d($1F1F1F,Rand(10000,30000),sx,sy,0,0)
						
							;Blut an Wand
							If blood>0 Then
								If Rand(3)=1 Then
									Select e_tilearea(stx,sty,sx,sy)
										Case 2 e_add_decal(stx*32,sty*32,gfx_decals,8,Rnd(0.7,1),Rand(200,255),0,0,5000,180)
										Case 4 e_add_decal(stx*32,sty*32,gfx_decals,8,Rnd(0.7,1),Rand(200,255),0,0,5000,-90)
										Case 6 e_add_decal(stx*32,sty*32,gfx_decals,8,Rnd(0.7,1),Rand(200,255),0,0,5000,90)
										Case 8 e_add_decal(stx*32,sty*32,gfx_decals,8,Rnd(0.7,1),Rand(200,255),0,0,5000,0)
									End Select
								EndIf
							EndIf
							
						EndIf
					EndIf
					
					
					;Schusslinie
					;e_add_sprite_line(startx,starty,sx,sy,255,0,0,0.5)
					
					
					Exit
				EndIf
				
				;Breakable?
				If map(stx,sty,3)>0 And map(stx,sty,3)<4 Then
					If map(stx,sty,1)=25 Then e_hurt_breakable(stx,sty,pldam)
				EndIf
				
				;Blood verringern
				blood=blood-1
				
				;Kollision mit Spielern testen
				hurtany=0
				For player2.player = Each player
					If player2\id <> id Then
						If player2\health>0 Then
							If RectsOverlap(sx,sy,2,2,player2\x,player2\y,32,32)Then 
								hurtany=1
								If hurtblock=-1 Then
								
									hurtblock=player2\id
								
									If Rand(5)=1 Then
										e_add_sprite_fragment(Rand(8,15),Rand(100,255),0,0,player2\x,player2\y,Rand(-10,10),Rand(-10,10),Rand(-10,10))
									EndIf
									
									For i=0 To 2
										x=Rand(0,8)
										e_add_par2d($D20000,Rand(1000,5000),player2\x+16+(xo*x),player2\y+16+(yo*x),Rand(-6,6),Rand(-6,6))
									Next
									
									If damage=1 Then
										player_hurt(player2\id, player\id, pldam, player\sweapon[player\slot],1)
									EndIf
								
									blood=26
									playerdamaged=playerdamaged+1
									damagedid[playerdamaged]=player2\id
									
								EndIf
							EndIf
						EndIf
					EndIf
				Next
				
				;Kollision mit Hostages testen
				For hostage.hostage=Each hostage
					If hostage\health>0 Then
						If RectsOverlap(sx,sy,2,2,hostage\x,hostage\y,32,32)Then
							hurtany=1
							If hurtblock=-1 Then
								
								hurtblock=-2
								
								For i=0 To 2
									e_add_sprite_fragment(Rand(8,15),Rand(100,255),0,0,hostage\x,hostage\y,Rand(-10,10),Rand(-10,10),Rand(-10,10))
								Next
										
								For i=0 To 5
									x=Rand(0,8)
									e_add_par2d($D20000,Rand(1000,5000),hostage\x+16+(xo*x),hostage\y+16+(yo*x),Rand(-6,6),Rand(-6,6))
								Next
								
								If player\id=e_player Or player\bot=1 Then
									game_hostage_hurt(hostage\id, player\id, pldam, player\sweapon[player\slot],1)
								EndIf
														
								blood=26
								
							EndIf
						EndIf
					EndIf
				Next
				If Not hurtany Then hurtblock=-1
				
			Next
			
			;Muzzleflash
			If aw<45 Then
				xo=Sin(pldir)*23
				yo=-Cos(pldir)*23
				e_add_sprite_muzzleflash(player\x-16+xo,player\y-16+yo,Rand(50,70),pldir,player\h)
			EndIf
			
			;Muzzlesmoke
			If op_smoke Then
				e_add_sprite_smokepuff(player\x+16+xo,player\y+16+yo,Rand(3,10),Rnd(0.2,0.3))
				If (aw>=10 And aw<20) Or aw=45 Then
					For i=0 To Rand(3,8)
						e_add_sprite_smokepuff(player\x+16+xo+Rand(-2,2),player\y+16+yo+Rand(-2,2),Rand(3,10),Rnd(0.3,0.5))
					Next
				EndIf
			EndIf
			
			;Patronenhlse
			par2d.par2d=New par2d
			par2d\col=-1323756
			par2d\age=ms+1500
			par2d\x=plx+Sin(pldir)*13
			par2d\y=ply+-Cos(pldir)*13
			par2d\fx=Rand(-6,6)
			par2d\fy=Rand(-6,6)
			
		Else
			
			;Leergerusch
			e_sound(sfx_w_emtpy,player\x,player\y)
			player\shoottimer=ms+300
			
			;BOT
			If player\bot=1 Then
				;Bot - Ammo leer
				If player\reload=0 Then
					If player_reload(player\id,1,1)=0 Then
						player_bestweapon(id)
						If player\sammoin[player\slot]=0 Then
							player_reload(player\id,1,1)
						EndIf
						;Messer? -> Zum Gegner!
						If player\sweapon[player\slot]=50 Then
							player\bot_obj[0]=11
							player\bot_obj[1]=player\bot_enemy_id
						EndIf
					EndIf
				EndIf	
			EndIf
			
			Return 0
		EndIf
	Else
		Return 0
	EndIf
	
	;Send - Client
	If send Then
		If e_player<>e_server Then
			For player.player = Each player
				If player\id = e_server Then
					;Schuss mit Schaden
					If playerdamaged>0 Then
						udp_iniimp(player\ip,player\port,2)
						udp_w_byte(13)
						udp_w_byte(playerdamaged)
						For i=1 To playerdamaged
							udp_w_byte(damagedid[i])
						Next
						udp_w_byte(svch_weapon)
						udp_w_byte(svch_weaponmode)
						udp_w_byte(e_sv_rsession)
						udp_sendimp()
						udp_sendb(7+playerdamaged)
					;Ohne Schaden
					Else
						;Bei schnellen Schssen einfache bertragung
						If weapon_freq(aw)<20 Then
							WriteByte(udp),10
							WriteByte(udp),id
							WriteByte(udp),e_sv_rsession
							SendUDPMsg(udp, player\ip, player\port)
							udp_sendb(3)
						;Bei langsamen Schssen gesicherte bertragung
						Else
							udp_iniimp(player\ip,player\port)
							udp_w_byte(12)
							udp_w_byte(e_sv_rsession)			
							udp_sendimp()
							udp_sendb(4)
						EndIf
					EndIf
					Exit
				EndIf
			Next
		EndIf
	EndIf
	;Send - Server
	If e_player=e_server Then
		For player.player = Each player
			If (player\id<>id) And (player\id<>e_server) Then
				;Nur an Spieler in der Nhe senden
				If (Abs(player\x-sendx)<(udp_sx+100) And Abs(player\y-sendy)<(udp_sy+100)) Then
					;Bei schnellen Schssen einfache bertragung
					If weapon_freq(aw)<20 Then
						WriteByte(udp),10
						WriteByte(udp),id
						WriteByte(udp),e_sv_rsession
						SendUDPMsg(udp, player\ip, player\port)
						udp_sendb(3)
					;Bei langsamen Schssen gesicherte bertragung
					Else
						udp_iniimp(player\ip,player\port)
						udp_w_byte(12)
						udp_w_byte(e_sv_rsession)			
						udp_sendimp()
						udp_sendb(4)
					EndIf
				EndIf
			EndIf
		Next
	EndIf
	
End Function


;--------------------Player Attack 2
Function player_attack2(id, mode=-1, send=1)
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If player\health<=0 Then Return 0
	
	If mode=-1 Then
		If player\weaponmode=0 Then
			If weapon_damage_z1(player\sweapon[player\slot])>0 Then
				player\weaponmode=1
			Else
				If player\id=e_player Then
					hud_m_add("This Weapon has no Secondary Fire!",1000)
				EndIf
				Return 0
			EndIf
		ElseIf player\weaponmode=1 Then
			If weapon_damage_z2(player\sweapon[player\slot])>0 Then
				player\weaponmode=2
			Else
				player\weaponmode=0
			EndIf
		ElseIf player\weaponmode=2 Then
			player\weaponmode=0
		EndIf
	Else
		player\weaponmode=mode
	EndIf
	
	;Zoom Mode
	If player\shoottimer<=ms Then
		player\shoottimer=ms+500
	Else
		player\shoottimer=player\shoottimer+500
	EndIf
	
	;Senden
	If send Then
		For player2.player=Each player
			If player2\id=e_server Then
				udp_iniimp(player2\ip,player2\port)
				udp_w_byte(11)
				udp_w_byte(player\id)
				udp_w_byte(player\weaponmode)
				udp_sendimp()
				udp_sendb(5)
				Exit
			EndIf
		Next
	EndIf
End Function


;--------------------Player Attack Servercheck (Serverseitige Kontrolle, ob Schaden mglich ist)
Function player_attack_servercheck(id,damagecount,weapon,weaponmode)
	If e_player<>e_server Then Return 0
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If player\h=0 Then Return 0
	If player\health<1 Then Return 0
		
	;Damage ermitteln
	Local pldam
	Select weaponmode
		Case 0 pldam=weapon_damage(weapon)/3
		Case 1 pldam=weapon_damage_z1(weapon)/3
		Case 2 pldam=weapon_damage_z2(weapon)/3
		Default pldam=weapon_damage(weapon)/3
	End Select
	
	
	;Cachen
	plx=player\x+16
	ply=player\y+16
	pldir=player\dir
	sx#=player\x+16
	sy#=player\y+16
	xo#=Sin(pldir)*64
	yo#=-Cos(pldir)*64
	range=weapon_range(weapon)
	Dim	udp_damage_d(50)

	chk=Rnd(100,999)
	
	
	
	;Prfschleife
	Local k=0
	For maxdis=0 To range Step 16
		;Bewegen
		sx#=sx#+xo#
		sy#=sy#+yo#
		
		;Verwunden?
		For i=1 To damagecount
			If udp_damage(i)<>-1 Then
				For pl2.player=Each player
					If pl2\id=udp_damage(i) Then
						
						If RectsOverlap(sx-32,sy-32,64,64,pl2\x,pl2\y,32,32) Then
							
							If udp_damage_d(pl2\id)=0 Then
							
								player_hurt(pl2\id, player\id, pldam, weapon,1)
								udp_damage_d(pl2\id)=1
								
							EndIf
							
						EndIf
						Exit
					EndIf
				Next
			EndIf
		Next
		
	Next
End Function


;--------------------Player Hurt
Function player_hurt(id, hurter, power, weapon, send=1, armor=-1)
	Local ph=0
	If hurter<>-1 Then
		For player.player=Each player
			If player\id=hurter Then ph=1:Exit
		Next
		If Not ph Then Return 0
		If player\health<=0 Then Return 0
		hurter_team=player\team
	EndIf
	ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	
	
	;HURT HUD
	If id=e_player Then
		If hurter>-1 Then
			e_add_hurt(hurter)
		EndIf
	EndIf
	
	;---FX
	
	;Blood
	If Rand(3)=1 Then
		e_add_sprite_fragment(Rand(8,15),Rand(100,255),0,0,player\x,player\y,Rand(-10,10),Rand(-10,10),Rand(-10,10))
	EndIf
	For i=0 To Rand(2,6)
		e_add_par2d($D20000,Rand(500,8000),player\x+16,player\y+16,Rand(-7,7),Rand(-7,7))
	Next
	;More Blood?!
	If op_blood>0 Then
		For i=1 To (op_blood*2)
			e_add_sprite_fragment(Rand(8,15),Rand(100,255),0,0,player\x,player\y,Rand(-10,10),Rand(-10,10),Rand(-10,10))
		Next
		For i=1 To (op_blood*20)
			e_add_par2d($D20000,Rand(200,3000),player\x+16,player\y+16,Rand(-12,12),Rand(-12,12))
		Next
	EndIf
	
	;Hitsound						
	e_sound(sfx_hit(Rand(0,2)), player\x+16,player\y+16,0.8,100)
	
	;---Game
	

	;SERVER - Schaden
	If e_player=e_server Then
		;Friendly Fire Cancel
		If e_sv_ff=0 Then
			If hurter_team=player\team Then Return 0
		EndIf
		;Energie/Kevlar abziehen
		If player\armor>0 Then
			player\armor=player\armor-power
			If player\armor<0 Then player\armor=0
			power=(power*0.65)
		EndIf
		If player\armor<150 Then player\health=player\health-power
		;Bot
		If player\bot Then
			player\bot_enemy_lasthit=ms
		EndIf
		;Kill
		If player\health<1 Then
			If e_player=e_server Then
				player_kill(id, hurter, weapon, 1)
			EndIf
		EndIf
	;CLIENT - Setzen
	Else
		;Energie setzen (nur wenn nicht gesendet sondern empfangen wird)
		If send=0 Then
			player\health=power
			If armor<>-1 Then player\armor=armor
		EndIf
	EndIf
	
	;Senden (nur als Server)
	If e_player=e_server Then
		If send Then
			sendx=player\x
			sendy=player\y
			For player2.player=Each player
				If player2\id <> e_player Then
					;Schaden mit Effekt an Spieler in der Nhe senden
					If (Abs(player2\x-sendx)<udp_sx And Abs(player2\y-sendy)<udp_sy) Then
						WriteByte(udp),40
						WriteByte(udp),id
						WriteByte(udp),hurter
						WriteByte(udp),player\health
						WriteByte(udp),weapon
						WriteByte(udp),player\armor
						WriteByte(udp),e_sv_rsession
						SendUDPMsg(udp, player2\ip, player2\port)
						udp_sendb(7)
					;Health/Armor an entfernte Spieler senden
					Else
						WriteByte(udp),42
						WriteByte(udp),id
						WriteByte(udp),player\health
						WriteByte(udp),player\armor
						WriteByte(udp),e_sv_ression
						SendUDPMsg(udp, player2\ip, player2\port)
						udp_sendb(5)
					EndIf
				EndIf
			Next
		EndIf
	EndIf
End Function





;--------------------Player Reload (Action 1)
Function player_reload(id,mode,send=1)
	Local ph=0,aweap
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	aweap=player\sweapon[player\slot]
	
	;Send
	If send Then
		;Reload start
		If mode=1 Then
			If player\action<>0 Then Return 0
			If player\sammoin[player\slot]>=weapon_ammoin(aweap) Then Return 0
			If player\sammo[player\slot]=0 Then Return 0
			e_sound(sfx_w_clipout,player\x,player\y)
			player\action=1
			player\actionstart=ms
			player\actiontotal=ms+(weapon_reload(aweap)*7)
			player\weaponmode=0
		;Reload end
		Else
			While player\sammo[player\slot]>0
				If player\sammoin[player\slot]<weapon_ammoin(aweap)
					player\sammo[player\slot]=player\sammo[player\slot]-1
					player\sammoin[player\slot]=player\sammoin[player\slot]+1
				Else
					Exit
				EndIf
			Wend
			e_sound(sfx_w_clipin,player\x,player\y)
			player\action=0
		EndIf
	;Get (only sound)
	Else
		;Reload start
		If mode=1 Then
			e_sound(sfx_w_clipout,player\x,player\y)	
		;Reload end
		Else
			e_sound(sfx_w_clipin,player\x,player\y)
		EndIf
	EndIf
	
	;Send - Client
	If send Then
		If e_player<>e_server Then
			For player.player = Each player
				If player\id = e_server Then
					udp_iniimp(player\ip,player\port)
					udp_w_byte(33)
					udp_w_byte(id)
					udp_w_byte(1)
					udp_w_byte(mode)				
					udp_w_byte(e_sv_rsession)
					udp_sendimp()
					udp_sendb(7)
					Exit
				EndIf
			Next
		EndIf
	EndIf
	;Send - Server
	If e_player=e_server Then
		For player.player = Each player
			If (player\id<>id) And (player\id<>e_server) Then
				udp_iniimp(player\ip,player\port)
				udp_w_byte(33)
				udp_w_byte(id)
				udp_w_byte(1)
				udp_w_byte(mode)				
				udp_w_byte(e_sv_rsession)
				udp_sendimp()
				udp_sendb(7)
			EndIf
		Next
	EndIf
	
	Return 1
End Function

;--------------------Player Action
Function player_action(id,action,mode=0,send=1)
	Local ph=0,aweap
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	Local performreturn=-1
	
	;Send
	If send Then
		;Action
		Select action
			;1 - Reload
			;2 - Plant
			Case 2
				;Start Plant
				If mode=1 Then
					If player\tile_entity<>5 Then
						If id=e_player Then hud_m_add("You must plant the bomb at a bomb site")
						Return 0
					EndIf
					player\action=2
					player\actionstart=ms
					player\actiontotal=ms+3000
					performreturn=1
				;End Plant
				Else
					If player\tile_entity<>5 Then Return 0
					player\action=0
					player\sweapon[7]=0
					player_bestweapon(id)
					If player\id=e_player Then op_bind_attack=2
				EndIf
			;3 - Defuse
			Case 3
				;Start Defuse
				If mode=1 Then
					If player\sweapon[8]=56 Then
						player\action=3
						player\actionstart=ms
						player\actiontotal=ms+3000
					Else
						player\action=3
						player\actionstart=ms
						player\actiontotal=ms+6000
					EndIf
					performreturn=1
				;End Defuse
				Else
					player\action=0
				EndIf
			;4 - Use Hostage
			Case 4
				;No Preparation	
		End Select
	EndIf
	
	;Send - Client
	If send Then
		If e_player<>e_server Then
			For player2.player = Each player
				If player2\id = e_server Then
					udp_iniimp(player2\ip,player2\port)
					udp_w_byte(33)
					udp_w_byte(id)
					udp_w_byte(action)
					udp_w_byte(mode)				
					udp_w_byte(e_sv_rsession)
					udp_sendimp()
					udp_sendb(7)
					Exit
				EndIf
			Next
		EndIf
	EndIf
	;Send - Server
	If e_player=e_server Then
		For player2.player = Each player
			If (player2\id<>id) And (player2\id<>e_server) Then
				udp_iniimp(player2\ip,player2\port)
				udp_w_byte(33)
				udp_w_byte(id)
				udp_w_byte(action)
				udp_w_byte(mode)				
				udp_w_byte(e_sv_rsession)
				udp_sendimp()
				udp_sendb(7)
			EndIf
		Next
	EndIf
	
	;Perform Return
	If performreturn<>-1 Then
		Return performreturn
	EndIf
	
	
	;Perform Action
	Select action
		;1 - Reload
		;2 - Plant
		Case 2
			;End Plant
			If mode=0 Then
				hud_m_add("Bomb has been planted")
				e_play(sfx_r_bombpl)
				player\sweapon[7]=0
				player_ini(id)
				e_setup_item(100,(Int(player\x)+16)/32,(Int(player\y)+16)/32,0,0)
				e_sv_bombtimer=ms+35*1000
				e_sv_bombblink=ms+2000
			EndIf
		;3 - Defuse
		Case 3
			;Start Defuse
			If mode=1 Then
				e_sound(sfx_w_c4_disarm, player\x,player\y)
			;End Defuse
			Else
				If e_player=e_server Then
					game_roundend(5)
				EndIf
			EndIf
		;4 - Follow
		Case 4
			For hostage.hostage=Each hostage
				If hostage\id=mode Then
					;Follow start
					If hostage\followid=-1 Then
						hostage\followid=player\id
						If Not hostage\used Then
							player_money(player\id,150)
							If e_player=e_server Then
								For player2.player=Each player
									If player2\team=2 Then
										player2\sv_givemoney=player2\sv_givemoney+100
									EndIf
								Next
							EndIf
							hostage\used=1
						EndIf
						e_sound(sfx_hostage(Rand(0,4)),hostage\x,hostage\y)
					;Follow end / change
					Else
						If hostage\followid=player\id Then
							hostage\followid=-1
						Else
							hostage\followid=player\id
						EndIf
					EndIf
					Exit
				EndIf
			Next
	End Select
End Function

;--------------------Player Use
Function player_use(id)
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If player\health<1 Then Return -1
		
	If player\action<>0 Then Return 0
	
	;Defuse
	If player\team=2 Then
		For item.item=Each item
			If item\typ=100 Then
				If item\x=(Int(player\x)+16)/32 Then
					If item\y=(Int(player\y)+16)/32 Then
						player_action(id,3,1)
					EndIf
				EndIf
			EndIf
		Next
	EndIf
	
	;Rescue
	If player\team=2 Then
		If player\id=e_player And op_bind_usehit=0 Then Return 0
		For hostage.hostage=Each hostage
			If hostage\health>0 Then
				If Abs(hostage\x-player\x)<20 Then
					If Abs(hostage\y-player\y)<20 Then
						player_action(id,4,hostage\id)
						Exit
					EndIf
				EndIf
			EndIf
		Next
	EndIf
	
End Function

;--------------------Player bewegen
Function player_move(id, diroff, speed#, walk=0, mode=0, send=1)
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If player\health<1 Then Return -1
	
	;Multimove bei Relative Movement verhindern
	If player\id=e_player Then
		If mode Then
			If udp_ch_move>0 Then
				Return 0
			EndIf
		EndIf
	EndIf
	
	;Action Canceln
	If player\action=2 Then player\action=0	;Cancel Plant
	If player\action=3 Then player\action=0	;Cancel Defuse
	
	;Speed
	speed#=speed#+weapon_speed#(player\sweapon[player\slot])
	
	;LOCALS
	Local i,j
	Local dir							;Direction
	Local mx#,my#						;Move X/Y
	
	Local px[4]							;Player X
	Local py[4]							;Player Y
	Local tx[4]							;Tile X
	Local ty[4]							;Tile Y
	
	Local gox
	Local goy
	
	Local sc1,sc2
	
	Local tm
	
	;Movement Mode
	If mode Then 
		;Relative
		dir=player\dir+diroff Mod 360
	Else
		;Absolute
		dir=diroff Mod 360
	EndIf
	
	If send Then
		If walk And sphalf=0 Then Return 0
	EndIf
	
	mx#=Sin(dir)*1.
	my#=-Cos(dir)*1.
		
	For j=1 To Int(speed#)
		gox=0
		goy=0
		
		;[1]   [2]
		;   [0]
		;[3]   [4]
		
		;[0]
		px[0]=player\x+mx+16
		py[0]=player\y+my+16
		;[1]
		px[1]=player\x+mx+2
		py[1]=player\y+my+2
		;[2]
		px[2]=px[1]+28
		py[2]=py[1]+2
		;[3]
		px[3]=px[1]+2
		py[3]=py[1]+28
		;[4]
		px[4]=px[1]+28
		py[4]=py[1]+28
		
		;Tiles
		For i=0 To 4
			tx[i]=px[i]/32
			ty[i]=py[i]/32
		Next
		
		;X
		If mx<0 Then sc1=1: sc2=3
		If mx>0 Then sc1=2: sc2=4
		If mx<>0 Then
			If tx[sc1]>=0 Then
				If tx[sc1]<=map_xsize Then
					If ty[sc1]>=0 Then 
						If ty[sc1]<=map_ysize Then
							If map(tx[sc1],ty[sc1],3)<1 Or map(tx[sc1],ty[sc1],3)>4 Then
								If tx[sc2]>=0 Then
									If tx[sc2]<=map_xsize Then
										If ty[sc2]>=0 Then 
											If ty[sc2]<=map_ysize Then
												If map(tx[sc2],ty[sc2],3)<1 Or map(tx[sc2],ty[sc2],3)>4 Then
													gox=1
												EndIf
											EndIf
										EndIf
									EndIf
								EndIf
							EndIf
						EndIf
					EndIf
				EndIf
			EndIf
		EndIf
		
		;Y
		If my<0 Then sc1=1: sc2=2
		If my>0 Then sc1=3: sc2=4
		If my<>0 Then
			If tx[sc1]>=0 Then
				If tx[sc1]<=map_xsize Then
					If ty[sc1]>=0 Then 
						If ty[sc1]<=map_ysize Then
							If map(tx[sc1],ty[sc1],3)<1 Or map(tx[sc1],ty[sc1],3)>4 Then
								If tx[sc2]>=0 Then
									If tx[sc2]<=map_xsize Then
										If ty[sc2]>=0 Then 
											If ty[sc2]<=map_ysize Then
												If map(tx[sc2],ty[sc2],3)<1 Or map(tx[sc2],ty[sc2],3)>4 Then
													goy=1
												EndIf
											EndIf
										EndIf
									EndIf
								EndIf
							EndIf
						EndIf
					EndIf
				EndIf
			EndIf
		EndIf
	
	
		;Bewegen
		If gox Then player\x=player\x+mx
		If goy Then player\y=player\y+my
		
		;Physicals
		If player\id=e_player Or player\bot=1 Then
			For physical.physical=Each physical
				If RectsOverlap(Int(player\x),Int(player\y),32,32,Int(physical\x)-8,Int(physical\y)-8,16,16) Then
					physical\fx#=physical\fx#+mx
					physical\fy#=physical\fy#+my
				EndIf
			Next
		EndIf
		
		;Scan
		If gox Or goy
			scan_tx=tx[0]
			scan_ty=ty[0]
			If scan_tx>=0 Then
				If scan_ty>=0 Then
					If scan_tx<=map_xsize Then
						If scan_ty<=map_ysize Then
						
							scan_tm=map(scan_tx,scan_ty,3)
											
							;Sounds
							If scan_tm>=10 And scan_tm<50 Then
								If Not walk
									If ms-player\step_timer>300 Then
										player\step_timer=ms
										Select scan_tm
											Case 10 e_sound(sfx_dirt(Rand(0,3)),player\x,player\y)
											Case 11 e_sound(sfx_snow(Rand(0,3)),player\x,player\y)
													e_add_decal(player\x,player\y,gfx_decals,9+Rand(0,3),1,0,0,0,1000,player\dir)
											Case 12 e_sound(sfx_step(Rand(0,3)),player\x,player\y)
											Case 13 e_sound(sfx_tile(Rand(0,3)),player\x,player\y)
											Case 14 e_sound(sfx_wade(Rand(0,3)),player\x,player\y)
													e_add_sprite_wave(player\x+16+Rand(-6,6),player\y+16+Rand(-6,6),Rnd(5,10),Rnd(0.4,0.8))
											Case 15 e_sound(sfx_metal(Rand(0,3)),player\x,player\y)
										End Select
									EndIf
								EndIf
							
							;Dead
							ElseIf scan_tm>=50 And scan_tm<60
								If e_player=e_server Or player\bot=1 Then
									Select scan_tm
										Case 50 player_kill(id, 200, 0, 1)
										Case 51 player_kill(id, 200, 1, 1)
										Case 52 player_kill(id, 200, 2, 1)
										Case 53 player_kill(id, 200, 3, 1)
									End Select
								EndIf
							EndIf
							
						EndIf
					EndIf
				EndIf
			EndIf
		EndIf
	
	Next
	
	PositionEntity player\h,((player\x)*2)-640+32,-((player\y)*2)+480-32,640
	
	;Tile scannen
	If player\tile_x<>(Int(player\x)+16)/32 Or player\tile_y<>(Int(player\y)+16)/32 Then
		player\tile_x=(Int(player\x)+16)/32
		player\tile_y=(Int(player\y)+16)/32
		player\tile_mode=0
		player\tile_entity=-1
		If player\tile_x>=0 Then
			If player\tile_y>=0 Then
				If player\tile_x<=map_xsize Then
					If player\tile_y<=map_ysize Then
						player\tile_mode=map(player\tile_x,player\tile_y,3)
						player\tile_entity=map(player\tile_x,player\tile_y,1)
						If player\id=e_player Or player\bot=1 Then
							;Item sammeln
							For item.item=Each item
								If item\x=(Int(player\x)+16)/32 Then
									If item\y=(Int(player\y)+16)/32 Then
										player_collect(player\id,item\typ,item\x,item\y,1)
									EndIf
								EndIf
							Next
							;Entity Action
							For entity.entity=Each entity
								If entity\x=(Int(player\x)+16)/32 Then
									If entity\y=(Int(player\y)+16)/32 Then
										Select entity\typ
											;func_teleport
											Case 70
												player_pos(player\id, entity\value_int[0]*32,entity\value_int[1]*32, send=1)
												For hostage.hostage=Each hostage
													If hostage\followid=player\id Then
														game_hostage_data(hostage\id,entity\value_int[0]*32+Rand(-5,5),entity\value_int[1]*32+Rand(-5,5),hostage\dir,0)
														game_hostage_data(hostage\id,entity\value_int[0]*32+Rand(-5,5),entity\value_int[1]*32+Rand(-5,5),hostage\dir,1)
													EndIf
												Next
										End Select
										Exit
									EndIf
								EndIf
							Next
						EndIf
					EndIf
				EndIf
			EndIf
		EndIf
	EndIf
	
	;VIP
	If e_player=e_server
		If player\vip=1 Then
			If player\tile_entity=6 Then
				game_roundend(2)
			EndIf
		EndIf
	EndIf
	
	;Beine
	player\legs_lastmove=ms
	player\legs_mlx=mx
	player\legs_mly=my
	If walk=0 Then
		player\legs_lastspeed=50
	Else
		player\legs_lastspeed=95
	EndIf
	
	;UDP
	player\udp_walk=walk
	
	;Senden
	If send Then
		If player\id=e_player Then
			udp_ch_move=udp_ch_move+1
		EndIf
	EndIf
	
	Return 1
	
End Function


;--------------------Player Move Relativ
Function player_move_rel(id, xdif,ydif, walk)
	Local ph=0
	If xdif>10 Then Return 0
	If xdif<-10 Then Return 0
	If ydif>10 Then Return 0
	If ydif<-10 Then Return 0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If Not player\h Then Return 0
	
	player\x=player\x+xdif
	player\y=player\y+ydif
	
	PositionEntity player\h,((player\x)*2)-640+32,-((player\y)*2)+480-32,640
	
	;Action Canceln
	If player\action=2 Then player\action=0	;Cancel Plant
	If player\action=3 Then player\action=0	;Cancel Defuse
	
	;Physicals
	If player\id=e_player Or player\bot=1 Then
		For physical.physical=Each physical
			If RectsOverlap(Int(player\x),Int(player\y),32,32,Int(physical\x)-8,Int(physical\y)-8,16,16) Then
				physical\fx#=physical\fx#+mx
				physical\fy#=physical\fy#+my
			EndIf
		Next
	EndIf
	
	;Scan
	scan_tx=(Int(player\x)+16)/32
	scan_ty=(Int(player\y)+16)/32
	If scan_tx>=0 Then
		If scan_ty>=0 Then
			If scan_tx<=map_xsize Then
				If scan_ty<=map_ysize Then
					
					scan_tm=map(scan_tx,scan_ty,3)
					
					;Sounds
					If scan_tm>=10 And scan_tm<50 Then
						If Not walk
							If ms-player\step_timer>300 Then
								player\step_timer=ms
								Select scan_tm
									Case 10 e_sound(sfx_dirt(Rand(0,3)),player\x,player\y)
									Case 11 e_sound(sfx_snow(Rand(0,3)),player\x,player\y)
											e_add_decal(player\x,player\y,gfx_decals,9+Rand(0,3),1,0,0,0,1000,player\dir)
									Case 12 e_sound(sfx_step(Rand(0,3)),player\x,player\y)
									Case 13 e_sound(sfx_tile(Rand(0,3)),player\x,player\y)
									Case 14 e_sound(sfx_wade(Rand(0,3)),player\x,player\y)
											e_add_sprite_wave(player\x+16+Rand(-6,6),player\y+16+Rand(-6,6),Rnd(5,10),Rnd(0.4,0.8))
									Case 15 e_sound(sfx_metal(Rand(0,3)),player\x,player\y)
								End Select
							EndIf
						EndIf
					
					;Dead
					ElseIf scan_tm>=50 And scan_tm<60
						If e_player=e_server Or player\bot=1 Then
							Select scan_tm
								Case 50 player_kill(id, 200, 0, 1)
								Case 51 player_kill(id, 200, 1, 1)
								Case 52 player_kill(id, 200, 2, 1)
								Case 53 player_kill(id, 200, 3, 1)
							End Select
						EndIf
					EndIf
									
				EndIf
			EndIf
		EndIf
	EndIf
	
	;Tile scannen
	If player\tile_x<>(player\x+16)/32 Or player\tile_y<>(player\y+16)/32 Then
		player\tile_x=(player\x+16)/32
		player\tile_y=(player\y+16)/32
		player\tile_mode=0
		player\tile_entity=-1
		If player\tile_x>=0 Then
			If player\tile_y>=0 Then
				If player\tile_x<=map_xsize Then
					If player\tile_y<=map_ysize Then
						player\tile_mode=map(player\tile_x,player\tile_y,3)
						player\tile_entity=map(player\tile_x,player\tile_y,1)
						;Item sammeln
						If player\id=e_player Or player\bot=1 Then
							For item.item=Each item
								If item\x=(player\x+16)/32 Then
									If item\y=(player\y+16)/32 Then
										player_collect(player\id,item\typ,item\x,item\y,1)
									EndIf
								EndIf
							Next
						EndIf
					EndIf
				EndIf
			EndIf
		EndIf
	EndIf
	
	;VIP
	If e_player=e_server
		If player\vip=1 Then
			If player\tile_entity=6 Then
				game_roundend(2)
			EndIf
		EndIf
	EndIf
	
	;Beine
	player\legs_lastmove=ms
	player\legs_mlx=xdif
	player\legs_mly=ydif
	If walk=0 Then
		player\legs_lastspeed=50
	Else
		player\legs_lastspeed=95
	EndIf
	
	;UDP
	player\udp_walk=walk
End Function


;--------------------Player Position
Function player_pos(id, lx,ly, send=1)
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If Not player\h Then Return 0
	
	If send<>2 Then
		player\x=lx
		player\y=ly
		player\udp_mlx=lx
		player\udp_mly=ly
		player\udp_move=0
		PositionEntity player\h,((lx)*2)-640+32,-((ly)*2)+480-32,640
		
		
		;Health? (um aufsammeln und unntiges Scannen im Spec Mode zu verhindern)
		If player\health>0 Then
			If player\forcedeath=0 Then
				;Tile scannen
				If player\tile_x<>(Int(player\x)+16)/32 Or player\tile_y<>(Int(player\y)+16)/32 Then
					player\tile_x=(Int(player\x)+16)/32
					player\tile_y=(Int(player\y)+16)/32
					player\tile_mode=0
					player\tile_entity=-1
					If player\tile_x>=0 Then
						If player\tile_y>=0 Then
							If player\tile_x<=map_xsize Then
								If player\tile_y<=map_ysize Then
									player\tile_mode=map(player\tile_x,player\tile_y,3)
									player\tile_entity=map(player\tile_x,player\tile_y,1)
									;Items aufsammeln, wenn Player man selbst oder Bot ist
									If player\id=e_player Or player\bot=1 Then
										For item.item=Each item
											If item\x=(Int(player\x)+16)/32 Then
												If item\y=(Int(player\y)+16)/32 Then
													player_collect(player\id,item\typ,item\x,item\y,1)
												EndIf
											EndIf
										Next
									EndIf
								EndIf
							EndIf
						EndIf
					EndIf
				EndIf	
			EndIf
		EndIf
	Else
		lx=player\x
		ly=player\y
	EndIf
	
	
	;Send - Client
	If send<>0 Then
		If e_player<>e_server Then
			For player.player = Each player
				If player\id = e_server Then
					WriteByte(udp),15
					WriteByte(udp),id
					WriteInt(udp),lx
					WriteInt(udp),ly
					WriteByte(udp),e_sv_rsession
					SendUDPMsg(udp, player\ip, player\port)
					udp_sendb(11)
					Exit
				EndIf
			Next
		EndIf
	EndIf
	;Send - Server
	If e_player=e_server Then
		For player.player = Each player
			If (player\id<>id) And (player\id<>e_server) Then
				WriteByte(udp),15
				WriteByte(udp),id
				WriteInt(udp),lx
				WriteInt(udp),ly
				WriteByte(udp),e_sv_rsession
				SendUDPMsg(udp, player\ip, player\port)
				udp_sendb(11)
			EndIf
		Next
	EndIf
End Function


;--------------------Player Waffe
Function player_weapon(id, slot, weapon, send=1)
	Local ph=0,msg$
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If Not player\h Then Return 0
	If weapon=0 Then Return 0
	
	;Cachen fr Last weapon used
	If id=e_player Then
		If slot<>player\slot Then
			e_lastusedslot=player\slot
		EndIf
	EndIf
	
	;Setzen
	player\slot=slot
	player\sweapon[slot]=weapon
	EntityTexture player\weapon_h, gfx_weapons, weapon_frame(player\sweapon[slot])
	player_turn(id,player\dir,0)
	
	;Zoom bei Waffen ohne Zoom deaktivieren
	If player\weaponmode>0 Then
		If player\weaponmode=1 And weapon_damage_z1(player\sweapon[slot])=0 Then player\weaponmode=0
		If player\weaponmode=2 And weapon_damage_z2(player\sweapon[slot])=0 Then player\weaponmode=0
	EndIf
	
	;Senden
	If send Then	
		For player.player=Each player
			If player\id <> id Then
				udp_iniimp(player\ip,player\port)
				udp_w_byte(30)
				udp_w_byte(id)
				udp_w_byte(slot)
				udp_w_byte(weapon)				
				udp_sendimp()
				udp_sendb(6)
			EndIf
		Next
	EndIf
	
	Return 1
End Function


;--------------------Player beste Waffe whlen
Function player_bestweapon(id, send=1)
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If Not player\h Then Return 0
	
	;Bot und spezieller Weaponmode?
	If player\bot=1 And op_bot_mode<>1 Then
		Select op_bot_mode
			;2 - Knifes only
			Case 2
				slot=2
			;3 - Pistols only
			Case 3
				slot=2
				If player\sweapon[1]<>0 And (player\sammo[1]+player\sammoin[1])>0 Then slot=1
			;4 - Shotguns only
			Case 4
				slot=2
				If player\sweapon[1]<>0 And (player\sammo[1]+player\sammoin[1])>0 Then slot=1
				If player\sweapon[0]>=10 And player\sweapon[0]<=11 Then
					If (player\sammo[0]+player\sammoin[0])>0 Then slot=0
				EndIf
			;5 - SMGs only
			Case 5
				slot=2
				If player\sweapon[1]<>0 And (player\sammo[1]+player\sammoin[1])>0 Then slot=1
				If player\sweapon[0]>=20 And player\sweapon[0]<=24 Then
					If (player\sammo[0]+player\sammoin[0])>0 Then slot=0
				EndIf
			;6 - Rifles only
			Case 6
				slot=2
				If player\sweapon[1]<>0 And (player\sammo[1]+player\sammoin[1])>0 Then slot=1
				If player\sweapon[0]>=30 And player\sweapon[0]<=33 Then
					If (player\sammo[0]+player\sammoin[0])>0 Then slot=0
				EndIf
			;7 - Sniper-Rifles only
			Case 7
				slot=2
				If player\sweapon[1]<>0 And (player\sammo[1]+player\sammoin[1])>0 Then slot=1
				If player\sweapon[0]>=34 And player\sweapon[0]<=73 Then
					If (player\sammo[0]+player\sammoin[0])>0 Then slot=0
				EndIf
			;8 - MGs only
			Case 8	
				slot=2
				If player\sweapon[1]<>0 And (player\sammo[1]+player\sammoin[1])>0 Then slot=1
				If player\sweapon[0]>=40 And player\sweapon[0]<=40 Then
					If (player\sammo[0]+player\sammoin[0])>0 Then slot=0
				EndIf
		End Select
	Else
	;Normal
		If player\sweapon[2]<>0 Then slot=2												;Knife
		If player\sweapon[6]<>0 Then slot=6												;Flare Grenade
		If player\sweapon[5]<>0 Then slot=5												;Smoke Grenade
		If player\sweapon[4]<>0 Then slot=4												;Flashbang
		If player\sweapon[3]<>0 Then slot=3												;HE Grenade
		If player\sweapon[1]<>0 And (player\sammo[1]+player\sammoin[1])>0 Then slot=1	;Secondary Weapon
		If player\sweapon[0]<>0 And (player\sammo[0]+player\sammoin[0])>0 Then slot=0	;Primary Weapon
	EndIf
	
	;Whlen!
	player_weapon(id,slot,player\sweapon[slot],send)
	
End Function


;--------------------Player Buy
Function player_buy(id, item, send=1)
	If e_player=id Then hud_men_set(0)
	Local ph=0,cantbuy
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If Not player\h Then Return 0
	If player\health<=0 Then Return 0
	If player\team<1 Or player\team>2 Then Return 0
	If send=1 Then
		If (player\tile_entity+1)<>player\team Then
			If id=e_player Then
				hud_m_add("You must be in a buy zone!")
			EndIf
			Return 0
		EndIf
		If (player\vip)=1 Then
			If id=e_player Then
				hud_m_add("You are the VIP - You can't buy anything!")
			EndIf
			Return 0
		EndIf
	EndIf
	
	;SEND - Buy+Sound
	If send Then
		If player\money>=weapon_price(item) Then
			;Primary Ammo
			If item=61 Then
				If player\sweapon[0]=0 Then Return 0
				If player\sammo[0]<weapon_ammo(player\sweapon[0]) Then
					If player\money>=30 Then
						e_sound(sfx_i_ammo,player\x,player\y)
						player\sammo[0]=player\sammo[0]+weapon_ammoin(player\sweapon[0])
						If player\sammo[0]>weapon_ammo(player\sweapon[0]) Then player\sammo[0]=weapon_ammo(player\sweapon[0])
						If player\sammoin[0]=0 Then
							player_reload(id,1,1)
						EndIf
					Else
						If id=e_player Then
							hud_m_add("You have insufficient funds!")
						EndIf
						Return 0
					EndIf
				Else
					Return 0
				EndIf
			;Secondary Ammo
			ElseIf item=62 Then
				If player\sweapon[1]=0 Then Return 0
				If player\sammo[1]<weapon_ammo(player\sweapon[1]) Then
					If player\money>=15 Then	
						e_sound(sfx_i_ammo,player\x,player\y)
						player\sammo[1]=player\sammo[1]+weapon_ammoin(player\sweapon[1])
						If player\sammo[1]>weapon_ammo(player\sweapon[1]) Then player\sammo[1]=weapon_ammo(player\sweapon[1])
						If player\sammoin[1]=0 Then
							player_reload(id,1,1)
						EndIf
					Else
						If id=e_player Then
							hud_m_add("Insufficient funds!")
						EndIf
						Return 0
					EndIf
				Else
					Return 0
				EndIf
			;Primary Ammo - FULL
			ElseIf item=63 Then
				If player\sweapon[0]=0 Then Return 0
				boughtam=0
				While player\sammo[0]<weapon_ammo(player\sweapon[0])
					If player\money>=30 Then
						player\sammo[0]=player\sammo[0]+weapon_ammoin(player\sweapon[0])
						If player\sammo[0]>weapon_ammo(player\sweapon[0]) Then player\sammo[0]=weapon_ammo(player\sweapon[0])
						boughtam=boughtam+1
					Else
						Exit
					EndIf
				Wend
				If boughtam Then
					e_sound(sfx_i_ammo,player\x,player\y)
					If player\sammoin[0]=0 Then
						player_reload(id,1,1)
					EndIf
				EndIf
			;Secondary Ammo - FUll
			ElseIf item=64
				If player\sweapon[1]=0 Then Return 0
				boughtam=0
				While player\sammo[1]<weapon_ammo(player\sweapon[1])
					If player\money>=15 Then
						player\sammo[1]=player\sammo[1]+weapon_ammoin(player\sweapon[1])
						If player\sammo[1]>weapon_ammo(player\sweapon[1]) Then player\sammo[1]=weapon_ammo(player\sweapon[1])
						boughtam=boughtam+1
					Else
						Exit
					EndIf
				Wend
				If boughtam Then
					e_sound(sfx_i_ammo,player\x,player\y)
					If player\sammoin[1]=0 Then
						player_reload(id,1,1)
					EndIf
				EndIf
			;Pistole
			ElseIf item>0 And item<10 Then
				;Drop
				If player\sweapon[1]<>0 Then player_drop(player\id,1,player\sweapon[1],player\sammo[1],player\sammoin[1],(Int(player\x)+16)/32,(Int(player\y)+16)/32,1)
				;Buy
				player_weapon(id,1,item)
				player\sammoin[1]=weapon_ammoin(item)
				player\sammo[1]=0
				e_sound(sfx_i_pickup,player\x,player\y)
			;Waffe
			ElseIf item>9 And item<50 Then
				;T cant buy
				If player\team=1 Then
					cantbuy=0
					If item=21 Then cantbuy=1	;TMP
					If item=32 Then cantbuy=1	;M4A1
					If item=33 Then cantbuy=1	;Aug
					If cantbuy=1 Then
						If id=e_player Then
							hud_m_add("This weapon is not available to you!")
						EndIf
						Return 0
					EndIf
				;CT cant buy
				Else
					cantbuy=0
					If item=23 Then cantbuy=1	;Mac10
					If item=30 Then cantbuy=1	;AK-47
					If item=31 Then cantbuy=1	;SG552
				EndIf
				If cantbuy=1 Then
					If id=e_player Then
						hud_m_add("This weapon is not available to you!")
					EndIf
					Return 0
				EndIf
				;Drop
				If player\sweapon[0]<>0 Then player_drop(player\id,0,player\sweapon[0],player\sammo[0],player\sammoin[0],(Int(player\x)+16)/32,(Int(player\y)+16)/32,1)
				;Buy
				player_weapon(id,0,item)
				player\sammoin[0]=weapon_ammoin(item)
				player\sammo[0]=0
				e_sound(sfx_i_pickup,player\x,player\y)
			;HE Grenade
			ElseIf item=51 Then
				If player\sweapon[3]<>0 Then
					If id=e_player Then
						hud_m_add("You already have a HE grenade!")
					EndIf
					Return 0
				Else
					player_weapon(id,3,item)
					player\sammoin[3]=1
					e_sound(sfx_i_pickup,player\x,player\y)
				EndIf
			
			;Smoke Grenade
			ElseIf item=53 Then
				If player\sweapon[5]<>0 Then
					If id=e_player Then
						hud_m_add("You already have a Smoke grenade!")
					EndIf
					Return 0
				Else
					player_weapon(id,5,item)
					player\sammoin[5]=1
					e_sound(sfx_i_pickup,player\x,player\y)
				EndIf
			
			;Flare Grenade
			ElseIf item=54 Then
				If player\sweapon[6]<>0 Then
					If id=e_player Then
						hud_m_add("You already have a Flare grenade!")
					EndIf
					Return 0
				Else
					player_weapon(id,6,item)
					player\sammoin[6]=1
					e_sound(sfx_i_pickup,player\x,player\y)
				EndIf
			
			;Flashbang
			ElseIf item=52 Then
				If player\sweapon[4]<>0 Then
					If player\sammoin[4]=1 Then
						player_weapon(id,4,item)
						player\sammoin[4]=2
						e_sound(sfx_i_pickup,player\x,player\y)
					Else
						If id=e_player Then
							hud_m_add("You already have 2 flashbangs!")
						EndIf
						Return 0
					EndIf
				Else
					player_weapon(id,4,item)
					player\sammoin[4]=1
					e_sound(sfx_i_pickup,player\x,player\y)
				EndIf
			
			;Defuse
			ElseIf item=56 Then
				If player\sweapon[8]<>0 Then
					If id=e_player Then
						hud_m_add("You already have a defusekit!")
					EndIf
					Return 0
				ElseIf player\team=1 Or map_gametype<>3 Then
					If id=e_player Then
						hud_m_add("You cannot buy this item!")
					EndIf
					Return 0
				Else
					player\sweapon[8]=item
					ShowEntity player\equipment_h
					EntityTexture player\equipment_h, gfx_equipment, 1
				EndIf
				
			;Kevlar
			ElseIf item=57
				If player\armor<60 Then
					player\armor=60
					e_sound(sfx_i_kevlar,player\x,player\y)
				Else
					If id=e_player Then
						hud_m_add("You already have kevlar!")
					EndIf
					Return 0
				EndIf
			
			;Kevlar + Helm
			ElseIf item=58
				If player\armor<100 Then
					player\armor=100
					e_sound(sfx_i_kevlar,player\x,player\y)
				Else
					If id=e_player Then
						hud_m_add("You already have kevlar and a helmet!")
					EndIf
					Return 0
				EndIf
			
			;Nightvision
			ElseIf item=59
				If player\sweapon[9]<>0 Then
					If id=e_player Then
						hud_m_add("You already have a nightvision!")
					EndIf
					Return 0
				Else
					player\sweapon[9]=item
				EndIf
			EndIf
			
			
			;Geld abziehen
			If id=e_player Or player\bot=1 Then
				If boughtam>0 Then
					If item=63 Then player_money(id,-(boughtam*30))
					If item=64 Then player_money(id,-(boughtam*15))
					player_money(id,-weapon_price(item))
				Else
					player_money(id,-weapon_price(item))
				EndIf
			EndIf
			
			;Senden
			For player.player = Each player
				If player\id<>e_player Then
					udp_iniimp(player\ip,player\port)
					udp_w_byte(32)
					udp_w_byte(id)
					udp_w_byte(item)
					udp_sendimp()
					udp_sendb(5)
				EndIf
			Next
			Return 1
		Else
			If id=e_player Then
				hud_m_add("Insufficient funds!")
				Return 0
			EndIf
		EndIf
	;GET - Sound only
	Else
		;Waffen
		If item>0 And item<50 Then
			e_sound(sfx_i_pickup,player\x,player\y,1)
		;Ammo
		ElseIf item>60 And item<65 Then
			e_sound(sfx_i_ammo,player\x,player\y,1)
		;Grenades
		ElseIf item>50 And item<55 Then
			e_sound(sfx_i_pickup,player\x,player\y,1)
		;Kevlar (+Helm)
		ElseIf item=57 Or item=58 Then
			e_sound(sfx_i_kevlar,player\x,player\y,1)
			If item=57 Then
				player\armor=60
			Else
				player\armor=100
			EndIf
		;Nightvision
		ElseIf item=59 Then
			e_sound(sfx_i_pickup,player\x,player\y,1)
		;Defuse
		ElseIf item=56 Then
			e_sound(sfx_i_pickup,player\x,player\y,1)
			ShowEntity player\equipment_h
			EntityTexture player\equipment_h, gfx_equipment, 1
		EndIf
	EndIf
End Function



;--------------------Player Spray
Function player_spray(id,x=0,y=0,logo$=0,col=0,send=1)
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If Not player\h Then Return 0
	If player\health<1 Then Return 0
	If id=e_player Then
		If player\spray-ms>0 Then Return 0
	EndIf
	
	If send Then
		x=player\x
		y=player\y
		logo$=op_logo$+".bmp"
		col=op_logocol
	EndIf
	
	Local sprayok=0
	For spray.spray=Each spray
		If spray\file$=logo$ Then sprayok=1:Exit
	Next
	If Not sprayok Then
		For spray.spray=Each spray
			If spray\file$="x.bmp" Then Exit
		Next
	EndIf
	
	Local r,g,b
	Select col
		Case 0 r=255:g=182:b=24
		Case 1 r=0:g=60:b=255
		Case 2 r=0:g=166:b=255
		Case 3 r=0:g=166:b=0
		Case 4 r=255:g=73:b=0
		Case 5 r=123:g=73:b=0
		Case 6 r=99:g=101:b=99
		Case 7 r=33:g=36:b=33
	End Select
	
	e_add_decal(x,y,spray\h,0,0.7,r,g,b,30000)	
	e_sound(sfx_spray,x,y,0.8)
	player\spray=ms+20*1000
	
	;Send - Client
	If send Then
		If e_player<>e_server Then
			For player.player = Each player
				If player\id = e_server Then
					udp_iniimp(player\ip,player\port)
					udp_w_byte(90)
					udp_w_byte(id)
					udp_w_int(x)
					udp_w_int(y)
					udp_w_line(logo$)
					udp_w_byte(col)
					udp_sendimp()
					udp_sendb(23)
					Exit
				EndIf
			Next
		EndIf
	EndIf
	;Send - Server
	If e_player=e_server Then
		For player.player = Each player
			If (player\id<>id) And (player\id<>e_server) Then
				udp_iniimp(player\ip,player\port)
				udp_w_byte(90)
				udp_w_byte(id)
				udp_w_int(x)
				udp_w_int(y)
				udp_w_line(logo$)
				udp_w_byte(col)
				udp_sendimp()
				udp_sendb(23)
			EndIf
		Next
	EndIf
	
End Function


;--------------------Player Radio
Function player_radio(id,radio,send=1)
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If Not player\h Then Return 0
	If player\health<1 Then Return 0
	If player\team<1 Or player\team>2 Then Return 0
	If id=e_player Then
		hud_men_set(0)
		If player\radio-ms>0 Then Return 0
	EndIf
	player\radio=ms+3000
	
	;Radio Output
	For player3.player=Each player
		If player3\id=e_player Then
			If player3\health>0 Then
				If player3\team=player\team Then
					If radio<>21 Then
						e_play(radio_sfx(radio))
						hud_ml_add(player\name$+"(Radio): ",player\team,radio_text$(radio),1)
					Else
						If Rand(0,1)=1 Then
							e_play(sfx_r_roger)
							hud_ml_add(player\name$+"(Radio): ",player\team,"Roger that.",1)
						Else
							e_play(sfx_r_affirm)
							hud_ml_add(player\name$+"(Radio): ",player\team,"Affirmative.",1)
						EndIf
					EndIf
				EndIf
			EndIf
			Exit
		EndIf
	Next
	
	;Send - Client
	If send Then
		If e_player<>e_server Then
			For player2.player = Each player
				If player2\id = e_server Then
					udp_iniimp(player2\ip,player2\port)
					udp_w_byte(92)
					udp_w_byte(id)
					udp_w_byte(radio)
					udp_sendimp()
					udp_sendb(5)
					Exit
				EndIf
			Next
		EndIf
	EndIf
	;Send - Server (nur an Clients die leben und im gleichen Team sind)
	If e_player=e_server Then
		For player2.player = Each player
			If (player2\id<>id) And (player2\id<>e_server) Then
				If player2\team=player\team
					If player2\health>0 Then
						udp_iniimp(player2\ip,player2\port)
						udp_w_byte(92)
						udp_w_byte(id)
						udp_w_byte(radio)
						udp_sendimp()
						udp_sendb(5)
					EndIf
				EndIf
			EndIf
		Next
	EndIf
	
End Function

;--------------------Player Say
Function player_say(id,txt$,send=1)
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	
	If Trim(txt$)="" Then Return 0
	
	;Dead Stat
	Local dead
	If player\health>0 Then
		dead=0 
	Else
		dead=1
	EndIf
	If player\team<1 Or player\team>2 Then dead=1
	
	;Cancel Get
	Local getdead
	If send=0 Then
		For player2.player=Each player
			If player2\id=e_player Then
				If player2\health>0 Then
					getdead=0 
				Else
					getdead=1
				EndIf
				If player2\team<1 Or player2\team>2 Then getdead=1
				If dead<>getdead Then Return 0
				Exit
			EndIf
		Next
	EndIf
	
	;Color
	Local teamcol
	Select player\team
		Case 1 teamcol=1
		Case 2 teamcol=2
		Default teamcol=3
	End Select
	
	;Ausgabe
	If dead Then
		hud_ml_add(player\name$+"*DEAD*: ",teamcol,txt$,1)
	Else
		hud_ml_add(player\name$+": ",teamcol,txt$,1)
	EndIf
	
	;Send - Client
	If send Then
		If e_player<>e_server Then
			For player2.player = Each player
				If player2\id = e_server Then
					udp_iniimp(player2\ip,player2\port)
					udp_w_byte(91)
					udp_w_byte(1)
					udp_w_byte(id)
					udp_w_line(txt$)							
					udp_sendimp()
					udp_sendb(15)
					Exit
				EndIf
			Next
		EndIf
	EndIf
	;Send - Server (nur an Leute mit gleichem dead-stat)
	If e_player=e_server Then
		For player2.player = Each player
			If (player2\id<>id) And (player2\id<>e_server) Then
				If player2\health>0 Then
					getdead=0 
				Else
					getdead=1
				EndIf
				If player2\team<1 Or player2\team>2 Then getdead=1
				If dead=getdead Then
					udp_iniimp(player2\ip,player2\port)
					udp_w_byte(91)
					udp_w_byte(1)
					udp_w_byte(id)
					udp_w_line(txt$)							
					udp_sendimp()
					udp_sendb(15)
				EndIf
			EndIf
		Next
	EndIf
	
End Function


;--------------------Player Say Team
Function player_sayteam(id,txt$,send=1)
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	
	If Trim(txt$)="" Then Return 0
	
	;Dead Stat
	Local dead
	If player\health>0 Then
		dead=0 
	Else
		dead=1
	EndIf
	If player\team<1 Or player\team>2 Then dead=1
	
	;Color
	Local teamcol
	Select player\team
		Case 1 teamcol=1
		Case 2 teamcol=2
		Default teamcol=3
	End Select
	
	;Cancel Get
	Local getdead
	Local getteamcol
	If send=0 Then
		For player2.player=Each player
			If player2\id=e_player Then
				If player2\health>0 Then
					getdead=0 
				Else
					getdead=1
				EndIf
				If player2\team<1 Or player2\team>2 Then getdead=1
				If dead<>getdead Then Return 0
				Select player2\team
					Case 1 getteamcol=1
					Case 2 getteamcol=2
					Default getteamcol=3
				End Select
				If teamcol<>getteamcol Then Return 0
				Exit
			EndIf
		Next
	EndIf
	
	;Ausgabe
	If dead Then
		hud_ml_add(player\name$+"*DEAD*(Team): ",teamcol,txt$,1)
	Else
		hud_ml_add(player\name$+"(Team): ",teamcol,txt$,1)
	EndIf
	
	;Send - Client
	If send Then
		If e_player<>e_server Then
			For player2.player = Each player
				If player2\id = e_server Then
					udp_iniimp(player2\ip,player2\port)
					udp_w_byte(91)
					udp_w_byte(2)
					udp_w_byte(e_player)
					udp_w_line(txt$)							
					udp_sendimp()
					udp_sendb(15)
					Exit
				EndIf
			Next
		EndIf
	EndIf
	;Send - Server (nur an Leute mit gleichem dead-stat und Team)
	If e_player=e_server Then
		For player2.player = Each player
			If (player2\id<>id) And (player2\id<>e_server) Then
				If player2\health>0 Then
					getdead=0 
				Else
					getdead=1
				EndIf
				If player2\team<1 Or player2\team>2 Then getdead=1
				Select player2\team
					Case 1 getteamcol=1
					Case 2 getteamcol=2
					Default getteamcol=3
				End Select
				If dead=getdead And teamcol=getteamcol Then
					udp_iniimp(player2\ip,player2\port)
					udp_w_byte(91)
					udp_w_byte(2)
					udp_w_byte(e_player)
					udp_w_line(txt$)							
					udp_sendimp()
					udp_sendb(15)
				EndIf
			EndIf
		Next
	EndIf
	
End Function


;--------------------Player Gren
Function player_gren(id,grenid,x,y,dir,typ,send=1)
	Local ph=0
	Local free=0
	Local gotid=-1
	Local i=0
	
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If ms-player\g_last<=500 Then player\g_last=ms:Return 0
	player\g_last=ms
	
	;Free ID
	If grenid=-1 Then	
		While gotid=-1
			free=1
			For grenade.grenade=Each grenade
				If grenade\id=i Then
					If grenade\owner=id Then
						free=0
						Exit
					EndIf
				EndIf
			Next
			If free=1 Then
				gotid=i
				Exit
			EndIf
			i=i+1
			If (i=255 And free=0) Or ( i>255 ) Then
				con_add("Error: Grenade overflow!",0,1)
				Return 0
			EndIf
		Wend
	Else
		gotid=grenid
	EndIf
	
	;Create Gren
	grenade.grenade=New grenade
	grenade\id=gotid
	grenade\typ=typ
	grenade\owner=id
	grenade\dir=dir Mod 360
	grenade\fx#=Sin(dir)
	grenade\fy#=-Cos(dir)
	grenade\x#=x+(grenade\fx#*15)
	grenade\y#=y+(grenade\fy#*15)
	grenade\fly=50
	
	grenade\h=CreateSprite()
	ScaleSprite grenade\h,32,32
	EntityTexture grenade\h,gfx_weapons,weapon_frame(typ)
	RotateSprite grenade\h,-dir
	EntityOrder grenade\h,-6
	PositionEntity grenade\h,((grenade\x)*2)-640+32,-((grenade\y)*2)+480-32,640
	
	;Send - Client
	If send Then
		If e_player<>e_server Then
			For player.player = Each player
				If player\id = e_server Then
					udp_iniimp(player\ip,player\port)
					udp_w_byte(50)
					udp_w_byte(id)
					udp_w_byte(grenade\id)
					udp_w_int(x)
					udp_w_int(y)
					udp_w_int(dir)
					udp_w_byte(typ)
					udp_sendimp()
					udp_sendb(16)
					Exit
				EndIf
			Next
		EndIf
		player_radio(id,33,1)
	EndIf
	;Send - Server
	If e_player=e_server Then
		For player.player = Each player
			If (player\id<>id) And (player\id<>e_server) Then
				udp_iniimp(player\ip,player\port)
				udp_w_byte(50)
				udp_w_byte(id)
				udp_w_byte(grenade\id)
				udp_w_int(x)
				udp_w_int(y)
				udp_w_int(dir)
				udp_w_byte(typ)
				udp_sendimp()
				udp_sendb(16)
			EndIf
		Next
	EndIf
		
End Function

;--------------------Player Drop
Function player_drop(id,slot,typ,ammo,ammoin,x,y,send=1)
	If typ=0 Then Return 0
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If Not player\h Then Return 0
	
	If id=e_player Then
		Local dropable=1
		If slot=2 Then dropable=0
		If slot>=3 And slot <=6 Then dropable=0
		If Not dropable Then
			hud_m_add("This weapon can't be dropped!",3000)
			Return 0
		EndIf
	EndIf
	
	player\sweapon[slot]=0
	player\sammo[slot]=0
	player\sammoin[slot]=0
	
	player\action=0
	
	;Droppen auf tdliche Tiles verhindern
	If x>=0 And x<=map_xsize And y>=0 And y<=map_ysize Then
		If map(x,y,3)>=50 And map(x,y,3)<=60 Then Return 0
	Else
		Return 0
	EndIf
	
	e_setup_item(typ,x,y,ammo,ammoin)
	
	If typ=55 Then hud_m_add(player\name+" dropped the bomb",3000):player_ini(player\id,0)
	If typ=56 Then player_ini(player\id,0)
	
	e_sound(sfx_i_drop,player\x,player\y)
	
	;Send - Client
	If send Then
		If e_player<>e_server Then
			For player.player = Each player
				If player\id = e_server Then
					udp_iniimp(player\ip,player\port)
					udp_w_byte(31)
					udp_w_byte(id)
					udp_w_byte(slot)
					udp_w_byte(typ)
					udp_w_int(ammo)
					udp_w_int(ammoin)
					udp_w_int(x)
					udp_w_int(y)				
					udp_sendimp()
					udp_sendb(22)
					Exit
				EndIf
			Next
		EndIf
	EndIf
	;Send - Server
	If e_player=e_server Then
		For player.player = Each player
			If (player\id<>id) And (player\id<>e_server) Then
				udp_iniimp(player\ip,player\port)
				udp_w_byte(31)
				udp_w_byte(id)
				udp_w_byte(slot)
				udp_w_byte(typ)
				udp_w_int(ammo)
				udp_w_int(ammoin)
				udp_w_int(x)
				udp_w_int(y)				
				udp_sendimp()
				udp_sendb(22)
			EndIf
		Next
	EndIf
	
	Return 1
End Function

;--------------------Player Collect
Function player_collect(id,typ,x,y,send=1)
	If typ=0 Then Return 0
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If Not player\h Then Return 0
	
	
	;Item suchen
	Local fitem=0
	For item.item=Each item
		If item\x=x Then
			If item\y=y Then
				If item\typ=typ Then
					fitem=1
					Exit
				EndIf
			EndIf
		EndIf
	Next
	If Not fitem Then Return 0
	
	
	;Als Server nehmen
	If (e_player=e_server Or send=2) Or e_bot=1 Then
	
		;Item nehmen
		;Primary Weapon
		If typ>=1 And typ<10 Then
			If player\vip Then Return 0
			If send=1 And player\sweapon[1]<>0 Then Return 0
			player\sweapon[1]=typ
			player\sammo[1]=item\ammo
			player\sammoin[1]=item\ammoin
			e_sound(sfx_i_pickup,player\x,player\y)
		;Secondary Weapon
		ElseIf typ>=10 And typ<=49 Then
			If player\vip Then Return 0
			If send=1 And player\sweapon[0]<>0 Then Return 0
			player\sweapon[0]=typ
			player\sammo[0]=item\ammo
			player\sammoin[0]=item\ammoin
			e_sound(sfx_i_pickup,player\x,player\y)
		;Grenade
		ElseIf typ>=51 And typ<=54 Then
			If player\vip Then Return 0
			Select typ
				;51 - HE
				Case 51
					If player\sweapon[3]=0 Then
						player\sweapon[3]=typ
						player\sammoin[3]=1
						e_sound(sfx_i_pickup,player\x,player\y)
					Else 
						Return 0
					EndIf
				;52 - Flash
				Case 52
					If player\sweapon[4]=0 Or player\sammoin[4]<2 Then
						player\sweapon[4]=typ
						player\sammoin[4]=player\sammoin[4]+1
						e_sound(sfx_i_pickup,player\x,player\y)
					Else
						Return 0
					EndIf
				;53 - Smoke
				Case 53
					If player\sweapon[5]=0 Then
						player\sweapon[5]=typ
						player\sammoin[5]=1
						e_sound(sfx_i_pickup,player\x,player\y)
					Else
						Return 0
					EndIf
				;54 - Flare
				Case 54
					If player\sweapon[6]=0 Then
						player\sweapon[6]=typ
						player\sammoin[6]=1
						e_sound(sfx_i_pickup,player\x,player\y)
					Else
						Return 0
					EndIf
			End Select
		;Items
		Else
			Select typ
				;55 - Bombe
				Case 55
					If send=1 Then
						If player\team<>1 Then Return 0
						If player\sweapon[7]<>0 Then Return 0
					EndIf
					player\sweapon[7]=55:e_sound(sfx_i_pickup,player\x,player\y)
					player_ini(player\id,0)
					If player\id=e_player Then
						hud_m_add("You picked up the bomb!",3000)
					Else
						hud_m_add(player\name$+" picked up the bomb",3000)
					EndIf
				;56 - Defuse Kit
				Case 56
					If send=1 Then
						If player\team<>2 Then Return 0
						If player\sweapon[8]<>0 Then Return 0
					EndIf
					player\sweapon[8]=56:e_sound(sfx_i_pickup,player\x,player\y)
					player_ini(player\id,0)
					If player\id=e_player Then
						hud_m_add("You picked up a defuser kit!",3000)
					EndIf
				;57 - Kevlar
				Case 57
				;58 - Kevlar + Helm
				Case 58
				;100 - Bombe
				Case 100 Return 0
			End Select
		EndIf
		
		;Beste Waffe
		If player\id=e_player Or player\bot=1 Then
			player_bestweapon(player\id,1)
		EndIf
		
		;Item lschen
		FreeEntity item\h
		Delete item
		
	EndIf
		
	
	;Senden
	If send=1 Then
		;Als Server an alle senden
		If e_player=e_server Then
			For player.player=Each player
				If player\id <> e_player Then
					udp_iniimp(player\ip,player\port)
					udp_w_byte(34)
					udp_w_byte(id)
					udp_w_byte(typ)
					udp_w_int(x)
					udp_w_int(y)									
					udp_sendimp()
					udp_sendb(13)
				EndIf
			Next
		;Als Client an den Server senden
		Else
			For player.player=Each player
				If player\id = e_server Then
					udp_iniimp(player\ip,player\port)
					udp_w_byte(34)
					udp_w_byte(id)
					udp_w_byte(typ)
					udp_w_int(x)
					udp_w_int(y)									
					udp_sendimp()
					udp_sendb(13)
					Exit
				EndIf
			Next
		EndIf
	EndIf
	
	Return 1
End Function


;--------------------Player Give Mission (VIP/BOMB)
Function player_give_mission(id,send=1)
	Local ph=0
	For player.player=Each player
		If player\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If Not player\h Then Return 0
	
	;AS
	If map_gametype=1 Then
		player\vip=1
		player\armor=200
		EntityTexture player\h, gfx_players, 8
	;DE
	ElseIf map_gametype=3 Then
		player\sweapon[7]=55
	EndIf
	
	;Senden
	If send Then
		For player.player=Each player
			If player\id<>e_player Then
				WriteByte(udp),99
				WriteByte(udp),id
				SendUDPMsg(udp,player\ip,player\port)
				udp_sendb(2)
			EndIf
		Next
	EndIf
	
	e_sv_playergiven=1
	Return 1
End Function


;--------------------Player Count
Function player_count(mode=0)
	Local count
	For player.player=Each player
		Select mode
			Case 0 count=count+1
			Case 1 If player\team=1 Then count=count+1
			Case 2 If player\team=2 Then count=count+1
			Case 3 If player\team=0 Then count=count+1
			Case 4 If player\team<>1 And player\team<>2 Then count=count+1
		End Select
	Next
	Return count
End Function

;--------------------Player Count Living
Function player_count_living(mode=0)
	Local count
	For player.player=Each player
		Select mode
			Case 0
				If player\team=1 Or player\team=2 Then
					If player\health>0 Then
						count=count+1
					EndIf
				EndIf
			Case 1
				If player\team=1 Then
					If player\health>0 Then
						count=count+1
					EndIf
				EndIf
			Case 2
				If player\team=2 Then
					If player\health>0 Then
						count=count+1
					EndIf
				EndIf
		End Select
	Next
	Return count
End Function

;--------------------Player Get ID (by IP + Port)
Function player_getid(ip,port)
	For player.player=Each player
		If player\ip=ip Then
			If player\port=port Then
				Return player\id
			EndIf
		EndIf
	Next
	Return -1
End Function