;----------------------------------------Game MISC Functions

;--------------------Grenades bewegen
Function game_gren_fly()
	Local tx,ty,inside
	Local cx[3]
	Local cy[3]
	Local ca[3]
	For grenade.grenade=Each grenade	
		If grenade\fly>0 Then
			grenade\fly=grenade\fly-1
			
			If Rand(2)=1 Then e_add_sprite_smokepuff(grenade\x#+16,grenade\y#+16,Rand(3,10),Rnd(0.2,0.4))
			
			For i=1 To 5
				grenade\x#=grenade\x#+grenade\fx#
				grenade\y#=grenade\y#+grenade\fy#
				grenade\dir=grenade\dir+5
				RotateSprite grenade\h,-grenade\dir
				PositionEntity grenade\h,((grenade\x)*2)-640+32,-((grenade\y)*2)+480-32,640
				
				;Kollision
				If grenade\coll=0 Then
					
					cx[0]=grenade\x#+10
					cy[0]=grenade\y#+10
					
					cx[1]=grenade\x#+20
					cy[1]=grenade\y#+10
					
					cx[2]=grenade\x#+10
					cy[2]=grenade\y#+20
					
					cx[3]=grenade\x#+20
					cy[3]=grenade\y#+20
					
					For j=0 To 3
						
						inside=0
						ca[j]=0
						
						tx=(cx[j])/32
						ty=(cy[j])/32
						If tx>=0 Then
							If ty>=0 Then
								If tx<=map_xsize Then
									If ty<=map_ysize Then
										inside=1
										If map(tx,ty,3)=1 Or map(tx,ty,3)=3 Then
											ca[j]=1
											grenade\coll=11
										EndIf
									EndIf
								EndIf
							EndIf
						EndIf
						If Not inside Then
							ca[j]=1
						EndIf
						
					Next
					
					;Oben
					If ca[0] Then
						e_sound(sfx_w_g_bounce,grenade\x#-16,grenade\y#-16)
						e_add_sprite_muzzleflash(grenade\x#,grenade\y#,Rand(40,70),Rand(360))
						;Oben
						If ca[1] Then
							grenade\fy#=-grenade\fy#
						;Links
						Else
							grenade\fx#=-grenade\fx#
						EndIf
					ElseIf ca[1] Then
						e_sound(sfx_w_g_bounce,grenade\x#-16,grenade\y#-16)
						e_add_sprite_muzzleflash(grenade\x#,grenade\y#,Rand(40,70),Rand(360))
						;Rechts
						If ca[3] Then
							grenade\fx#=-grenade\fx#
						;Obenrechts
						Else
							grenade\fy#=-grenade\fy#
						EndIf
					;Unten
					ElseIf ca[2] Then
						e_sound(sfx_w_g_bounce,grenade\x#-16,grenade\y#-16)
						e_add_sprite_muzzleflash(grenade\x#,grenade\y#,Rand(40,70),Rand(360))
						;Unten
						If ca[3] Then
							grenade\fy#=-grenade\fy#
						;Untenlinks
						Else
							grenade\fy#=-grenade\fy#
						EndIf
					ElseIf ca[3] Then
						e_sound(sfx_w_g_bounce,grenade\x#-16,grenade\y#-16)
						e_add_sprite_muzzleflash(grenade\x#,grenade\y#,Rand(40,70),Rand(360))
						;Untenrechts
						grenade\fx#=-grenade\fx#
					EndIf
					
					
					
				Else
					grenade\coll=grenade\coll-1
				EndIf
					
			Next
		Else
			;Explodieren lassen
			If grenade\exploded=0 Then
				If e_player=e_server Then
					game_gren_explode(grenade\id, grenade\x, grenade\y, grenade\typ, grenade\owner)
				Else
					FreeEntity grenade\h
					Delete grenade
				EndIf
			;Rauchwolken / Flares
			Else
				grenade\fly=grenade\fly-1
				Select grenade\typ
					;Rauchwolken
					Case 53
						If grenade\fly Mod 150 = 0 Then
							e_add_smoke(grenade\x+16+Rand(-10,10),grenade\y+16+Rand(-10,10),Rnd(15,40),Rnd(-0.122,0.122),Rnd(-0.122,0.122),12000,Rnd(0.95,1.3),Rand(0,360))
						EndIf
					;Flares
					Case 54
						If grenade\fly Mod 5 = 0 Then
							sprite.sprite=New sprite
							sprite\h=CreateSprite()
							EntityTexture sprite\h,gfx_muzzleflash
							ScaleSprite sprite\h,80,80
							EntityColor sprite\h,255,Rand(100,255),0
							PositionEntity sprite\h,((grenade\x+16)*2)-640,-((grenade\y+16)*2)+480,640
							EntityOrder sprite\h,order_splatter
							sprite\typ=1
							sprite\subtyp=0
							sprite\x=grenade\x+16
							sprite\y=grenade\y+16
							sprite\fx=Rand(-15,15)
							sprite\fy=Rand(-15,15)
							sprite\dir#=Rand(0,360)
							RotateSprite sprite\h,sprite\dir#
							sprite\alpha#=Rand(0.8,1.0)
							EntityAlpha sprite\h,1
							EntityBlend sprite\h,3
						EndIf
				End Select
				;Lschen
				If grenade\fly<-1200 Then
					FreeEntity grenade\h
					Delete grenade
				EndIf
			EndIf
		EndIf
	Next
End Function


;--------------------Grenade Explodieren
Function game_gren_explode(id,x,y,typ,owner,send=1)
	Local found=0
	;Lschen (HE/Flash)
	For grenade.grenade=Each grenade
		If grenade\id=id Then
			If grenade\owner=owner Then
				found=1
				If typ<53 Then
					FreeEntity grenade\h
					Delete grenade
				Else
					grenade\exploded=1
					EntityOrder grenade\h,order_item
				EndIf
				Exit
			EndIf
		EndIf
	Next
	;Anlegen falls nicht vorhanden (Smoke/Flare)
	If typ>=53 Then
		If Not found Then
			grenade.grenade=New grenade
			grenade\id=id
			grenade\x=x
			grenade\y=y
			grenade\typ=typ
			grenade\owner=owner
			grenade\exploded=1
			grenade\h=CreateSprite()
			ScaleSprite grenade\h,32,32
			EntityTexture grenade\h,gfx_weapons,weapon_frame(typ)
			RotateSprite grenade\h,Rand(-360,360)
			EntityOrder grenade\h,5
			PositionEntity grenade\h,((grenade\x)*2)-640+32,-((grenade\y)*2)+480-32,640
		EndIf
	EndIf
	Select typ
		;HE
		Case 51
			e_sound(sfx_explode(Rand(0,2)),x,y)
			e_add_decal(x,y,gfx_decals,0,Rnd(0.6,0.95),0,0,0,Rand(15000,25000),Rand(0,360))
			For wink=0 To 360 Step 15
				e_add_sprite_smokepuff(x+16+Sin(wink)*5,y+16-Cos(wink)*5,Rand(4,12),Rnd(0.4,0.6))
			Next
			e_add_explosion(x+16,y+16,Rand(110,150))
			If e_player=e_server Then game_damagewave(x+16,y+16,115,160,51,owner)
		;Flash
		Case 52
			e_sound(sfx_w_g_flash,x,y)
			e_add_decal(x,y,gfx_decals,0,Rnd(0.5,0.8),0,0,0,Rand(15000,25000),Rand(0,360))
			game_flash(x+16,y+16,e_player,150)
			sprite.sprite=New sprite
			sprite\h=CreateSprite()
			EntityTexture sprite\h,gfx_muzzleflash
			ScaleSprite sprite\h,280,280
			EntityColor sprite\h,255,255,255
			PositionEntity sprite\h,((x+16)*2)-640,-((y+16)*2)+480,640
			EntityOrder sprite\h,order_splatter
			sprite\typ=1
			sprite\subtyp=subtyp
			sprite\x=x+16
			sprite\y=y+16
			sprite\dir#=Rand(0,360)
			RotateSprite sprite\h,sprite\dir#
			sprite\alpha#=0.5
			EntityAlpha sprite\h,sprite\alpha#
			EntityBlend sprite\h,3
			e_add_sprite_smokepuff(x+16,y+16,Rand(4,12),Rnd(0.3,0.6))
		;Smoke
		Case 53
			e_sound(sfx_w_g_smoke,x,y)
			e_add_decal(x,y,gfx_decals,0,Rnd(0.4,0.7),0,0,0,Rand(15000,25000),Rand(0,360))
			e_add_smoke(x+16,y+16,40,0,0,20000,0.90,Rand(0,360))
			For wink=0 To 360 Step 10
				e_add_sprite_smokepuff(x+16+Sin(wink)*5,y+16-Cos(wink)*5,Rand(5,15),Rnd(0.4,0.6))
			Next
		;Flare
		Case 54
			e_sound(sfx_w_g_smoke,x,y)
			e_add_decal(x,y,gfx_decals,0,Rnd(0.4,0.7),0,0,0,Rand(15000,25000),Rand(0,360))
			sprite.sprite=New sprite
			sprite\h=CreateSprite()
			EntityTexture sprite\h,gfx_muzzleflash
			ScaleSprite sprite\h,280,280
			EntityColor sprite\h,255,Rand(200,255),100
			PositionEntity sprite\h,((grenade\x+16)*2)-640,-((grenade\y+16)*2)+480,640
			EntityOrder sprite\h,order_splatter
			sprite\typ=1
			sprite\subtyp=subtyp
			sprite\x=grenade\x+16
			sprite\y=grenade\y+16
			sprite\dir#=Rand(0,360)
			RotateSprite sprite\h,sprite\dir#
			sprite\alpha#=1.0
			EntityAlpha sprite\h,sprite\alpha#
			EntityBlend sprite\h,3
	End Select
	
	If send<>0 Then
		For player.player=Each player
			If player\id <> e_player Then
				udp_iniimp(player\ip,player\port)
				udp_w_byte(51)
				udp_w_byte(id)
				udp_w_int(x)
				udp_w_int(y)
				udp_w_byte(typ)
				udp_w_byte(owner)						
				udp_sendimp()
				udp_sendb(14)
			EndIf
		Next
	EndIf
End Function


;--------------------Schadenswelle (Ausgehend von explosion)
Function game_damagewave(x,y,damage,range,weapon=-1,triggerplayer=200,ignox=-666,ignoy=-666)
	Local d,cdamage,percent
	;Players
	For player.player = Each player
		If player\health>0 Then
			If player\team>0 And player\team<3 Then
				d=Sqr((x-player\x)^2+(y-player\y)^2)
				If d<range Then
					d=Abs(d-range)
					percent=(Float(d)/Float(range))*100.0
					cdamage=Float(damage)*(Float(percent)/100.0)
					player_hurt(player\id, triggerplayer, cdamage, weapon, 1)
					;con_add("Damage Wave: Near="+d+" Percent="+percent+"% Damage="+cdamage)
				EndIf
			EndIf
		EndIf
	Next
	;Hostages
	For hostage.hostage=Each hostage
		If hostage\health>0 Then
			d=Sqr((x-hostage\x)^2+(y-hostage\y)^2)
			If d<range Then
				d=Abs(d-range)
				percent=(Float(d)/Float(range))*100.0
				cdamage=Float(damage)*(Float(percent)/100.0)
				game_hostage_hurt(hostage\id, triggerplayer, cdamage, weapon,1)
			EndIf
		EndIf
	Next
	;Physicals
	For physical.physical=Each physical
		d=Sqr((x-physical\x)^2+(y-physical\y)^2)
		If d<range Then
			dir=ATan2((physical\x)-(x),(y)-(physical\y))
			d=Abs(d-range)
			percent=(Float(d)/Float(range))*100.0
			flypower#=Float(damage)*(Float(percent)/100.0)
			flypower#=flypower#/4
			physical\fx#=physical\fx#+(Sin(dir)*flypower#)
			physical\fy#=physical\fx#-(Cos(dir)*flypower#)
		EndIf
	Next
	;Breakables
	If e_player=e_server Then
		For entity.entity=Each entity
			If entity\typ=25 Then
				If entity\value_int[9]=0 Then
					If entity\x<>ignox Or entity\y<>ignoy Then ;Nicht sich selbst beschdigen..
						d=Sqr((x-(entity\x*32+16))^2+(y-(entity\y*32+16))^2)
						If d<range Then
							d=Abs(d-range)
							percent=(Float(d)/Float(range))*100.0
							cdamage=Float(damage)*(Float(percent)/100.0)
							expl.expl=New expl
							expl\x=entity\x
							expl\y=entity\y
							expl\damage=cdamage
						EndIf
					EndIf
				EndIf
			EndIf
		Next
	EndIf
End Function

;--------------------Flash
Function game_flash(x,y,id,power)
	Local dir#,sx#,sy#,xo#,yo#,stx,sty,d,newpower,selfflashed
	For player.player=Each player
		If player\id=e_player Or player\bot=1 Then
			dir#=ATan2((player\x+16)-(x),(y)-(player\y+16))
			xo#=Sin(dir#)*4
			yo#=-Cos(dir#)*4
			sx#=x
			sy#=y
			For i=0 To 125
				;Bewegen
				sx#=sx#+xo#
				sy#=sy#+yo#
				
				stx=Int((sx#-16)/32)
				sty=Int((sy#-16)/32)
							
				;Bei Maprand abbrechen
				If stx<0 Then Exit
				If sty<0 Then Exit
				If stx>map_xsize Then Exit
				If sty>map_ysize Then Exit
				
				;Bei Wnden abbrechen
				If map(stx,sty,3)=1 Then Exit
				
				;Bei Player angekommen? -> Flash!
				If RectsOverlap(sx#,sy#,2,2,player\x,player\y,32,32)Then
					If player\id=e_player And selfflashed=0 Then
						d=Sqr((x-player\x)^2+(y-player\y)^2)
						newpower=power-Float(Float(d)/3.0)
						If newpower<0 Then newpower=0
						hud_flash_a#=hud_flash_a#+Float(Float(newpower)/100.0)
						If hud_flash_a#>3.0 Then hud_flash_a#=3.0
						selfflashed=1
					ElseIf player\bot=1 Then
						player\bot_flashed=500
					EndIf
				EndIf
			Next
		EndIf
	Next
	Return 0
End Function




;--------------------Hostage Data
Function game_hostage_data(id,x=0,y=0,dir=0,send=1)
	For hostage.hostage=Each hostage
		If hostage\id=id Then
			If send Then
				For player.player=Each player
					If player\id<>e_player Then
						WriteByte(udp),60
						WriteByte(udp),id
						WriteInt(udp),hostage\x
						WriteInt(udp),hostage\y
						WriteInt(udp),hostage\dir
						WriteByte(udp),e_sv_rsession
						SendUDPMsg(udp,player\ip,player\port)
						udp_sendb(15)
					EndIf
				Next
			Else
				hostage\x=x
				hostage\y=y
				hostage\dir=dir
				RotateSprite hostage\h,-hostage\dir
				PositionEntity hostage\h,((hostage\x)*2)-640+32,-((hostage\y)*2)+480-32,640
			EndIf
			Exit
		EndIf
	Next
End Function

;--------------------Hostage Move
Function game_hostage_move(id)
	Local ph,oldx,oldy,moved
	For hostage.hostage=Each hostage
		If hostage\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	
	If hostage\followid>-1 Then
		
		;Zum Player drehen und laufen
		For player.player=Each player
			If player\id=hostage\followid Then
			
				hostage\dir=ATan2(player\x+16-(hostage\x+16),(hostage\y+16)-(player\y+16))
				RotateSprite hostage\h,-hostage\dir
				
				moved=0
				
				;Move X
				If Abs(hostage\x-player\x)>30 Then
					moved=1
					For move=1 To 7
						oldx=hostage\x
						oldy=hostage\y
						If hostage\x<player\x Then
							hostage\x=hostage\x+4
						Else
							hostage\x=hostage\x-4
						EndIf
						
						If map((hostage\x+16)/32,(hostage\y+16)/32,3)>0 And map((hostage\x+16)/32,(hostage\y+16)/32,3)<5 Then
							hostage\x=oldx
							hostage\y=oldy
							Exit
						EndIf
					Next
				EndIf
				
				;Move Y
				If Abs(hostage\y-player\y)>30 Then
					moved=1
					For move=1 To 7
						oldx=hostage\x
						oldy=hostage\y
						If hostage\y<player\y Then
							hostage\y=hostage\y+4
						Else
							hostage\y=hostage\y-4
						EndIf
						
						If map((hostage\x+16)/32,(hostage\y+16)/32,3)>0 And map((hostage\x+16)/32,(hostage\y+16)/32,3)<5 Then
							hostage\x=oldx
							hostage\y=oldy
							Exit
						EndIf
					Next
				EndIf
				
				;Rescue
				If map((hostage\x+16)/32,(hostage\y+16)/32,1)=4 Then
					game_hostage_rescue(hostage\id)
					Return 0
				;Die
				ElseIf map((hostage\x+16)/32,(hostage\y+16)/32,3)>49 And map((hostage\x+16)/32,(hostage\y+16)/32,3)<60 Then
					Select map((hostage\x+16)/32,(hostage\y+16)/32,3)
						Case 50 game_hostage_kill(hostage\id, 200, 0)
						Case 51 game_hostage_kill(hostage\id, 200, 1)
						Case 52 game_hostage_kill(hostage\id, 200, 2)
						Case 53 game_hostage_kill(hostage\id, 200, 3)
					End Select

				EndIf
				
				
				PositionEntity hostage\h,((hostage\x)*2)-640+32,-((hostage\y)*2)+480-32,640
				If moved Then game_hostage_data(hostage\id)
				
				Exit
			EndIf
		Next
	
	EndIf
End Function

;--------------------Hostage Hurt
Function game_hostage_hurt(id, hurter, power, weapon, send=1)
	Local ph=0
	If hurter<>-1 Then
		For player.player=Each player
			If player\id=hurter Then ph=1:Exit
		Next
		If Not ph Then Return 0
		If player\health<=0 Then Return 0
	EndIf
	
	ph=0
	For hostage.hostage=Each hostage
		If hostage\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	
	;Blood
	If Rand(3)=1 Then
		e_add_sprite_fragment(Rand(8,15),Rand(100,255),0,0,hostage\x,hostage\y,Rand(-10,10),Rand(-10,10),Rand(-10,10))
	EndIf
	For i=0 To Rand(2,6)
		e_add_par2d($D20000,Rand(200,1000),hostage\x+16,hostage\y+16,Rand(-7,7),Rand(-7,7))
	Next
	;More Blood?!
	If op_blood>0 Then
		For i=1 To (op_blood*3)
			e_add_sprite_fragment(Rand(8,15),Rand(100,255),0,0,hostage\x,hostage\y,Rand(-10,10),Rand(-10,10),Rand(-10,10))
		Next
		For i=1 To (op_blood*10)
			e_add_par2d($D20000,Rand(200,1000),hostage\x+16,hostage\y+16,Rand(-10,10),Rand(-10,10))
		Next
	EndIf
	
	;Hitsound						
	e_sound(sfx_hit(Rand(0,2)), hostage\x+16,hostage\y+16,0.8,100)
	
	;Energie abziehen -> killen?
	hostage\health=hostage\health-power
	If hostage\health<1 Then
		If e_player=e_server Then
			game_hostage_kill(id, hurter, weapon, 1)
		Else
			If hostage\forcedeath Then
				hostage\health=0
				HideEntity hostage\h
			Else
				hostage\health=Rand(1,20)
			EndIf
		EndIf
	EndIf
	
	;Senden
	If send Then
		For player.player=Each player
			If player\id <> e_player Then
				WriteByte(udp),61
				WriteByte(udp),id
				WriteByte(udp),hurter
				WriteByte(udp),power
				WriteByte(udp),weapon
				WriteByte(udp),e_sv_rsession
				SendUDPMsg(udp, player\ip, player\port)
				udp_sendb(6)
			EndIf
		Next
	EndIf
End Function


;--------------------Hostage Kill
Function game_hostage_kill(id, killer, killweapon=0, send=1)
	;Killer
	;0-100	= Player
	;200	= Environment

	Local ph=0
	For hostage.hostage=Each hostage
		If hostage\id=id Then ph=1:Exit
	Next
	If Not ph Then Return 0
	If hostage\forcedeath Then Return 0
	
	;Killen
	hostage\health=0
	hostage\forcedeath=1
	HideEntity hostage\h
	;0-100 / 200
	If killer<=200 Then
		If killer=200 Then
			Select killweapon
				Case 0:e_sound(sfx_die(Rand(0,2)),hostage\x,hostage\y,1,450)
				Case 1:e_sound(sfx_explode(Rand(0,2)),hostage\x,hostage\y,1,50):e_add_explosion(hostage\x,hostage\y,Rand(100,200))
				Case 2:e_sound(sfx_die_toxic,hostage\x,hostage\y,1,50)
				Case 3:e_sound(sfx_die_abyss,hostage\x,hostage\y,1,50)
				Default e_sound(sfx_die(Rand(0,2)),hostage\x,hostage\y,1,450)
			End Select
		Else
			e_sound(sfx_die(Rand(0,2)),hostage\x,hostage\y,1,450)
		EndIf
		e_add_decal(hostage\x,hostage\y,gfx_decals,Rand(1,5),Rnd(0.8,1),Rand(200,255),0,0,5000,Rand(360))
		;More Blood?!
		If op_blood>0 Then
			For i=1 To (op_blood*8)
				e_add_sprite_fragment(Rand(8,15),Rand(100,255),0,0,hostage\x,hostage\y,0,Rand(-15,15),Rand(-15,15))
			Next
			For i=1 To (op_blood*15)
				e_add_par2d($D20000,Rand(200,1000),hostage\x+16,hostage\y+16,Rand(-10,10),Rand(-10,10))
			Next
			For i=1 To (op_blood*3)
				EntityTexture e_add_sprite_fragment(0,128,128,128,hostage\x,hostage\y,0,Rand(-15,15),Rand(-15,15),1),gfx_bodyparts,Rand(0,7)
			Next
		EndIf
	EndIf

	;Nachricht
	For player2.player=Each player
		If player2\id=killer Then Exit
	Next
	If killer<=100 Then
		hud_or_add(player2\name$+" ", player2\team, weapon_name(killweapon)+" ", "Hostage", 0)
		con_add(player2\name$+" killed Hostage with "+weapon_name(killweapon),0,1)
	Else
		hud_or_add("Hostage ", 0, "died")
		con_add("Hostage died",0,1)
	EndIf
	
	;Geld abziehen
	player_money(killer,-1500)
	
	;Senden
	If send Then
		For player.player=Each player
			If player\id <> e_player Then
				udp_iniimp(player\ip,player\port)
				udp_w_byte(62)
				udp_w_byte(id)
				udp_w_byte(killer)
				udp_w_byte(killweapon)						
				udp_w_byte(e_sv_rsession)	
				udp_sendimp()
				udp_sendb(7)
			EndIf
		Next
		player_radio(killer,32,1)
	EndIf
	
End Function




;--------------------Hostage Rescue
Function game_hostage_rescue(id,send=1)
	hud_m_add("Hostage has been rescued!",3000)
	e_play(sfx_r_rescued)
	
	Local foundh=0
	For hostage.hostage=Each hostage
		If hostage\id=id Then
			foundh=1
			Exit
		EndIf
	Next
	
	;Money
	If foundh Then
		For player.player=Each player
			If player\id=hostage\followid Then
				player_money(player\id,1000)
				Exit
			EndIf
		Next
		FreeEntity hostage\h
		Delete hostage
	EndIf
	If e_player=e_server Then
		For player.player=Each player
			If player\team=2 Then
				player\sv_givemoney=player\sv_givemoney+150
			EndIf
		Next
	EndIf
	
	;Send - Client
	If send Then
		If e_player<>e_server Then
			For player.player = Each player
				If player\id = e_server Then
					udp_iniimp(player\ip,player\port)
					udp_w_byte(63)
					udp_w_byte(id)				
					udp_w_byte(e_sv_rsession)	
					udp_sendimp()
					udp_sendb(5)
					Exit
				EndIf
			Next
		EndIf
	EndIf
	;Send - Server
	If e_player=e_server Then
		For player.player = Each player
			If player\id<>e_server Then
				udp_iniimp(player\ip,player\port)
				udp_w_byte(63)
				udp_w_byte(id)				
				udp_w_byte(e_sv_rsession)	
				udp_sendimp()
				udp_sendb(5)
			EndIf
		Next
	EndIf
	
	;Round Restart? (Server only)
	If e_player=e_server Then
		Local count=0
		For hostage.hostage=Each hostage
			count=count+1
		Next
		If count=0 Then game_roundend(6)
	EndIf
	
End Function